<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard extends Admin_controller {
	
	public function __construct(){
		parent::__construct();
		siteStatus();
	}

	public function index()
	{	
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));

		$data['subordinate'] = $users;
		$goodBadLead = $this->Admin_m->getGoodOrBadLeads($users);

		$data['lead'] = [
			'leads' => $this->Admin_m->countLeads($users, 0),
			'insufficient' => $goodBadLead['insufficient'],
			'good' => $goodBadLead['good'],
			'bad' => $goodBadLead['bad'],
		];
		
		$data['project'] = [
			'projects' => $this->Admin_m->countProject(['where_in' => $users]),
			'complete_project' => $this->Admin_m->countProject(['where_in' => $users, 'status' => 0]),
			'failed_project' => $this->Admin_m->countProject(['where_in' => $users, 'status' => 1, 'deadline <' => date('Y-m-d')]),
		];
		$rr = $this->Admin_m->countTasks(['where_in' => $users, 'status' => 1, 'deadline <' => date('Y-m-d')]);
		
		$data['task'] = [
			'tasks' => $this->Admin_m->countTasks(['where_in' => $users]),
			'complete_task' => $this->Admin_m->countTasks(['where_in' => $users, 'status' => 0]),
			'failed_task' => $this->Admin_m->countTasks(['where_in' => $users, 'status' => 1, 'deadline <' => date('Y-m-d')]),
		];
		
		$data['todolist'] =  $this->Admin_m->findAll('emp_todo', array('user_id' => getUserData('user_id'),'deleted_at'=> NULL,'status'=>'1'));
		$data['settings'] = $this->Admin_m->find('system_settings', array());
		$data['class'] = 'index2';
        $data['page'] = 'dashboard';
        $data['view'] = 'admin_panel';
         
        $this->load->view('master', $data);
	}

	public function getNotificationData()
	{
		echo json_encode(getNotification());		
	}

	public function getFunnelData($value='')
	{	
		$start = date('Y-m-d',strtotime($this->input->post('from_date')));
		$end = date('Y-m-t', strtotime($start));
		$user_id = $this->input->post('user_id');
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));
		$where = ['leads.status' => 0];

		if($this->input->post('from_date')):
			$where = ['leads.created_at >=' => $start, 'leads.created_at <' => $end];
		else:
			$where = ['leads.created_at >=' => date('Y-m-01', strtotime('0 month', strtotime(date('Y-m-d')))), 'leads.created_at <=' => date('Y-m-t', strtotime('0 month', strtotime(date('Y-m-d'))))];	
		endif;	

		if($user_id){
			$where['leads.km'] = $user_id;
		} else {
			if(getUserData('is_admin') == 0):
				$where['where_in'] = ['leads.km' => $users];
			endif;
		}

		$data = $this->Admin_m->getFunnelData($where);
		echo $data;
	}

	public function getCalData($value='')
	{	
		$user_id = $this->input->post('user_id');
		$results = $this->Admin_m->getDataForCal($user_id);
		echo json_encode($results);
	}

	public function getDeliverableData()
	{
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));
		echo $this->Admin_m->deliverableDataDtl($users);
	}

}