<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Login extends Admin_controller {

	public function __construct(){
		parent::__construct();
	}

	static $rules_add = array(
        'username' => array(
                'field' => 'username', 
                'label' => 'Username', 
                'rules' => 'trim|required'
        ),
        'password' => array(
                'field' => 'password', 
                'label' => 'Password', 
                'rules' => 'trim|required'
        ),
    );

	public function index()
	{
		$data['class'] = 'authentication';
		//$data['view'] = 'login';
		$this->load->view('login', $data);
	}

	public function action()
	{
		$this->form_validation->set_rules(self::$rules_add);

		if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
			$user['username'] = $this->input->post('username');
			$user['password'] = hashdata($this->input->post('password'));

			$userInfo	= $this->Login_m->getUserData($user);
			
			if( !empty($userInfo) && $userInfo['deleted_at'] == NULL) {

				if($userInfo['status'] == 0){
					$data['hasError']	= 1;
					$data['msg']		= 'Account no active';
				} else {
					$settings = $this->Admin_m->find('system_settings', array());
					//dd($settings);
					$loginData = [
						'user_id' => $userInfo['id'], 
						'fullname' => $userInfo['fullname'], 
						'supervisor' => $userInfo['supervisor_id'],
						'user_name' => $userInfo['username'], 
						'email' => $userInfo['email'], 
						'user_type' => $userInfo['usertype_id'], 
						'is_admin' => $userInfo['is_admin'],
						'supervisor_of' => $this->Admin_m->myAssistants($userInfo['id']), 
						'theme' => $userInfo['theme'],	
						'company' => base_url(),					
						'loggedin' => 'true'
					];

					setUserData($loginData);

					$cookie= array(
						'name'   => 'remember_me',
						'value'  => session_id(),
						'expire' => '86500',
					);
					$this->input->set_cookie($cookie);

					$logData['user_id'] = $this->session->userdata('user_id');
					$logData['session_id'] = session_id();
					$logData['login_device'] = userAgent();
		        	$logData['ip_address'] = getIP();
		        	$logData['login_timestamp'] = date('Y-m-d H:m:s');

					$this->Login_m->save('user_log', $logData);
					
					saveNotificationData();

					$return['type'] = 'login_success'; 
					$return['class'] = 'success';
				   	$return['message'] = 'Login successful. Redirecting...';
					$return['url'] = base_url('dashboard'); 	
				   	echo json_encode($return);					
				}
				
			}  else  {
				$return['type'] = 'login_success'; 
				$return['class'] = 'warning';
			   	$return['message'] = 'Wrong User ID or Password !';
			   	echo json_encode($return);
			}
		}
	}

	public function logout()
	{
		$result = logoutUser();
		if($result){			
			//delete_cookie("remember_me");
		    return redirect('login');
		}
	}

	public function get_tokens() {
		echo $this->security->get_csrf_hash();
	} 
		
}