<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class System_settings extends Admin_controller {



    public function __construct(){
        parent::__construct();
        siteStatus();
    }

    static $rules_update = array(
        'site_title' => array(
            'field' => 'site_title',
            'label' => 'Site title',
            'rules' => 'trim|required'
        ),
        'email' => array(
            'field' => 'email',
            'label' => 'Email address',
            'rules' => 'trim|required'
        ),
        'company_name' => array(
            'field' => 'company_name',
            'label' => 'Company Name',
            'rules' => 'trim|required'
        ),
        'address' => array(
            'field' => 'address',
            'label' => 'Company address',
            'rules' => 'trim|required'
        ),
        'phone_fax' => array(
            'field' => 'phone_fax',
            'label' => 'Phone/Fax',
            'rules' => 'trim|required'
        ),
        'copy_right' => array(
            'field' => 'copy_right',
            'label' => 'Copyright ',
            'rules' => 'trim|required'
        ),
        'offline_text' => array(
            'field' => 'offline_text',
            'label' => 'Offline text ',
            'rules' => 'trim|required'
        ),
        'system_name' => array(
            'field' => 'system_name',
            'label' => 'System Name ',
            'rules' => 'trim|required'
        ),
        'logo' => array(
            'field' => 'logo',
            'label' => 'Logo ',
            'rules' => 'trim|required'
        ),
    );

    public function index()
    {

        $data['input'] = $this->Admin_m->find('system_settings', array());
        $data['theme'] = $this->Admin_m->find('users', array('id' => getUserData('user_id')));

        if(empty($data['input'])){
            $input                  = new stdClass();
        
            $input->site_title      = '';
            $input->logo            = '';
            $input->favicon         = '';
            $input->company_name    = '';
            $input->system_name     = '';
            $input->slogan          = '';
            $input->site_offline    = '';
            $input->offline_text    = '';
            $input->address         = '';
            $input->phone_fax       = '';
            $input->email           = '';
            $input->copy_right      = '';
           
            $data['input']          = $input;

        }

        $this->load->view('setting/system_form', $data);
           
            
     }

    public function save()
    {

        $settings = [
                    'site_title'         => $this->input->post('site_title'),
                    'logo'               => $this->input->post('logo'),
                    'company_name'       => $this->input->post('company_name'),
                    'system_name'        => $this->input->post('system_name'),
                    'site_offline'       => $this->input->post('site_offline'),
                    'address'            => $this->input->post('address'),
                    'phone_fax'          => $this->input->post('phone_fax'),
                    'email'              => $this->input->post('email'),
                    'copy_right'         => $this->input->post('copy_right'),
                    'offline_text'       => $this->input->post('offline_text'),
                    'logo'               => $this->input->post('logo'),
                    'favicon'            => $this->input->post('favicon'),
                ];
       $this->form_validation->set_rules(self::$rules_update);
         
        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {

            empty($this->Admin_m->find('system_settings', array())) ? $this->Admin_m->save('system_settings', $settings, array()) : $this->Admin_m->update('system_settings', $settings, array()); 

                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'settings updateed !!';
               // $return['url'] = base_url('dashboard'); 
                echo json_encode($return);
           }

        }

        public function getSettingData()
        {
            $data = $this->Admin_m->find('system_settings', array());
            echo json_encode($data);
        }

        public function saveTheme(){
            $this->db->trans_start();
            $id = getUserData('user_id');
            setUserData(['theme' => $this->input->post('theme')]);
            $data['theme'] = $this->input->post('theme');

            $this->Admin_m->update('users', $data, array('id' => $id));

            $this->db->trans_complete();

        }
        
}
