<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Upload extends Admin_controller {

	static $model 	 = array();
	static $helper   = array('form');
	
	public function __construct(){
		parent::__construct();
		siteStatus();
		$this->load->library('upload');
	}
	
	public function index($type = 0)
	{	
		$output = array();
		$config = array('upload_path' => './uploads');
		$fileLocation = "uploads/";
		
		$config['allowed_types'] = 'jpg|jpeg|png|pdf';
		$config['file_name'] 	 = time();
		$config['create_thumb'] = TRUE;
        $config['maintain_ratio'] = TRUE;
        $config['width'] = 250;
        $config['height'] = 250;


		$this->upload->initialize($config);

		if($this->upload->do_upload('attachment')) {
			$uploadData = $this->upload->data();
			$this->load->library('image_lib');
			//your desired config for the resize() function
		    $thumbconfig = array(
			    'source_image'      => $uploadData['full_path'], //path to the uploaded image
			    'new_image'         => realpath(APPPATH.'../uploads/thumb'), //path to
			    'maintain_ratio'    => true,
			    'width'             => 128,
			    'height'            => 128
		    );
		    //this is the magic line that enables you generate multiple thumbnails
		    //you have to call the initialize() function each time you call the resize()
		    //otherwise it will not work and only generate one thumbnail
		    $this->image_lib->initialize($thumbconfig);
		    $this->image_lib->resize();

			$output['status'] = 'success';
			$output['fileLocation'] = $fileLocation.$uploadData['file_name'];
			$output['fileName'] 	= $uploadData['file_name'];
			$output['fileExt'] 		= $uploadData['file_ext'];
		} else {
			$output['status'] 	= 'failed';
			$output['message'] 	= $this->upload->display_errors('', '');
		}

		echo json_encode($output);
	}


	public function remove($type = 0)
	{	
		$fileName = $this->input->post('attachment');

		$fileLink = './uploads/'.$fileName;
		
		unlink($fileLink);
	}


}