<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *');
/**
 * Login API
 */
class Apitest extends CI_Controller
{
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('Admin_m');
	}

	static $rules_add = array(
        'user_id' => array(
                'field' => 'user_id', 
                'label' => 'User Info', 
                'rules' => 'trim|required'
        ),
        'token' => array(
                'field' => 'token', 
                'label' => 'Token', 
                'rules' => 'trim|required'
        ),
        'longitude' => array(
                'field' => 'longitude', 
                'label' => 'Longitude', 
                'rules' => 'trim|required'
        ),
        'latitude' => array(
                'field' => 'latitude', 
                'label' => 'Latitude', 
                'rules' => 'trim|required'
        ),
    );

    public function index()
	{
		header('Content-Type: application/json');
		header('Access-Control-Allow-Origin: *');
		header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");
		header('Access-Control-Allow-Methods: POST');
		
		$_POST = json_decode(file_get_contents('php://input'),true);

		$this->form_validation->set_rules(self::$rules_add);

		if($this->form_validation->run() == FALSE):
			$return['status'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            
            echo json_encode(validation_errors());
		else:
			$this->db->trans_start();
    			$attData = [
    				'user_id' => $_POST['user_id'],
    				'token' => $_POST['token'],
    				'longitude' => $_POST['longitude'],
    				'latitude' => $_POST['latitude'],
    				'address' => getAddress($_POST['latitude'],$_POST['longitude']),
                    'timestamp' => date('Y-m-d G:i:s'),
    			];
    
    			$result = $this->Admin_m->find('user_log', ['user_id' => $attData['user_id'], 'token' => $attData['token']]);
    
    			if($result):
    				unset($attData['token']);
    			    $id = $this->Admin_m->save('attendance', $attData);			    
    			    echo json_encode('Attendance Saved');
    		    else:
    		        echo json_encode('Error occurred');
    		    endif;
		    $this->db->trans_complete();
		endif;
	}
}