<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *');
/**
 * Login API
 */
class Login extends CI_Controller
{
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('Login_m');
		$this->load->model('Admin_m');
	}

	static $rules_add = array(
        'username' => array(
                'field' => 'username', 
                'label' => 'Username', 
                'rules' => 'trim|required'
        ),
        'password' => array(
                'field' => 'password', 
                'label' => 'Password', 
                'rules' => 'trim|required'
        ),
    );

    public function getLogedinUser()
	{
		header('Content-Type: application/json');
		header('Access-Control-Allow-Origin: *');
		header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");
		header('Access-Control-Allow-Methods: POST');
		$_POST = json_decode(file_get_contents('php://input'),true);

		$this->form_validation->set_rules(self::$rules_add);

		if($this->form_validation->run() == FALSE) {
            $return['status'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            
            $this->output
		        ->set_content_type('application/json')
		        ->set_output(json_encode($return));
        } else {
			$user['username'] = $this->input->post('username');
			$user['password'] = hashdata($this->input->post('password'));

			$userInfo	= $this->Login_m->getUserData($user);
			
			if( !empty($userInfo) && $userInfo['deleted_at'] == NULL) {
				if($userInfo['status'] == 0){
					$data['hasError']	= 1;
					$data['msg']		= 'Account no active';
				} else {
					$loginData = [
						'type' => 'login_success',
						'user_id' => $userInfo['id'], 
						'fullname' => $userInfo['fullname'], 
						'supervisor' => $userInfo['supervisor_id'],
						'user_name' => $userInfo['username'], 
						'email' => $userInfo['email'], 
						'user_type' => $userInfo['usertype_id'], 
						'is_admin' => $userInfo['is_admin'],
						'supervisor_of' => $this->Admin_m->myAssistants($userInfo['id']), 
						'theme' => $userInfo['theme'],	
						'company' => base_url(),					
						'login_type' => 2,
						'loggedin' => 'true'
					];

					setUserData($loginData);

					$token = generate_token();

					$logData = [
						'user_id' => $this->session->userdata('user_id'),
						'session_id' => session_id(),
						'login_device' => userAgent(),
						'ip_address' => getIP(),
						'login_type' => 2,
						'token' => $token,
						'login_timestamp' => date('Y-m-d H:m:s')
					];

					$this->Login_m->save('user_log', $logData);

					$return = [
						'status' => 'success',
						'user_id' => $this->session->userdata('user_id'),
						'session_id' => session_id(),
						'fullname' => $this->session->userdata('fullname'),
						'token' => $token,
					];
					
					$this->output
				        ->set_content_type('application/json')
				        ->set_output(json_encode($return));					
				}
				
			}  else  {
				$return = [
					'status' => 'warning',
					'message' => 'Wrong User ID or Password !'
				]; 
				$this->output
			        ->set_content_type('application/json')
			        ->set_output(json_encode($return));
			}
		}

	}

	public function authuser(){
	    $data = [
			'user_id' => $this->uri->segment(4, 0),
			'token' => $this->uri->segment(5, 0),
		];

		$result = $this->Admin_m->find('user_log', $data);

		if($result){
		    $userInfo = $this->Login_m->getUserData(['users.id' => $data['user_id']]);
		    
		    $loginData = [
		        'login_type' => 2,
				'user_id' => $userInfo['id'], 
				'fullname' => $userInfo['fullname'], 
				'supervisor' => $userInfo['supervisor_id'],
				'user_name' => $userInfo['username'], 
				'email' => $userInfo['email'], 
				'user_type' => $userInfo['usertype_id'], 
				'is_admin' => $userInfo['is_admin'],
				'supervisor_of' => $this->Admin_m->myAssistants($userInfo['id']), 
				'theme' => $userInfo['theme'],	
				'company' => base_url(),					
				'loggedin' => 'true'
			];
			
			setUserData($loginData);			
			
			redirect('dashboard');			
		}
	}
}