<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Leads extends Admin_controller {

	
	public function __construct(){
		parent::__construct();
        siteStatus();
       
	}


	public function index()
	{
        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function getListData(){
		$lists = $this->Admin_m->findall_datatable(
			'Admin_m', // Model name
			'_get_leads_query', // Function Name
			'filter' // Query type
		);

        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {
        	$button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/lead/leads/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="leads">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>&nbsp;';	                    
            if(getUserData('user_type') != 5 && getUserData('user_type') != 6 && $list->status != 2):		
            	$button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" data-toggle="modal" data-target="#exampleModal" data-title="Assign Lead" data-href="'.site_url('crm/lead/leads/assign/'.$list->id).'" data-id="'.$list->id.'" data-html="form" data-selector="Edit" title="Assign Lead">
                         <i class="zmdi zmdi-thumb-up-down table-icon"></i>
                    </a>&nbsp;';
                if(getUserData('is_admin') == 1):    
                	$button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round make-client" data-href="'.site_url('crm/lead/leads/convert_to_client').'" data-id="'.$list->id.'" data-toggle="tooltip" title="Make Client">
		                <i class="zmdi zmdi-account-add table-icon"></i>
		            </a>&nbsp;';
		        endif;    
		    	$button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" data-toggle="modal" data-target="#exampleModal" data-href="'.site_url('crm/lead/tasks/new_/'.$list->id).'" data-id="'.$list->id.'" data-title="Add Task" data-html="form" data-selector="" title="Add Task">
                        <i class="zmdi zmdi-storage table-icon"></i>
                    </a>&nbsp;';
                $button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('hr/management/visitreport/new_/'.$list->id).'" data-id="'.$list->id.'" data-title="Visit Report" data-html="form" data-selector="" title="Visit Report">
                    <i class="zmdi zmdi-comment-text table-icon"></i>
                </a>&nbsp;';
            endif;        
        	if(getUserData('is_admin') == 1 && getUserData('user_type') != 5 && getUserData('user_type') != 6 && empty($list->deleted_at)):
            $button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round delete-confirm" data-href="'.site_url('crm/lead/leads/delete').'" data-id="'.$list->id.'" title="Remove">
                <i class="zmdi zmdi-delete table-icon"></i>
            </a>';
            endif;

            $no++;
            $row = array();
            
            $row[]  = $list->name;
            $row[]  = $list->lead_contact.' ('.$list->lead_contact_no.')';
            $row[]  = $list->lead_manager_name;
            $row[]  = $list->leadstatus_id == NULL? 'Pending' : '<div class="'.(getUserData('user_type') != 5 && getUserData('user_type') != 6 ? 'contenteditable' : '').'" data-id="'.$list->id.'" data-status="'.$list->leadstatus_id.'">'.$list->lead_status_name.'</div>';
            //$row[] = leadStatistic($list);
            $row[] = (leadStatistic($list) ? '<div class="progressBar'.$key.'"></div>
                <script type="text/javascript">        
                  $(\'.progressBar'.$key.'\').gradientProgressBar({
                      value: '.leadStatistic($list).',
                      size: 100,
                      fill: {
                          gradient: ["red", "yellow", "green"]
                      }
                  });        
                </script>' : '<p class="text-danger">Insufficient Data</p>');
            $row[]  = ($list->total_order_val > 0 ? number_format($list->total_order_val, 2) : '');
            $row[]  = $button;
            $data[] = $row;
        }

        $output = array(
            "draw" 				=> $_POST['draw'],
            "recordsTotal" 		=> '',
            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Admin_m', '_get_leads_query', 'count'),
            "data" 				=> $data,
        );

        //output to json format
        echo json_encode($output);
	}

	static $rules_add = array(
        'name' => array(
                'field'   => 'name', 
                'label'   => 'name', 
                'rules'   => 'trim|required'

        ),
        'street' => array(
                'field'   => 'street', 
                'label'   => 'Street', 
                'rules'   => 'trim|required'

        ),
        'zip' => array(
                'field'   => 'zip', 
                'label'   => 'Zip', 
                'rules'   => 'trim|required'

        ),
        'city' => array(
                'field'   => 'city', 
                'label'   => 'City', 
                'rules'   => 'trim|required'

        ),
        'country_id' => array(
                'field'   => 'country_id', 
                'label'   => 'Country', 
                'rules'   => 'trim|required'

        ),
        'number_of_emp' => array(
                'field'   => 'number_of_emp', 
                'label'   => 'Number of emp', 
                'rules'   => 'trim|required'

        ),
        'annual_revenue' => array(
                'field'   => 'annual_revenue', 
                'label'   => 'Annual revenue', 
                'rules'   => 'trim|required'

        ),
        'leadsource_id' => array(
                'field'   => 'leadsource_id', 
                'label'   => 'Lead source', 
                'rules'   => 'trim|required'

        ),
        'lead_source_desc' => array(
                'field'   => 'lead_source_desc', 
                'label'   => 'Lead source info', 
                'rules'   => 'trim|required'

        ),
        'services' => array(
                'field'   => 'services[]', 
                'label'   => 'Services', 
                'rules'   => 'trim|required'

        ),
        'decision_process' => array(
                'field'   => 'decision_process', 
                'label'   => 'Decision process', 
                'rules'   => 'trim|required'

        ),
        'price_sensitivity' => array(
                'field'   => 'price_sensitivity', 
                'label'   => 'Price sensitivity', 
                'rules'   => 'trim|required'

        ),
        'client_segment' => array(
                'field'   => 'client_segment', 
                'label'   => 'client segment', 
                'rules'   => 'trim|required'

        ),
        'client_budget' => array(
                'field'   => 'client_budget', 
                'label'   => 'Client budget', 
                'rules'   => 'trim|required'

        ),
        'management_style' => array(
                'field'   => 'management_style', 
                'label'   => 'Management style', 
                'rules'   => 'trim|required'

        ),
        'leadstatus_id' => array(
                'field'   => 'leadstatus_id', 
                'label'   => 'Lead status', 
                'rules'   => 'trim|required'

        ),
        'probability' => array(
                'field'   => 'probability', 
                'label'   => 'Probability', 
                'rules'   => 'trim|required'

        ),

        'first_name' => array(
                'field'   => 'first_name[]', 
                'label'   => 'First Name', 
                'rules'   => 'required'

        ),
        'mobile' => array(
                'field'   => 'mobile[]', 
                'label'   => 'Mobile', 
                'rules'   => 'required|numeric|min_length[7]|max_length[16]'

        ),
        'email' => array(
                'field'   => 'email[]', 
                'label'   => 'Email', 
                'rules'   => 'required'

        ),
        'mobile' => array(
                'field'   => 'mobile[]', 
                'label'   => 'Mobile', 
                'rules'   => 'required|numeric|min_length[7]|max_length[16]'

        ),
        'gender' => array(
                'field'   => 'gender[]', 
                'label'   => 'Gender', 
                'rules'   => 'required'

        ),
        'marital_status' => array(
                'field'   => 'marital_status[]', 
                'label'   => 'Marital status', 
                'rules'   => 'required'

        ),
        'family_size' => array(
                'field'   => 'family_size[]', 
                'label'   => 'Family size', 
                'rules'   => 'required'

        ),
        'family_size' => array(
                'field'   => 'family_size[]', 
                'label'   => 'Family size', 
                'rules'   => 'required'

        ),
        'age' => array(
                'field'   => 'age[]', 
                'label'   => 'Age', 
                'rules'   => 'required'

        ),
        'designation' => array(
                'field'   => 'designation[]', 
                'label'   => 'Designation', 
                'rules'   => 'required'

        ),
    );

    static $rules_primary = array(
        'type' => array(
                'field'   => 'type', 
                'label'   => 'Type', 
                'rules'   => 'trim|required'

        ),
        'name' => array(
                'field'   => 'name', 
                'label'   => 'Name', 
                'rules'   => 'trim|required'

        ),
        'street' => array(
                'field'   => 'street', 
                'label'   => 'Street', 
                'rules'   => 'trim|required'

        ),
        'zip' => array(
                'field'   => 'zip', 
                'label'   => 'Zip', 
                'rules'   => 'trim|required'

        ),
        'city' => array(
                'field'   => 'city', 
                'label'   => 'City', 
                'rules'   => 'trim|required'

        ),
        'leadsource_id' => array(
                'field'   => 'leadsource_id', 
                'label'   => 'Lead source', 
                'rules'   => 'trim|required'

        ),
        'lead_source_desc' => array(
                'field'   => 'lead_source_desc', 
                'label'   => 'Lead source info', 
                'rules'   => 'trim|required'

        ),
        'services' => array(
                'field'   => 'services[]', 
                'label'   => 'Services', 
                'rules'   => 'trim|required'

        ), 
        'used_services' => array(
                'field'   => 'used_services[]', 
                'label'   => 'Used services', 
                'rules'   => 'trim|required'

        ),
        'require_referrals' => array(
                'field'   => 'require_referrals[]', 
                'label'   => 'Require referrals', 
                'rules'   => 'trim|required'

        ),
        'decision_process' => array(
                'field'   => 'decision_process', 
                'label'   => 'Decision process', 
                'rules'   => 'trim|required'

        ),
        'price_sensitivity' => array(
                'field'   => 'price_sensitivity', 
                'label'   => 'Price sensitivity', 
                'rules'   => 'trim|required'

        ),
        'probability' => array(
                'field'   => 'probability', 
                'label'   => 'Probability', 
                'rules'   => 'trim|required'

        ),

        'first_name' => array(
                'field'   => 'first_name[]', 
                'label'   => 'First Name', 
                'rules'   => 'required'

        ),
        'email' => array(
                'field'   => 'email[]', 
                'label'   => 'Email', 
                'rules'   => 'required'

        ),
        'mobile' => array(
                'field'   => 'mobile[]', 
                'label'   => 'Mobile', 
                'rules'   => 'required|numeric|min_length[7]|max_length[16]'

        ),
      
        'designation' => array(
                'field'   => 'designation[]', 
                'label'   => 'Designation', 
                'rules'   => 'required'

        ),

        'client_budget' => array(
            'field'   => 'client_budget[]', 
            'label'   => 'Client Budget', 
            'rules'   => 'required'
        ),

        'client_segment'  => array(
            'field'   => 'client_segment[]', 
            'label'   => 'Client Segment', 
            'rules'   => 'required'
        ),
    );

    static $rules_second  = array(
        
    );

	public function new_()
	{
        $this->session->unset_userdata('lead_question');

		$input 							= new stdClass();
		
		$input->id 						= '';
		$input->type 					= '';
		$input->lead_contacts_id		= '';
		$input->name 			        = '';
		$input->email 			        = '';
		$input->company_address 		= '';
		$input->company_contact 		= '';
		$input->company_email 		    = '';
		$input->company_mobile 		    = '';
		$input->company_website 		= '';
		$input->bankinfo 		        = '';
		$input->tin 		            = '';
		$input->logo 		            = '';
		$input->lead_source_desc        = '';
		$input->street 		            = '';
		$input->street2 		        = '';
		$input->city 		            = '';
		$input->state 		            = '';
		$input->leadstatus_id 		    = '';
		$input->leadsource_id 		    = '';
		$input->services 		        = '';
		$input->used_services_desc		= '';
		$input->km 		        		= '';
		$input->created_user 		    = '';
		$input->country_id 		        = '';
		$input->zip 		            = '';
		$input->family_size 		    = '';
        $input->income                  = '';
        $input->number_of_emp           = '';
        $input->annual_revenue          = '';
        $input->decision_process        = '';
        $input->management_style        = '';
        $input->type_of_business        = '';
		$input->years_in_business 	    = '';
        $input->require_referrals_desc  = '';
        $input->require_competition_desc= '';
        $input->query_date              = '';

		$input->first_name 		        = '';
		$input->last_name 		        = '';
		$input->mobile 		            = '';
		$input->phone 		            = '';
		$input->designation 		    = '';
		$input->status 					= '';
		$input->probability				= '';
		$input->age			         	= '';
		
		$data['input'] 					= $input;
		$data['detailRowDataList'] 		= array();

        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/question';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}

    public function newLead($id = NULL)
    {

        if($this->session->has_userdata('lead_question')):
            $result = getUserData('lead_question');
        else:    
            $result = [];
        endif;
        
        $input                          = new stdClass();
        
        $input->id                      = '';
        $input->type                    = ($result ? $result['type'] : '');
        $input->type_of_business        = ($result ? $result['type_of_business'] : '');
        $input->name                    = ($result ? $result['name'] : '');
        $input->street                  = ($result ? $result['street'] : '');
        $input->street2                 = ($result ? $result['street2'] : '');
        $input->zip                     = ($result ? $result['zip'] : '');
        $input->city                    = ($result ? $result['city'] : '');
        $input->state                   = ($result ? $result['state'] : '');
        $input->country_id              = ($result ? $result['country_id'] : '');
        $input->number_of_emp           = ($result ? $result['number_of_emp'] : '');
        $input->years_in_business       = ($result ? $result['years_in_business'] : '');
        $input->annual_revenue          = ($result ? $result['annual_revenue'] : '');
        $input->leadsource_id           = ($result ? $result['leadsource_id'] : '');
        $input->lead_source_desc        = ($result ? $result['lead_source_desc'] : '');
        $input->services                = ($result ? $result['services'] : '');
        $input->used_services           = ($result ? $result['used_services'] : '');
        $input->used_services_desc      = ($result ? $result['used_services_desc'] : '');
        $input->require_referrals       = ($result ? $result['require_referrals'] : '');
        $input->require_referrals_desc  = ($result ? $result['require_referrals_desc'] : '');
        $input->decision_process        = ($result ? $result['decision_process'] : '');
        $input->price_sensitivity       = ($result ? $result['price_sensitivity'] : '');
        $input->management_style        = ($result ? $result['management_style'] : '');
        $input->probability             = ($result ? $result['probability'] : '');
        $input->logo                    = '';
        $input->company_contact         = '';
        $input->company_website         = '';
        $input->leadstatus_id           = '';
        $input->notes                   = '';
        
        $input->km                      = '';
        $input->created_user            = '';     
        $input->status                  = ($result ? 2 : '');   
        $input->contacts                = ($result ? $result['contact'] : '');        
        
        $data['input']                  = $input;

        $data['detailRowDataList']      = array();

        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

    }

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->findLeads(['leads.id' => $id], true);
        $contact = $data['input']->contacts;
        unset($data['input']->contacts);
		$data['input']->contacts = json_decode(json_encode($contact), True);
        $data['input']->secondary = $this->Admin_m->findAll('leads_secondary_info', ['lead_id' => $id], 'row');
        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}
	
	public function confirmStep($id = '')
	{
        $data['id'] = $id;
		$data['result'] = $this->Admin_m->find('leads_secondary_info', ['lead_id' => $id]);

        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/confirmStep';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function secondaryInfo($id = '')
	{

		$result = $this->Admin_m->find('leads_secondary_info', ['lead_id' => $id]);

		$input 							= new stdClass();
		
		$input->id 						= ($result ? $result->id : '');
		$input->lead_id					= ($result ? $result->lead_id : $id);
		$input->professionalism 		= ($result ? $result->professionalism :'');
		$input->tech_sophistication		= ($result ? $result->tech_sophistication :'');
		$input->brand_preferences 		= ($result ? $result->brand_preferences :'');
		$input->conservative 			= ($result ? $result->conservative :'');
		$input->internet_usage 			= ($result ? $result->internet_usage :'');
		$input->collateral_consumed 	= ($result ? $result->collateral_consumed :'');
		$input->purchasing_power 		= ($result ? $result->purchasing_power :'');
		$input->purchasing_process 		= ($result ? $result->purchasing_process :'');
		$input->purchasing_methods 		= ($result ? $result->purchasing_methods :'');
		
		$data['input'] 					= $input;
		$data['detailRowDataList'] 		= array();

        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/secondForm';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}

	public function assign($id)
	{
		$data['input'] = $this->Admin_m->find('lead_manager',['lead_id' => $id, 'status' => 1], true);

        $this->load->view('crm/leads/assign', $data);

	}

    public function saveprimaryinfo()
    {
        if($this->input->post('type') == 1):
            self::$rules_primary['number_of_emp'] = array(
                'field'   => 'number_of_emp', 
                'label'   => 'Number of emp', 
                'rules'   => 'trim|required'
            );
            self::$rules_primary['annual_revenue'] = array(
                'field'   => 'annual_revenue', 
                'label'   => 'Annual revenue', 
                'rules'   => 'trim|required'
            );
            self::$rules_primary['management_style'] = array(
                'field'   => 'management_style', 
                'label'   => 'Management style', 
                'rules'   => 'trim|required'
            );
            self::$rules_primary['years_in_business'] = array(
                'field'   => 'years_in_business', 
                'label'   => 'Years in business', 
                'rules'   => 'trim|required'
            );
        endif;

        if($this->input->post('sub_service')):
            self::$rules_primary['sub_service'] = array(
                'field'   => 'sub_service[]', 
                'label'   => 'Sub service', 
                'rules'   => 'trim|required'

            );
        endif;

        if($this->input->post('used_services') == 1):
            self::$rules_primary['used_services_desc'] = array(
                'field'   => 'used_services_desc', 
                'label'   => 'Used services desc', 
                'rules'   => 'trim|required'

            );
        endif;

        if($this->input->post('require_referrals') == 1):
            self::$rules_primary['require_referrals_desc'] = array(
                'field'   => 'require_referrals_desc', 
                'label'   => 'Require referrals desc', 
                'rules'   => 'trim|required'

            );
        endif;

        if($this->input->post('require_competition') == 1):
            self::$rules_primary['require_competition_desc'] = array(
                'field'   => 'require_competition_desc', 
                'label'   => 'Require competition desc', 
                'rules'   => 'trim|required'

            );
        endif;

        $this->form_validation->set_rules(self::$rules_primary);    
        
        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
            $this->db->trans_start();

                $leadData = [
                    'type' => $this->input->post('type'),
                    'type_of_business' => $this->input->post('type_of_business'),
                    'name' => $this->input->post('name'),
                    'street' => $this->input->post('street'),
                    'street2' => $this->input->post('street2'),
                    'zip' => $this->input->post('zip'),
                    'city' => $this->input->post('city'),
                    'state' => $this->input->post('state'),
                    'country_id' => $this->input->post('country_id'),
                    'leadsource_id' => $this->input->post('leadsource_id'),
                    'lead_source_desc' => $this->input->post('lead_source_desc'),
                    'used_services' =>  $this->input->post('used_services'),
                    'used_services_desc' => $this->input->post('used_services_desc'),
                    'require_referrals' => $this->input->post('require_referrals'),
                    'require_referrals_desc' => $this->input->post('require_referrals_desc'),

                    'require_competition' => $this->input->post('require_competition'),
                    'require_competition_desc' => $this->input->post('require_competition_desc'),
                    'client_segment' => $this->input->post('client_segment'),
                    'query_date' => $this->input->post('query_date'),

                    'decision_process' => $this->input->post('decision_process'),
                    'price_sensitivity' => $this->input->post('price_sensitivity'),
                    'probability' => $this->input->post('probability'),
                    'client_budget'  => $this->input->post('client_budget'),
                    'km' => getUserData('user_id'),
                    'created_user' => getUserData('user_id'),
                    'created_at' => date('Y-m-d'),
                ];

                $id = $this->Admin_m->save('leads', $leadData);
                if($this->input->post('type') == 1):
                    $this->Admin_m->delete('leads_company_data', ['lead_id' => $id]);
                    $leadCompData = [
                        'lead_id' => $id,
                        'number_of_emp' => $this->input->post('number_of_emp'),
                        'years_in_business' =>  $this->input->post('years_in_business'),
                        'annual_revenue' => $this->input->post('annual_revenue'),
                        'management_style' => $this->input->post('management_style'),
                    ];
                    $this->Admin_m->save('leads_company_data', $leadCompData);
                endif;
                $secondary = [
                        'lead_id' => $id,
                        'professionalism' => $this->input->post('professionalism'),
                        'tech_sophistication' => $this->input->post('tech_sophistication'),
                        'brand_preferences' => $this->input->post('brand_preferences'),
                        'conservative' => $this->input->post('conservative'),
                        'internet_usage' => $this->input->post('internet_usage'),
                        'collateral_consumed' => $this->input->post('collateral_consumed'),
                        'purchasing_power' => $this->input->post('purchasing_power'),
                        'purchasing_process' => $this->input->post('purchasing_process'),
                        'purchasing_methods' => $this->input->post('purchasing_methods'),
                    ];

                $this->Admin_m->save('leads_secondary_info', $secondary);


                $leadContact = [];
                foreach ($this->input->post('first_name') as $key => $name) {
                    $leadContact[$key] = [
                        'lead_id' => $id,
                        'contact_type' => ($this->input->post('same_as_contact') === 'on' ? 2 : $this->input->post('contact_type')[$key]),
                        'first_name' => $name,
                        'email' => $this->input->post('email')[$key],
                        'mobile' => $this->input->post('mobile')[$key],
                        'designation' => $this->input->post('designation')[$key],
                        'photo' => $this->input->post('photo')[$key],
                    ];
                }

                if($this->input->post('same_as_contact') === 'on'){
                    unset($leadContact[1]);
                }                

                $this->Admin_m->save('lead_contacts', $leadContact, true);
                
                $leadManager = [
                    'lead_id'       => $id,
                    'user_id'       => getUserData('user_id'),
                    'updated_by'    => getUserData('user_id')
                ];
                $this->Admin_m->save('lead_manager', $leadManager);

                $services = $this->input->post('services');
                $sub_service = $this->input->post('sub_service');
                $module_id = $this->input->post('module_id');
                $module_name =  $this->input->post('module_name');
                $criteria = $this->input->post('criteria');
                $description = $this->input->post('description');
                $exp_total_order_val = $this->input->post('exp_total_order_val');
                $exp_order_date = $this->input->post('exp_order_date');

                $service_info = [];

                foreach ($services as $key => $value):
                    $service_info[$key] = [
                        'lead_id' => $id,
                        'services_id' => $value,                        
                        'exp_total_order_val' => $exp_total_order_val[$value][0],
                        'exp_order_date' => $exp_order_date[$value][0],
                        'detail' => []
                    ];

                    if(isset($sub_service[$value])):
                        $service_info[$key]['sub_service'] = $sub_service[$value];
                    endif;

                    if($module_id):
                        foreach ($module_id as $mkey => $module):
                            if(isset($sub_service[$value]) && isset($module[$sub_service[$value]][0])):
                                $array = [
                                    'lead_id' => $id,
                                    'module_id' => $module[$sub_service[$value]][0],
                                    'criteria' => array_to_string($criteria[$mkey][$sub_service[$value]][$module[$sub_service[$value]][0]]),
                                    'description' => $description[$mkey][$sub_service[$value]][0],
                                ];
                                array_push($service_info[$key]['detail'], $array);
                            endif;
                        endforeach;
                    endif;  
                endforeach;

                foreach ($service_info as $key => $value):
                    $details = $value['detail'];
                    unset($value['detail']);
                    $lead_services = $this->Admin_m->save('lead_services', $value);

                    if($details):
                        foreach ($details as $key => $value):
                            $value['lead_services_id'] = $lead_services;
                            $this->Admin_m->save('lead_services_detail', $value);
                        endforeach;
                    endif;
                endforeach;

                $this->session->set_userdata('lead_question', $leadData);
                $message = "Successfully Saved";

            $this->db->trans_complete();

            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('crm/lead/Leads/new_'),
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/lead/leads/edit/'.$id),
                ]; 
            }

            echo json_encode($return);
        }
    }

	public function save()
	{
        if($this->input->post('type') == 1):
            self::$rules_primary['number_of_emp'] = array(
                'field'   => 'number_of_emp', 
                'label'   => 'Number of emp', 
                'rules'   => 'trim|required'
            );
            self::$rules_primary['annual_revenue'] = array(
                'field'   => 'annual_revenue', 
                'label'   => 'Annual revenue', 
                'rules'   => 'trim|required'
            );
            self::$rules_primary['management_style'] = array(
                'field'   => 'management_style', 
                'label'   => 'Management style', 
                'rules'   => 'trim|required'
            );
            self::$rules_primary['years_in_business'] = array(
                'field'   => 'years_in_business', 
                'label'   => 'Years in business', 
                'rules'   => 'trim|required'
            );
        endif;

        if($this->input->post('used_services') === 1):
            self::$rules_primary['used_services_desc'] = array(
                'field'   => 'used_services_desc', 
                'label'   => 'Used services desc', 
                'rules'   => 'trim|required'

            );
        endif;

        if($this->input->post('require_referrals') === 1):
            self::$rules_primary['require_referrals_desc'] = array(
                'field'   => 'require_referrals_desc', 
                'label'   => 'Require referrals desc', 
                'rules'   => 'trim|required'

            );
        endif;

        $this->form_validation->set_rules(self::$rules_primary);
		if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
            $this->db->trans_start();

				$leadData = [
                    'type' => $this->input->post('type'),
                    'type_of_business' => $this->input->post('type_of_business'),
                    'name' => $this->input->post('name'),
                    'street' => $this->input->post('street'),
                    'street2' => $this->input->post('street2'),
                    'zip' => $this->input->post('zip'),
                    'city' => $this->input->post('city'),
                    'state' => $this->input->post('state'),
                    'notes' => $this->input->post('notes'),
                    'country_id' => $this->input->post('country_id'),
                    'leadsource_id' => $this->input->post('leadsource_id'),
                    'lead_source_desc' => $this->input->post('lead_source_desc'),
                    'used_services' =>  $this->input->post('used_services'),
                    'used_services_desc' => $this->input->post('used_services_desc'),
                    'require_referrals' => $this->input->post('require_referrals'),
                    'require_referrals_desc' => $this->input->post('require_referrals_desc'),
                    'decision_process' => $this->input->post('decision_process'),
                    'price_sensitivity' => $this->input->post('price_sensitivity'),
                    'probability' => $this->input->post('probability'),
                    'require_competition' => $this->input->post('require_competition'),
                    'require_competition_desc' => $this->input->post('require_competition_desc'),
                    'client_segment' => $this->input->post('client_segment'),
                    'query_date' => $this->input->post('query_date'),
                    'client_budget' => $this->input->post('client_budget'),
                    'km' => ($this->input->post('id') ? $this->input->post('km') : getUserData('user_id')),
                   
                ];

                if($this->input->post('leadstatus_id') != NULL):
                    $leadData['leadstatus_id'] = $this->input->post('leadstatus_id');
                endif;

				if($this->input->post('id')):
                
					$id = $this->input->post('id');                    
					$leadData['updated_by'] = getUserData('user_id');
					$leadData['updated_at'] = date('Y-m-d');
                    
                   
					$this->Admin_m->update('leads', $leadData, array('id' => $id));

                    if($this->input->post('type') == 1):
                        $this->Admin_m->delete('leads_company_data', ['lead_id' => $id]);
                        $leadCompData = [
                            'lead_id' => $id,
                            'number_of_emp' => $this->input->post('number_of_emp'),
                            'years_in_business' =>  $this->input->post('years_in_business'),
                            'annual_revenue' => $this->input->post('annual_revenue'),
                            'management_style' => $this->input->post('management_style'),
                        ];
                        $this->Admin_m->save('leads_company_data', $leadCompData);
                    endif;

					$this->Admin_m->delete('lead_contacts', ['lead_id' => $id]);
                    $this->Admin_m->delete('leads_secondary_info', ['lead_id' => $id]);

                    $secondary = [
                        'lead_id' => $id,
                        'professionalism' => $this->input->post('professionalism'),
                        'tech_sophistication' => $this->input->post('tech_sophistication'),
                        'brand_preferences' => $this->input->post('brand_preferences'),
                        'conservative' => $this->input->post('conservative'),
                        'internet_usage' => $this->input->post('internet_usage'),
                        'collateral_consumed' => $this->input->post('collateral_consumed'),
                        'purchasing_power' => $this->input->post('purchasing_power'),
                        'purchasing_process' => $this->input->post('purchasing_process'),
                        'purchasing_methods' => $this->input->post('purchasing_methods'),
                    ];

                    $this->Admin_m->save('leads_secondary_info', $secondary);

                    


					$message = 'update successfull';
				else:
                    $leadData['created_at'] = date('Y-m-d');
                    $leadData['created_user'] = getUserData('user_id');

               

					$id = $this->Admin_m->save('leads', $leadData);

					$leadManager = [
						'lead_id' 		=> $id,
						'user_id' 		=> getUserData('user_id'),
						'updated_by' 	=> getUserData('user_id')
					];
					$this->Admin_m->save('lead_manager', $leadManager);
					$message = 'save successfull';
				endif;

				$leadContact = [];
				foreach ($this->input->post('first_name') as $key => $name) {
					$leadContact[$key] = [
						'lead_id' => $id,
						'contact_type' => $this->input->post('contact_type')[$key],
						'first_name' => $name,
						'email' => $this->input->post('email')[$key],
						'mobile' => $this->input->post('mobile')[$key],
						'gender' => $this->input->post('gender')[$key],
						'marital_status' => $this->input->post('marital_status')[$key],
						'designation' => $this->input->post('designation')[$key],
						'family_size' => $this->input->post('family_size')[$key],
						'income' => $this->input->post('income')[$key],
						'age' => $this->input->post('age')[$key],
                        'photo' => $this->input->post('photo')[$key],
						'social_circles' => array_to_string(
							[
								$this->input->post('facebook')[$key],
								$this->input->post('linkedin')[$key],
								$this->input->post('twitter')[$key],
							]
						)
					];
				}
				$this->Admin_m->save('lead_contacts', $leadContact, true);

                $this->Admin_m->delete('lead_services_detail', ['lead_id' => $id]);
                $this->Admin_m->delete('lead_services', ['lead_id' => $id]);

                $services = $this->input->post('services');
                $sub_service = $this->input->post('sub_service');
                $module_id = $this->input->post('module_id');
                $module_name =  $this->input->post('module_name');
                $criteria = $this->input->post('criteria');
                $description = $this->input->post('description');
                $exp_total_order_val = $this->input->post('exp_total_order_val');
                $exp_order_date =  $this->input->post('exp_order_date');

                $service_info = [];

                foreach ($services as $key => $value):
                    $service_info[$key] = [
                        'lead_id' => $id,
                        'services_id' => $value,                        
                        'exp_total_order_val' => $exp_total_order_val[$value][0],
                        'exp_order_date' => $exp_order_date[$value][0],
                        'detail' => []
                    ];

                    if(isset($sub_service[$value])):
                        $service_info[$key]['sub_service'] = $sub_service[$value];
                    endif;

                    if($module_id):
                        foreach ($module_id as $mkey => $module):
                            if(isset($sub_service[$value]) && isset($module[$sub_service[$value]][0])):
                                $array = [
                                    'lead_id' => $id,
                                    'module_id' => $module[$sub_service[$value]][0],
                                    'criteria' => array_to_string($criteria[$mkey][$sub_service[$value]][$module[$sub_service[$value]][0]]),
                                    'description' => $description[$mkey][$sub_service[$value]][0],
                                ];
                                array_push($service_info[$key]['detail'], $array);
                            endif;
                        endforeach;
                    endif;  
                endforeach;

                foreach ($service_info as $key => $value):
                    $details = $value['detail'];
                    unset($value['detail']);
                    $lead_services = $this->Admin_m->save('lead_services', $value);

                    if($details):
                        foreach ($details as $key => $value):
                            $value['lead_services_id'] = $lead_services;
                            $this->Admin_m->save('lead_services_detail', $value);
                        endforeach;
                    endif;
                endforeach;

				$notification = [
		            'tbl_name'      => 'leads',
		            'tbl_pk'        => $id,
		            'user_id'       => getUserData('user_id'), 
		            'usertype_id'   => getUserData('user_type'),
		            'title'         => '<strong>'.getUserData('fullname').' '.word_limiter(plainText($leadData['name']), 10).'</strong> Lead '.($this->input->post('id') ? 'Updated' : 'Created'),
		            'source_url'    => 'crm/lead/leads/view/'.$id,
		            'deadline'      => NULL, 
		            'list_class'    => 'info',
		            'created_date'  => date('Y-m-d H:i:sa'),
		        ];
		        $this->Admin_m->save('notifications', $notification);

                $this->session->unset_userdata('lead_question');

			$this->db->trans_complete();

			if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('crm/lead/Leads/newLead'),
                ]; 
            } else {
                if ($id) {
                    $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/lead/leads/'),
                ];
                }else{
                  $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/lead/leads/confirmStep'),
                ];  
                }
                 
            }

            echo json_encode($return);
            
		}
			
		
	}

	public function saveSecond()
	{
		$this->form_validation->set_rules(self::$rules_second);

		if($this->form_validation->run() == FALSE) {
		   	$return['type'] = 'validation_error'; 
            foreach ($_POST as $key => $value):
                if($value === ''):
                    $return['message'][str_replace("[]","",$key)] = ucfirst($key).' field is required!';
                endif;
            endforeach;
            echo json_encode($return);
		} else {
			$this->db->trans_start();

				$data = [
					'id' => $this->input->post('id'),
					'lead_id' => $this->input->post('lead_id'),
					'professionalism' => $this->input->post('professionalism'),
					'tech_sophistication' => $this->input->post('tech_sophistication'),
					'brand_preferences' => $this->input->post('brand_preferences'),
					'conservative' => $this->input->post('conservative'),
					'internet_usage' => $this->input->post('internet_usage'),
					'collateral_consumed' => $this->input->post('collateral_consumed'),
					'purchasing_power' => $this->input->post('purchasing_power'),
					'purchasing_process' => $this->input->post('purchasing_process'),
					'purchasing_methods' => $this->input->post('purchasing_methods'),
				];

				if($this->input->post('id')):
					$id = $this->input->post('id');
					$this->Admin_m->update('leads_secondary_info', $data, array('id' => $id));
					$message = 'update successfull';
				else:
					$this->Admin_m->save('leads_secondary_info', $data);
					$message = 'save successfull';
				endif;

			$this->db->trans_complete();

			if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('crm/lead/Leads/secondForm'),
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/lead/leads/'),
                ]; 
            }

            echo json_encode($return);
		}
		
	}

    public function delete()
    {
        $id = $this->input->post('id');
        $this->db->trans_start();
            if(!empty($id)) {
                $this->Admin_m->destroy('leads', array('id' => $id));
            }

            $returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Lead delete successfull', 'detailMessage' => '');
            echo json_encode($returnData);
        $this->db->trans_complete();
    }


	public function assign_save()
	{

		$id					       = $this->input->post('id');              
		$data['lead_id']           = $this->input->post('lead_id');
		$data['user_id']           = $this->input->post('user_id');
		$data['updated_by']        = getUserData('user_id');
		$status['status']          = 0;
		
		$this->db->trans_start();
			$result = $this->Admin_m->find('lead_manager', ['lead_id' => $data['lead_id'], 'user_id' => $data['user_id'], 'status' => 1]);
			$lead = $this->Admin_m->find('leads', ['id' => $data['lead_id']]);
			if(empty($result)){
				$this->Admin_m->update('leads', ['km' => $data['user_id']], ['id' => $data['lead_id']]);
				$this->Admin_m->update('lead_manager', $status, array('id' => $id));
				$this->Admin_m->save('lead_manager', $data);
				$message = 'Lead assigned Successfully ';	

				$notification = [
		            'tbl_name'      => 'leads',
		            'tbl_pk'        => $data['lead_id'],
		            'user_id'       => $data['user_id'], 
		            'usertype_id'   => getUserData('user_type'),
		            'title'         => '<strong>'.getUserData('fullname').' Assigned Lead: '.word_limiter(plainText($lead->name), 10).'</strong>   to '.userList(['users.id' => $data['user_id']], '', true),
		            'source_url'    => 'crm/lead/leads/view/'.$data['lead_id'],
		            'deadline'      => NULL, 
		            'list_class'    => 'info',
		            'created_date'  => date('Y-m-d H:i:sa'),
		            ];
		            //dd($notification);
		        $this->Admin_m->save('notifications', $notification);			
			} else {
				$message = 'Data aready exists';				
			}			
			
		$this->db->trans_complete();

        if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('crm/lead/leads/'),
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/lead/leads/'),
                ]; 
            }

            echo json_encode($return);

		}
	
	
		function reports(){

            $lists = $this->Admin_m->findall_datatable('Admin_m', '_get_leads_query', 'filter', ['leads.created_at' => date('Y-m-d')]);

            $data = array();

            $no = $_POST['start'];

            foreach ($lists as $key => $list) {
                $no++;
                $row = array();

                $leadService = '';

                $row[] = $list->name;
                $row[] = $list->lead_manager_name;
                $row[] = $list->lead_contact;
                $row[] = $list->leadstatus_id == NULL? 'Pending' : '<div class="contenteditable" data-id="'.$list->id.'" data-status="'.$list->leadstatus_id.'">'.$list->lead_status_name.'</div>';
                $data[] = $row;
            }

            $output = array(
                "draw"              => $_POST['draw'],
                "recordsTotal"      => '',
                "recordsFiltered"   => $this->Admin_m->findall_datatable('Admin_m', '_get_leads_query', 'count', ['leads.created_at' => date('Y-m-d')]),
                "data"              => $data,
            );

            //output to json format
            echo json_encode($output);
        }

	public function convert_to_client(){

            $this->db->trans_start();
		
			$id = $this->input->post('id');
			$data['status'] = 1;

			if(!empty($id)) {
				$this->Admin_m->update('leads', $data, array('id' => $id));
			}

			$client = [
				'lead_id' => $id,
				'created_by' => getUserData('user_id'),
				'date' => date('Y-m-d h:i:s')
			];
			$this->Admin_m->save('clients', $client);
			$lead = $this->Admin_m->find('leads', ['id' => $id]);
            $message = "Client Converted Successfully";
            
			$notification = [
                'tbl_name'      => 'clients',
                'tbl_pk'        => $id,
                'user_id'       => getUserData('user_id'), 
                'usertype_id'   => getUserData('user_type'),
                'title'         => '<strong>'.getUserData('fullname').' Created : '.word_limiter(plainText($lead->name), 10).'</strong> as a Client',
                'source_url'    => 'crm/lead/leads/view/'.$id,
                'deadline'      => NULL, 
                'list_class'    => 'info',
                'created_date'  => date('Y-m-d H:i:sa'),
                ];
                //dd($notification);
            	$this->Admin_m->save('notifications', $notification);
		$this->db->trans_complete();
		
		if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    /*'url' => site_url('crm/lead/Leads/secondForm'),*/
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    /*'url' => site_url('crm/lead/leads/'),*/
                ]; 
            }

            echo json_encode($return);
	}

	 public function view($id)
    {
    	$data['input'] = $this->Admin_m->findLeads(['leads.id' => $id], true);
    	$data['input']->secondary = $this->Admin_m->find('leads_secondary_info', ['lead_id' => $data['input']->id]);

        $data['class'] = 'index2';
        $data['page'] = 'crm/leads/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);        
    }

    public function getLeadList(){
    	if(getUserData('is_admin') == 1){
        	$leads = getLead(['leads.status' => 0,], true,true);
	    } 
	    else {
	        $leads = getLead(['leads.status' => 0,'where_in' => ['leads.km' => getUserData('supervisor_of')]], true,true);
	    }
	    
	    $html = '<label for="bill_type">Lead/Client</label><select name="lead_id" class="form-control show-tick" id="lead_id" style="width: 100%; " tabindex="-98"><option value="">Select Lead</option>';

	    foreach ($leads as $key => $lead) {
	    	$html .= '<option value="'.$lead['id'].'">'.($lead['name'] ? $lead['name'] : $lead['first_name']." ".$lead['last_name']).'</option>';
	    }
        $html .= '</select>';
	    echo $html;

	}

	public function report(){
		
		if($_REQUEST['columns'][0]['search']['value'] || $_REQUEST['columns'][1]['search']['value'] || $_REQUEST['columns'][2]['search']['value'] || $_REQUEST['columns'][3]['search']['value']):
			$lists = $this->Admin_m->findall_datatable(
				'Report_m', // Model name
				'_get_leads_query', // Function Name
				'filter' // Query type
			);
          //  dd($lists);
            
			$data = array();
	        $no = $_POST['start'];
	        foreach ($lists as $key => $list) {
	            $no++;
	            $row = array();
	            
	            $row[] = getLead(['leads.id' => $list->id]);
	            $row[] = $list->lead_manager_name;
	            $row[] = $list->lead_contact;
	            $row[] = $list->company_website;
	            $row[] = $list->lead_status_name;
	            $data[]= $row;
	        }

	        $output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Report_m', '_get_leads_query', 'count'),
	            "data" 				=> $data,
	        );
	    else:
	    	$output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> 0,
	            "data" 				=> [],
	        );
	    endif;    

        //output to json format
        echo json_encode($output);
	}

	public function savereport(){

		$data['user_id'] = $this->input->post('user_id');
        $data['leadstatus_id'] = $this->input->post('department_id');
        $data['from_date'] = $this->input->post('from_date');
        $data['to_date'] = $this->input->post('to_date');

        $lists['results'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_leads_query', // Function Name
                '', // Query type    
                $data        
            );
        
        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('hr/reports/management/pdf/leadsreport',$lists);
        $html = $this->output->get_output();
        //echo $html; exit;
        $dompdf->loadHtml($html);
        $dompdf->set_paper('A4', 'landscape');
        $dompdf->render();
        $dompdf->stream('projectreport_'.date('Ymd').'.pdf',array("Attachment"=>0));
    }

    public function updateLead()
    {
    	$id = $this->input->post('id');
    	$data['leadstatus_id'] = $this->input->post('leadstatus');

    	$id = $this->Admin_m->update('leads', $data, array('id' => $id));
        
    	if($id){
    		echo json_encode(['class' => 'success', 'message' => 'Status Successfully Updated']);
    	} else {
    		echo json_encode(['class' => 'error', 'message' => 'Somthing Wrong']);
    	}

    }

    public function approveleads()
    {
        $id = $this->input->post('id');
        $data['leadstatus_id'] = 1;
        $data['status'] = 0;

        $id = $this->Admin_m->update('leads', $data, array('id' => $id));
        $output = array(
                'hasError'      => 0, 
                'class'         => 'success', 
                'message'       => 'Lead approved Successfully', 
                'detailMessage' => ''
            );
        echo json_encode($output);

    }

    public function checkCreateDate()
    {
        $result = $this->Admin_m->find('leads', ['id' => $this->input->post('id')]);

        if(strtotime($result->created_at) < strtotime($this->input->post('date'))):
            ;
            echo json_encode(['msgType' => 'warning', 'message' => 'Invalid Date']);
        endif;
    }

    public function getLeadAnalytics()
    {
        $data = $this->Admin_m->findLeadAnalytics($this->input->post('id'));
        
        $result = [];

        if($data):
            $parm1 = date_diff(date_create($data->query_date),date_create($data->created_at))->format("%R%a");
            if($parm1 <= 30):
                array_push($result, ['y' => 'Query Generate Date', 'a' => 5]);
            elseif($parm1 >= 30 &&  $parm1 <= 45):
                array_push($result, ['y' => 'Query Generate Date', 'a' => 4]);    
            elseif($parm1 >= 45 &&  $parm1 <= 60):
                array_push($result, ['y' => 'Query Generate Date', 'a' => 3]);        
            elseif($parm1 >= 60 &&  $parm1 <= 90):
                array_push($result, ['y' => 'Query Generate Date', 'a' => 2]);        
            else:
                array_push($result, ['y' => 'Query Generate Date', 'a' => 0, 'color' => '']);
            endif;   

            $parm2 = date_diff(date_create($data->created_at),date_create($data->exp_order_date))->format("%R%a");

            if($parm2 <= 30):
                array_push($result, ['y' => 'Expected Order Date', 'a' => 5]);
            elseif($parm2 >= 30 &&  $parm2 <= 45):
                array_push($result, ['y' => 'Expected Order Date', 'a' => 4]);    
            elseif($parm2 >= 45 &&  $parm2 <= 60):
                array_push($result, ['y' => 'Expected Order Date', 'a' => 3]);        
            elseif($parm2 >= 60 &&  $parm2 <= 90):
                array_push($result, ['y' => 'Expected Order Date', 'a' => 2]);        
            else:
                array_push($result, ['y' => 'Expected Order Date', 'a' => 0, 'color' => '']);
            endif;  

            if($data->used_services == 1):
                array_push($result, ['y' => 'Using Service', 'a' => 3]);        
            else:
                array_push($result, ['y' => 'Using Service', 'a' => 5]);     
            endif;

            if($data->require_competition == 1):
                array_push($result, ['y' => 'Competition Offer', 'a' => 3]);       
            else:
                array_push($result, ['y' => 'Competition Offer', 'a' => 5]);          
            endif;

            if($data->price_sensitivity == 1):
                array_push($result, ['y' => 'Price Sensitive', 'a' => 3]);
            else:
                array_push($result, ['y' => 'Price Sensitive', 'a' => 5]);        
            endif;

            if($data->client_budget == 1):
                array_push($result, ['y' => 'Client Budget', 'a' => 5]);        
            else:
                array_push($result, ['y' => 'Client Budget', 'a' => 3]);      
            endif;

            if($data->client_segment === 'C1' || $data->client_segment === 'C2'):
                array_push($result, ['y' => 'Client Segment', 'a' => 2]);      
            elseif($data->client_segment === 'B2'):
                array_push($result, ['y' => 'Client Segment', 'a' => 3]);      
            else:
                array_push($result, ['y' => 'Client Segment', 'a' => 5]);        
            endif;

            if($data->probability <= 2):
                array_push($result, ['y' => 'Probability', 'a' => 2]);        
            elseif($data->probability == 3):
                array_push($result, ['y' => 'Probability', 'a' => 3]);     
            else:
                array_push($result, ['y' => 'Probability', 'a' => 5]);        
            endif;

            if($data->purchasing_power == 2):
                array_push($result, ['y' => 'Purchase Power', 'a' => 5]); 
            elseif($data->purchasing_power == 1):
                array_push($result, ['y' => 'Purchase Power', 'a' => 3]);
            else:
                array_push($result, ['y' => 'Purchase Power', 'a' => 2]);    
            endif;

            $services = CI()->Admin_m->findAll('lead_services', ['lead_id' => $data->id]);

            $modulePrice = 0;
            $orderPrice = 0;
            if($services):
                foreach ($services as $key => $service):
                    if($service->sub_service != NULL):
                        $details = CI()->Admin_m->findAll('lead_services_detail', ['lead_id' => $data->id]);
                        foreach ($details as $detail):
                            $info = CI()->Admin_m->find('service_modules', ['id' => $detail->module_id]);
                            $modulePrice += $info->max_range;
                        endforeach;                    
                    else:
                        $info = CI()->Admin_m->find('services', ['id' => $service->services_id]);
                        $modulePrice += $info->max_range;
                    endif;
                    $orderPrice += $service->exp_total_order_val;
                endforeach;

                $percentChange = percentChange($modulePrice, $orderPrice);

                if($percentChange >= -20 && $percentChange < 1):
                    array_push($result, ['y' => 'Order Value', 'a' => 5]);
                elseif($percentChange >= 1 && $percentChange < 11):
                    array_push($result, ['y' => 'Order Value', 'a' => 4]);
                elseif($percentChange < 21 && $percentChange > 10):
                    array_push($result, ['y' => 'Order Value', 'a' => 3]);    
                elseif ($percentChange < 25 && $percentChange > 20):
                    array_push($result, ['y' => 'Order Value', 'a' => 2]);  
                else:
                    array_push($result, ['y' => 'Order Value', 'a' => 0, 'color' => '']);   
                endif;
            endif;
        endif;

        echo json_encode($result);
    }

}