<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Tasks extends Admin_controller {

	
	public function __construct(){
		parent::__construct();
		siteStatus();
       
	}

	static $rules = array(
		'lead_id' =>  array(
                'field' => 'lead_id', 
                'label' => 'Lead', 
                'rules' => 'trim|required'
        ),
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),
    );


	public function index()
	{
		$data['class'] = 'index2';
        $data['page'] = 'crm/leads/task/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function getListData() {

        $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_tasks_query', // Function Name
                'filter', // Query type
                getUserData('supervisor_of')
            );

        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

   			$button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/lead/tasks/preview/'.$list->id).'" data-title="View tasks" data-html="form" data-selector="tasks" title="View">
                	<i class="zmdi zmdi-eye table-icon"></i>
            		</a>';	
            if(getUserData('user_type') != 5):		
			$button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/lead/tasks/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="Comment" data-html="form" data-selector="employee">
						<i class="zmdi zmdi-comment-text table-icon"></i>
					</a>';	
			endif;		

            $no++;
            $row = array();
            $row[] = $list->lead_name;
            $row[] = $list->lead_status_name;
            $row[] = $list->name;
            $row[] = $list->employee_name;
            $row[] = $list->deadline;
            $row[] =  calculate_time_span($list->updated_at);
            $row[] = '<div class="flipswitch" data-toggle="tooltip" data-placement="top" title="Status Change">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-usertype = "'.getUserData('user_type').'" data-href="'.site_url('crm/lead/tasks/status').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' '.(getUserData('is_admin') == 0 ? '': '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Admin_m->findall_datatable('Admin_m', '_get_tasks_query', 'count', getUserData('supervisor_of')),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

	static $rules_add = array(
        'company_website' => array(
                'field'   => 'company_website', 
                'label'   => 'company_website', 
                'rules'   => 'trim|required|is_unique[tasks.company_website]'
        ),
    );

    static $rules_update  = array(
        'company_website' => array(
                'field'   => 'company_website', 
                'label'   => 'company company_website', 
                'rules'   => 'trim|required'
        ),
    );


	public function new_($lead_id= '')
	{
		$input 							= new stdClass();
		
		$input->id 						= '';

		if($_GET){
			$input->lead_id			    = $_GET['lead'];
		} else {
			$input->lead_id			    = ($lead_id ? $lead_id : '');
		}		

		$input->user_id			        = '';
		$input->name 			        = '';
		$input->date 			 		= '';
		$input->deadline 			    = '';
		
		$data['input'] 					= $input;
		$data['detailRowDataList'] 		= array();
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));  

		if(getUserData('is_admin') == 1){
			$data['leads'] = getLead(['leads.status' => 0], true);
		} else {
			$data['leads'] = getLead(['leads.status' => 0,'where_in' => ['leads.km' => $users]], true);
		}		

		$data['users'] = userList(['where_in' => ['users.id' => $users]], true);
		
		$this->load->view('crm/leads/task/form', $data);
	}

	public function edit($id)
	{
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));  
		
		$data['leads'] = getLead([], true);
		
		$data['input'] = $this->Admin_m->find('tasks', array('id' => $id));

		$data['input']->user_id = array();
		//dd($data['input']);

		$users = $this->Admin_m->findAll('task_user', array('task_id' => $data['input']->id));
		
		foreach ($users as $key => $user) {
			array_push($data['input']->user_id, $user->user_id);
		}
		$this->load->view('crm/leads/task/form', $data);
	}

	public function save()
	{
		$id = $this->input->post('id');               //tasks table
		$data = [
			'lead_id'    => $this->input->post('lead_id'),
			'name'       => $this->input->post('name'),
			'deadline' 	 => $this->input->post('deadline'),
			'date' 	     => date('Y-m-d h:i:s'),
		];
		$this->form_validation->set_rules(self::$rules);

      if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
			if(!empty($id)) {
				$this->db->trans_start();
					$this->Admin_m->update('tasks', $data, array('id' => $id));
					$comment = [
						'task_id' => $id,
						'comment' => json_encode(getUserData('fullname').' updated task.'),
						'user_id' => getUserData('user_id')
					];
					$this->Admin_m->save('task_rev', $comment);

					$notification[0] = [
                        'tbl_name'      => 'tasks',
                        'tbl_pk'        => $id,
                        'user_id'       => getUserData('user_id'), 
                        'usertype_id'   => getUserType(getUserData('user_id')), 
                        'title'         => '<strong>'.getUserData('fullname').'</strong> updated '.word_limiter(plainText($data['name']), 10).' task.',
                        'source_url'    => 'crm/lead/tasks/preview/'.$id,
                        'deadline'      => NULL, 
                        'list_class'    => 'info',
                        'created_date'  => date('Y-m-d H:i:sa'),
                    ];

					$currentTaskUser = $this->Admin_m->findAll('task_user', ['task_id' => $id], 'result_array');
					$removedUser = array_diff(array_column($currentTaskUser, 'user_id'), $_POST['user_id']);
					$addedUser = array_diff($_POST['user_id'], array_column($currentTaskUser, 'user_id'));
					if($removedUser):	
						foreach ($removedUser as $key => $value):
							$this->Admin_m->delete('task_user', ['task_id' => $id, 'user_id' => $value]);	
							array_push($notification, [
		                        'tbl_name'      => 'tasks',
		                        'tbl_pk'        => $id,
		                        'user_id'       => $value, 
		                        'usertype_id'   => getUserType($value), 
		                        'title'         => '<strong>'.getUserData('fullname').'</strong> remove '.userList(['users.id' => $value], '', true).' from '.word_limiter(plainText($data['name']), 10).' task.',
		                        'source_url'    => 'crm/lead/tasks/preview/'.$id,
		                        'deadline'      => NULL, 
		                        'list_class'    => 'info',
		                        'created_date'  => date('Y-m-d H:i:sa'),
		                    ]);
						endforeach;
					endif;

					if($addedUser):
						foreach ($addedUser as $key => $value):
							$this->Admin_m->save('task_user', ['task_id' => $id, 'user_id' => $value]);	
							array_push($notification, [
		                        'tbl_name'      => 'tasks',
		                        'tbl_pk'        => $id,
		                        'user_id'       => $value, 
		                        'usertype_id'   => getUserType($value), 
		                        'title'         => '<strong>'.getUserData('fullname').'</strong> added '.userList(['users.id' => $value], '', true).' in '.word_limiter(plainText($data['name']), 10).' task.',
		                        'source_url'    => 'crm/lead/tasks/preview/'.$id,
		                        'deadline'      => NULL, 
		                        'list_class'    => 'info',
		                        'created_date'  => date('Y-m-d H:i:sa'),
		                    ]);
						endforeach;
					endif;	
					$this->Admin_m->save('notifications', $notification, true);

					$message = 'Task successfully updated';	
				$this->db->trans_complete();				
			} else {	
				$this->db->trans_start();
				    $data['created_by'] = getUserData('user_id');
				    $data['date']	= date('Y-m-d H-i-sa');
					$id = $this->Admin_m->save('tasks', $data);

					$comment = [
						'task_id' => $id,
						'comment' => json_encode(getUserData('fullname').' created task.'),
						'user_id' => getUserData('user_id')
					];

					$this->Admin_m->save('task_rev', $comment);

					$notification[0] = [
	                        'tbl_name'      => 'tasks',
	                        'tbl_pk'        => $id,
	                        'user_id'       => getUserData('user_id'), 
	                        'usertype_id'   => getUserType(getUserData('user_id')), 
	                        'title'         => '<strong>'.getUserData('fullname').'</strong> created '.word_limiter(plainText($data['name']), 10).' task.',
	                        'source_url'    => 'crm/lead/tasks/preview/'.$id,
	                        'deadline'      => NULL, 
	                        'list_class'    => 'info',
	                        'created_date'  => date('Y-m-d H:i:sa'),
	                    ];

					foreach($this->input->post('user_id') as $key => $user)
					{
						$taskUser = [
							'task_id' => $id,
							'user_id' => $user,
						];

						$tu_id = $this->Admin_m->save('task_user', $taskUser);

						$notification[$key + 1] = [
	                        'tbl_name'      => 'tasks',
	                        'tbl_pk'        => $id,
	                        'user_id'       => $user, 
	                        'usertype_id'   => getUserType($user), 
	                        'title'         => '<strong>'.getUserData('fullname').'</strong> added '.userList(['users.id' => $user], '', true).' in '.word_limiter(plainText($data['name']), 10).' task.',
	                        'source_url'    => 'crm/lead/tasks/preview/'.$id,
	                        'deadline'      => NULL, 
	                        'list_class'    => 'info',
	                        'created_date'  => date('Y-m-d H:i:sa'),
	                    ];
				    }

				    $this->Admin_m->save('notifications', $notification, true);

					$message = 'Task successfully saved';
				$this->db->trans_complete();
			}
			if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => ($_SERVER['HTTP_REFERER'] === base_url('crm/lead/tasks') ? site_url('crm/lead/tasks') : ''),
                ]; 
            }

            echo json_encode($return);

		}
	}

	
	

	public function status(){

		$this->db->trans_start();
			$id = $this->input->post('id');
			$data['status'] = $this->input->post('status');
			$data['updated_at'] = date('Y-m-d h:i:s');

			$this->Admin_m->update('tasks', $data, array('id' => $id));

			$user = $this->Admin_m->find('employees', array('user_id' => getUserData('user_id')));

			$comment = [
				'task_id' => $id,
				'comment' => 'Task has been '.($data['status'] == 0 ? 'completed' : 'reopened').' by '.$user->first_name.' '.$user->last_name,
				'user_id' => getUserData('user_id')
			];

			$this->Admin_m->save('task_rev', $comment);
		$this->db->trans_complete();	

		if($_SERVER['HTTP_REFERER'] === base_url('hr/management/notebook')):
			$returnData = array('type' => 'save_success', 'class' => 'success', 'message' => 'Status update successfull');
		else:
			$returnData = array('hasError' => 0, 'type' => 'save_success', 'class' => 'success', 'message' => 'Status update successfull');
		endif;

		echo json_encode($returnData);

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('department', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

	public function view($id){

		$data['input'] = $this->Admin_m->findTaskData($id);
		$data['class'] = 'index2';
        $data['page'] = 'crm/leads/task/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}


	public function comment() {
		$this->form_validation->set_rules('comment', 'Comment', 'required');
		
		if($this->form_validation->run() == FALSE) {
		   	$output = array(
				'hasError' 		=> 1, 
				'class' 		=> 'error', 
				'message' 		=> 'Please fix the error!', 
				'detailMessage' => '<div class="alert alert-danger">'.validation_errors('<p style="margin:0">', '</p>').'</div>'
			);
		} else {
			$this->db->trans_start();
			$data = [
				'task_id' => $this->input->post('task_id'),
				'comment' => json_encode($this->input->post('comment')),
				'user_id' => getUserData('user_id')
			];

			$this->Admin_m->save('task_rev', $data);

			$message = 'Comment has been sent';
			$this->db->trans_complete();
			
			if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/lead/tasks/view/'.$data['task_id']),
                ]; 
            }

            echo json_encode($return);
        }
	}

	function reports(){

		$totalTasks = $this->Admin_m->findLeadTasks(['leads.km' => getUserData('user_id')]);

		$lists = $this->Admin_m->findall_datatable(
            'Admin_m', // Model name
            '_get_tasks_query', // Function Name
            'filter'  // Query type                 
        );

       	$data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {
            $no++;
            $row   = array();
            
            $row[] = getLead(['leads.id' => $list->lead_id]);
            $row[] = $list->name;
            $row[] = $list->employee_name;
            $row[] = $list->deadline;
            $data[]= $row;
        }

        $output = array(
            "draw" 				=> $_POST['draw'],
            "recordsTotal" 		=> '',
            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Admin_m', '_get_tasks_query', 'count'),
            "data" 				=> $data,
        );
        
        //output to json format
        echo json_encode($output);
	}

	public function preview($id)
	{
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));  
		
		$data['input'] = $this->Admin_m->findTaskData($id);

		$data['input']->user_id = array();
		$users = $this->Admin_m->findAll('task_user', array('task_id' => $data['input']->id));
		
		foreach ($users as $key => $user) {
			array_push($data['input']->user_id, $user->user_id);
		}
		$data['class'] = 'index2';
        $data['page'] = 'crm/leads/task/preview';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	function report(){

		if($_REQUEST['columns'][0]['search']['value'] || $_REQUEST['columns'][1]['search']['value'] || $_REQUEST['columns'][2]['search']['value'] || $_REQUEST['columns'][3]['search']['value'] || $_REQUEST['columns'][4]['search']['value'] || $_REQUEST['columns'][5]['search']['value']):
			$lists = $this->Admin_m->findall_datatable(
	            'Report_m', // Model name
	            '_get_lead_tasks_query', // Function Name
	            'filter'  // Query type                 
	        );

	       $data = array();
	       //dd($lists);
	        $no = $_POST['start'];

	        foreach ($lists as $key => $list) {

		        if ($list->status == 0) {
	               $status = '<span class="label label-sm label-success  arrowed arrowed-right">Completed</span>';
	            }else{
	               $status = '<span class="label label-sm label-primary arrowed-right arrowed-in">Active</span>';
	            }
	            $no++;
	            $row   = array();
	            
	            $row[] = getLead(['leads.id' => $list->lead_id]);
	            $row[] = $list->lead_status_name;
	            $row[] = $list->name;
	            $row[] = $list->employee_name;
	            $row[] = date('M j-Y', strtotime($list->deadline));
	            $row[] = date('M j,Y',strtotime($list->updated_at));
	            $row[] = $status;
	            $data[]= $row;
	        }

	        $output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Report_m', '_get_lead_tasks_query', 'count'),
	            "data" 				=> $data,
	        );
		else:
			$output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> 0,
	            "data" 				=> [],
	        );
		endif;	
        
        //output to json format
        echo json_encode($output);
	}

	public function savereport(){

        $data['user_id'] = $this->input->post('user_id');
        $data['leadstatus_id'] = $this->input->post('leadstatus_id');
        $data['lead_id'] = $this->input->post('lead_id');
        $data['status'] = $this->input->post('status');
        $data['from_date'] = $this->input->post('from_date');
        $data['to_date'] = $this->input->post('to_date');

        $lists['results'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_lead_tasks_query', // Function Name
                '', // Query type    
                $data        
            );
        
        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('hr/reports/management/pdf/leadtaskreport',$lists);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->set_paper('A4', 'landscape');
        $dompdf->render();
        $dompdf->stream('projectreport_'.date('Ymd').'.pdf',array("Attachment"=>0));
    }

}