<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Projects extends Admin_controller {

    static $model 	= array();
    static $helper	= array();

    public function __construct(){
        parent::__construct();
        siteStatus();
    }

    static $rules = array(
        'workspaces_id' => array(
                'field' => 'workspaces_id', 
                'label' => 'Workspaces', 
                'rules' => 'trim|required'
        ),
        'department_id' => array(
                'field' => 'department_id', 
                'label' => 'Department', 
                'rules' => 'trim|required'
        ),
        'services_id' => array(
                'field' => 'services_id', 
                'label' => 'Services', 
                'rules' => 'trim|required'
        ),
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),
        'description' => array(
                'field' => 'description', 
                'label' => 'Description', 
                'rules' => 'trim|required'
        ),
        'start_date' => array(
                'field' => 'start_date', 
                'label' => 'start_date', 
                'rules' => 'trim|required'
        ),
        'deadline' => array(
                'field' => 'deadline', 
                'label' => 'Deadline', 
                'rules' => 'trim|required'
        ),
        'user_id' => array(
                'field' => 'user_id[]', 
                'label' => 'User', 
                'rules' => 'trim|required'
        ),

    );

	public function index()
	{
		$data['class'] = 'index2';
        $data['page'] = 'crm/workspace/projects/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function new_($callback = '')
	{
		$input = new stdClass();
		$input->id 				= '';
		$input->workspaces_id 	= '';
		$input->department_id 	= '';
		$input->services_id 	= '';
		$input->name 			= '';
		$input->description 	= '';
		$input->privacy 		= '';
		$input->start_date 		= '';
		$input->deadline 		= '';
		$input->user_id 		= '';
		$data['input'] 		= $input;
		$data['callback'] 	= $callback;

		$users = getUserData('supervisor_of');
       	if(getUserData('is_admin') == 1){
        	$data['workspaceList'] = workspaceList(['workspaces.deleted_at =' => NULL]);
	    } 
	    else {
	        $data['workspaceList'] = workspaceList(['workspaces.deleted_at =' => NULL,'where_in' => ['leads.km' => $users]]);
	    }

		$this->load->view('crm/workspace/projects/form', $data);
	}

	public function getListData()
	{
        $lists = $lists = $this->Admin_m->findall_datatable(
	            'Admin_m', // Model name
	            '_get_project_query', // Function Name
	            'filter', // Query type
	            getUserData('supervisor_of') // coditions
	        );

        // echo $this->db->last_query();
        // dd($lists);

        $data = array();
        $no = $_POST['start'];

        foreach ($lists as $key => $list) {
        	$button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/workspace/projects/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="workspaces">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>';
        	if($list->status == 1 && $list->deadline >= date('Y-m-d') && getUserData('user_type') != 5 && getUserData('user_type') != 6):
	        	$button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" data-toggle="modal" data-href="'.site_url('crm/workspace/tasks/new_/'.$list->id).'" data-id="'.$list->id.'" data-target="#exampleModal"  title="Create Task" data-html="form" data-title="Create Task" >
               <i class="zmdi zmdi-storage table-icon"></i>
            </a>';
	        endif;        	

            $no++;
            $row = array();
            $row[] = $list->lead_name;
            $row[] = $list->workspace_name;
            $row[] = $list->department_name;
            $row[] = $list->services_name;
            $row[] = $list->name;
            $row[] = $list->km;
            $row[] = $list->fullname;
            $row[] = $list->start_date;
            $row[] = $list->deadline;
            $row[] = '<div class="flipswitch" data-toggle="tooltip" data-placement="top" title="Status Change">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-usertype = "'.getUserData('user_type').'" data-href="'.site_url('crm/workspace/projects/status').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
	        $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $lists = $lists = $this->Admin_m->findall_datatable('Admin_m', '_get_project_query', 'count', getUserData('supervisor_of')),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->find('projects', array('id' => $id));
		$data['input']->user_id = array();
		
		$users = $this->Admin_m->findAll('project_user', array('project_id' => $data['input']->id));
		
		foreach ($users as $key => $user) {
			array_push($data['input']->user_id, $user->user_id);
		}

		$data['workspaceList'] = workspaceList(['workspaces.deleted_at =' => NULL]);

        $this->load->view('crm/workspace/projects/form', $data);
		
	}

	public function save()
	{
		$id	= $this->input->post('id');
		$data['workspaces_id']  = $this->input->post('workspaces_id');		
		$data['services_id']    = $this->input->post('services_id');		
		$data['department_id']  = $this->input->post('department_id');		
		$data['name']           = $this->input->post('name');		
		$data['description']    = $this->input->post('description');
		$data['start_date']     = $this->input->post('start_date');
		$data['deadline']       = $this->input->post('deadline');
		$data['privacy']        = 'members';
		$users                  = $this->input->post('user_id');	
		$this->form_validation->set_rules(self::$rules);
		if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
			$this->db->trans_start();
				if(!empty($id)) {
					$this->Admin_m->update('projects', $data, array('id' => $id));
					$notification[0] = [
                        'tbl_name'      => 'projects',
                        'tbl_pk'        => $id,
                        'user_id'       => getUserData('user_id'), 
                        'usertype_id'   => getUserType(getUserData('user_id')), 
                        'title'         => '<strong>'.getUserData('fullname').'</strong> updated project.',
                        'source_url'    => 'crm/workspace/projects/view/'.$id,
                        'deadline'      => NULL, 
                        'list_class'    => 'info',
                        'created_date'  => date('Y-m-d H:i:sa'),
                    ];

					$currentProjectUser = $this->Admin_m->findAll('project_user', ['project_id' => $id], 'result_array');
					$removedUser = array_diff(array_column($currentProjectUser, 'user_id'), $_POST['user_id']);
					$addedUser = array_diff($_POST['user_id'], array_column($currentProjectUser, 'user_id'));
					if ($removedUser) {
						foreach ($removedUser as $key => $value) {
							$this->Admin_m->delete('project_user', ['project_id' => $id, 'user_id' => $value]);

						array_push($notification, [
		                        'tbl_name'      => 'projects',
		                        'tbl_pk'        => $id,
		                        'user_id'       => $value, 
		                        'usertype_id'   => getUserType($value), 
		                        'title'         => '<strong>'.getUserData('fullname').'</strong> removed '.userList(['users.id' => $value], '', true).' from '.word_limiter(plainText($data['name']), 10).' Project.',
		                        'source_url'    => 'crm/workspace/projects/view/'.$id,
		                        'deadline'      => NULL, 
		                        'list_class'    => 'info',
		                        'created_date'  => date('Y-m-d H:i:sa'),
		                    ]);
						}
					}
					if ($addedUser) {
						foreach($addedUser as $key => $user)
						{
							$projectUser = [
								'project_id'   => $id,
								'user_id'	   => $user
							];

							array_push($notification, [
		                        'tbl_name'      => 'projects',
		                        'tbl_pk'        => $id,
		                        'user_id'       => $user, 
		                        'usertype_id'   => getUserType($user), 
		                        'title'         => '<strong>'.getUserData('fullname').'</strong> added '.userList(['users.id' => $user], '', true).' in '.word_limiter(plainText($data['name']), 10).' Project.',
		                        'source_url'    => 'crm/workspace/projects/view/'.$id,
		                        'deadline'      => NULL, 
		                        'list_class'    => 'info',
		                        'created_date'  => date('Y-m-d H:i:sa'),
		                    ]);

							$this->Admin_m->save('project_user', $projectUser);
					    }
					}

					$this->Admin_m->save('notifications', $notification, true);

					$message = 'Project successfully updated';	

				} else {	
					$data['created_by'] = getUserData('user_id');
					$data['created_at'] = date('Y-m-d h:i:s');
					$saveid	= $this->Admin_m->save('projects', $data);

				$notification[0] = [
		            'tbl_name'      => 'projects',
		            'tbl_pk'        => $saveid,
		            'user_id'       => getUserData('user_id'), 
		            'usertype_id'   => getUserData('user_type'),
		            'title'         => '<strong>'.getUserData('fullname').' '.word_limiter(plainText($data['name']), 10).'</strong> Project Created',
		            'source_url'    => 'crm/workspace/projects/view/'.$saveid,
		            'deadline'      => NULL, 
		            'list_class'    => 'info',
		            'created_date'  => date('Y-m-d H:i:sa'),
		        ];

					foreach ($users as $key => $user) {
						$list = [
							'project_id' => $saveid,
							'user_id'    => $user,
							'created_by' => getUserData('user_id'),
							'created_at' => date('Y-m-d h:i:s')
						];
						$this->Admin_m->save('project_user', $list);

						$notification[$key + 1] = [
	                        'tbl_name'      => 'projects',
	                        'tbl_pk'        => $saveid,
	                        'user_id'       => $user, 
	                        'usertype_id'   => getUserType($user), 
	                        'title'         => '<strong>'.getUserData('fullname').'</strong> added '.userList(['users.id' => $user], '', true).' in '.word_limiter(plainText($data['name']), 10).' Project.',
	                        'source_url'    => 'crm/workspace/projects/view/'.$saveid,
	                        'deadline'      => NULL, 
	                        'list_class'    => 'info',
	                        'created_date'  => date('Y-m-d H:i:sa'),
	                    ];						
					}

					$message = 'Project created';
				    $this->Admin_m->save('notifications', $notification, true);
				}
				
			$this->db->trans_complete();

			if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/workspace/projects/'),
                ]; 
            }

            echo json_encode($return);

		}
		
	}

	public function status(){
		$id = $this->input->post('id');
		$data['status'] = $this->input->post('status');
		$data['updated_at'] = date('Y-m-d h:i:s');
		$this->db->trans_start();			

			if($data['status'] == 0):
				$tasks = $this->Admin_m->findAll('tasks', array('project_id' => $id, 'status' => 1));			

				if($tasks):
					foreach ($tasks as $key => $task):
						$this->Admin_m->update('tasks', $data, array('id' => $task->id));					
					endforeach;
				endif;
			endif;

			$this->Admin_m->update('projects', $data, array('id' => $id));
			
			$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Status update successfull', 'detailMessage' => '');

			echo json_encode($returnData);
		$this->db->trans_complete();

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('workspaces', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

	public function view($id)
	{

	 	$data['input'] = $this->Admin_m->viewProjectInfo($id);
		$data['class'] = 'index2';
        $data['page'] = 'crm/workspace/projects/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}

	public function getProjectUser(){
		$users = $this->Admin_m->findAll('project_user', array('project_id' => $this->input->post('project_id')));

		$html = '';
		if($users){
			foreach ($users as $key => $user) {
				$html .= '<option value="'.$user->user_id.'">'.userList(['employees.user_id' => $user->user_id], false, true).'</option>';
			}
		}
		
		echo $html;
	}

		function report(){
			if($_REQUEST['columns'][0]['search']['value'] || $_REQUEST['columns'][1]['search']['value'] || $_REQUEST['columns'][2]['search']['value'] || $_REQUEST['columns'][3]['search']['value'] || $_REQUEST['columns'][4]['search']['value'] || $_REQUEST['columns'][5]['search']['value']):
			$lists = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_project_query', // Function Name
                'filter'  // Query type                 
            );
           $data = array();
	        $no = $_POST['start'];

	        foreach ($lists as $key => $list) {

		        if ($list->status == 0) {
	               $status = '<span class="label label-sm label-success  arrowed arrowed-right">Completed</span>';
	            }else{
	               $status = '<span class="label label-sm label-primary arrowed-right arrowed-in">Active</span>';
	            }
	            $no++;
	            $row   = array();
	            
	            $row[] = $list->name;
	            $row[] = $list->workspace_name;
	            $row[] = $list->department_name;
	            $row[] = $list->services_name;
	            $row[] = $list->name;
	            $row[] = $list->km;
	           	$row[] = $status;
	            $row[] = date('M j-Y', strtotime($list->deadline));
	            $row[] = date('M j-Y', strtotime($list->deadline));
	            $data[]= $row;
	        }
	        $output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Report_m', '_get_project_query', 'count'),
	            "data" 				=> $data,
	        );
	        else:
	        $output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> 0,
	            "data" 				=> [],
	        );
	        endif;
	        //output to json format
	        echo json_encode($output);
		}

		public function savereport(){
        $data['lead_id'] = $this->input->post('lead_id');
        $data['id'] = $this->input->post('id');
        $data['services_id'] = $this->input->post('services_id');
        $data['status'] = $this->input->post('status');
        $data['from_date'] = $this->input->post('from_date');
        $data['to_date'] = $this->input->post('to_date');

        $lists['results'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_project_query', // Function Name
                '', // Query type    
                $data        
            );
       	//dd($lists['results']);
       	$options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('hr/reports/management/pdf/projectreport',$lists);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->set_paper('A4', 'landscape');
        $dompdf->render();
        $dompdf->stream('projectreport_'.date('Ymd').'.pdf',array("Attachment"=>0));
        
    }

}