<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Tasks extends Admin_controller {

	static $model 	= array();
	static $helper	= array();
	
	public function __construct(){
		parent::__construct();
		siteStatus();
		$this->load->helper('smiley');
		//$this->load->library('Dompdf_gen');
	}

	static $rules = array(
        'project_id' => array(
                'field'   => 'project_id', 
                'label'   => 'Project', 
                'rules'   => 'trim|required'
        ),
        'name' => array(
                'field'   => 'name', 
                'label'   => 'Project', 
                'rules'   => 'trim|required'
        ),
        'deadline' => array(
                'field'   => 'deadline', 
                'label'   => 'Deadline', 
                'rules'   => 'trim|required'
        ),
    );


	public function index()
	{
		$data['class'] = 'index2';
        $data['page'] = 'crm/workspace/task/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function getListData(){

        $users = $this->Admin_m->myAssistants(getUserData('user_id'));
        //dd($users);

        $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_work_tasks_query', // Function Name
                'filter', // Query type
                $users // coditions
            );

        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

        	$button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/workspace/tasks/preview/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="employee">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>';
			if(getUserData('user_type') != 5):						
			$button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/workspace/tasks/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="Comment" data-html="form" data-selector="employee">
               <i class="zmdi zmdi-comment-text table-icon"></i>
            </a>';
			endif;		

            $no++;
            $row = array();
            $row[] = $list->leads_name;
            $row[] = $list->workspaces_name;
            $row[] = $list->projects_name;
            $row[] = $list->name;
            $row[] = $list->km;
            $row[] = $list->deadline;
            $row[] = $list->created_employee;
            $row[] = '<div class="flipswitch" data-toggle="tooltip" data-placement="top" title="Status Change">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-usertype = "'.getUserData('user_type').'" data-href="'.site_url('crm/workspace/tasks/status').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Admin_m->findall_datatable('Admin_m', '_get_work_tasks_query', 'count', $users),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

	public function new_($project_id = '')
	{
		$input 							= new stdClass();
		
		$input->id 						= '';
		$input->project_id			    = ($project_id ? $project_id : '');
		$input->lead_id			        = '';
		$input->user_id			        = '';
		$input->name 			        = '';
		$input->date 			 		= '';
		$input->deadline 			    = '';
		$input->description 			= '';
		
		$data['input'] 					= $input;
		$data['detailRowDataList'] 		= array();

		if($_GET){

			$data['projectList'] = projectList(['workspaces.lead_id' => $_GET['client'],'project_user.user_id' => getUserData('user_id')]);
		} else {
			$data['projectList'] = projectList(($input->id ? [] : (getUserData('is_admin') == 1 ? [] : ['project_user.user_id' => getUserData('user_id')])));	
		}
		$data['users'] = ($project_id ? projectUserList(array('project_id' => $project_id)) : userList([], true));
        $this->load->view('crm/workspace/task/form', $data);
		
	}

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->find('tasks', array('id' => $id));
		$data['projectList'] = projectList(($data['input']->id ? [] : ['project_user.user_id' => getUserData('user_id')]));
		$data['users'] = projectUserList(array('project_id' => $data['input']->project_id));
		$data['input']->user_id = array();
		$users = $this->Admin_m->findAll('task_user', array('task_id' => $data['input']->id));
		if($data['input']->project_id){
			$tuser = taskUserList(['task_id' => $id]);
			foreach ($tuser as $key => $tu) {
				$data['users'][$key] = $tu;
			}	
		}
		foreach ($users as $key => $user) {
			array_push($data['input']->user_id, $user->user_id);
		}
		$this->load->view('crm/workspace/task/form', $data);
		
	}

	public function save()
	{
		$this->form_validation->set_rules(self::$rules);
		
		if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {

			$id = $this->input->post('id');               //tasks table
			$data = [
				'project_id' => $this->input->post('project_id'),
				'name'       => $this->input->post('name'),
				'lead_id'	 => ($this->input->post('lead_id') ? $this->input->post('lead_id') : getProjectToLeadID($this->input->post('project_id'))),
				'description'=> $this->input->post('description'),
				'deadline' 	 => $this->input->post('deadline'),
			];
			
			$user = $this->Admin_m->find('employees', array('user_id' => getUserData('user_id')));
			if(!empty($id)) {
				$this->db->trans_start();
					$data['updated_at']	= getUserData('user_id');
				    $data['updated_by']		= date('Y-m-d H-i-s');
					$this->Admin_m->update('tasks', $data, array('id' => $id));

					$comment = [
						'task_id' => $id,
						'comment' => $user->first_name.' '.$user->last_name.' updated task.',
						'user_id' => getUserData('user_id')
					];

					$this->Admin_m->save('task_rev', $comment);
					$notification[0] = [
                        'tbl_name'      => 'tasks',
                        'tbl_pk'        => $id,
                        'user_id'       => getUserData('user_id'), 
                        'usertype_id'   => getUserType(getUserData('user_id')), 
                        'title'         => '<strong>'.getUserData('fullname').'</strong> updated '.word_limiter(plainText($data['name']), 10).' task.',
                        'source_url'    => 'crm/workspace/tasks/preview/'.$id,
                        'deadline'      => NULL, 
                        'list_class'    => 'info',
                        'created_date'  => date('Y-m-d H:i:sa'),
                    ];

					$currentTaskUser = $this->Admin_m->findAll('task_user', ['task_id' => $id], 'result_array');
					$removedUser = array_diff(array_column($currentTaskUser, 'user_id'), $_POST['user_id']);
					$addedUser = array_diff($_POST['user_id'], array_column($currentTaskUser, 'user_id'));
					if($removedUser):
						foreach ($removedUser as $key => $value):
							$this->Admin_m->delete('task_user', ['task_id' => $id, 'user_id' => $value]);
							array_push($notification, [
		                        'tbl_name'      => 'tasks',
		                        'tbl_pk'        => $id,
		                        'user_id'       => $value, 
		                        'usertype_id'   => getUserType($value), 
		                        'title'         => '<strong>'.getUserData('fullname').'</strong> removed '.userList(['users.id' => $value], '', true).' from '.word_limiter(plainText($data['name']), 10).' task.',
		                        'source_url'    => 'crm/workspace/tasks/preview/'.$id,
		                        'deadline'      => NULL, 
		                        'list_class'    => 'info',
		                        'created_date'  => date('Y-m-d H:i:sa'),
		                    ]);
						endforeach;
					endif;	

					if($addedUser):
						foreach($addedUser as $key => $user):
							$taskUser = [
								'task_id' => $id,
								'user_id'	   => $user
							];

							array_push($notification, [
		                        'tbl_name'      => 'tasks',
		                        'tbl_pk'        => $id,
		                        'user_id'       => $user, 
		                        'usertype_id'   => getUserType($user), 
		                        'title'         => '<strong>'.getUserData('fullname').'</strong> added '.userList(['users.id' => $user], '', true).' in '.word_limiter(plainText($data['name']), 10).' task.',
		                        'source_url'    => 'crm/workspace/tasks/preview/'.$id,
		                        'deadline'      => NULL, 
		                        'list_class'    => 'info',
		                        'created_date'  => date('Y-m-d H:i:sa'),
		                    ]);

							$this->Admin_m->save('task_user', $taskUser);
					    endforeach;
					endif;    
					$this->Admin_m->save('notifications', $notification, true);

					$message = 'Task successfully updated';	
				$this->db->trans_complete();				
			} else {	
				$this->db->trans_start();
					$data['created_by']	= getUserData('user_id');
				    $data['date']		= date('Y-m-d H-i-s');
					$data['id'] 		= $this->Admin_m->save('tasks', $data);

					$comment = [
						'task_id' => $data['id'],
						'comment' => $user->first_name.' '.$user->last_name.' created task.',
						'user_id' => getUserData('user_id')
					];

					$this->Admin_m->save('task_rev', $comment);
					$notification[0] = [
	                        'tbl_name'      => 'tasks',
	                        'tbl_pk'        => $id,
	                        'user_id'       => getUserData('user_id'), 
	                        'usertype_id'   => getUserType(getUserData('user_id')), 
	                        'title'         => '<strong>'.getUserData('fullname').'</strong> created '.word_limiter(plainText($data['name']), 10).' task.',
	                        'source_url'    => 'crm/workspace/tasks/preview/'.$data['id'],
	                        'deadline'      => NULL, 
	                        'list_class'    => 'info',
	                        'created_date'  => date('Y-m-d H:i:sa'),
	                    ];

					foreach($this->input->post('user_id') as $key => $user)
					{
						$taskUser = [
							'task_id' => $data['id'],
							'user_id'	   => $user,
						];

						$notification[$key + 1] = [
	                        'tbl_name'      => 'tasks',
	                        'tbl_pk'        => $id,
	                        'user_id'       => $user, 
	                        'usertype_id'   => getUserType($user), 
	                        'title'         => '<strong>'.getUserData('fullname').'</strong> added '.userList(['users.id' => $user], '', true).' in '.word_limiter(plainText($data['name']), 10).' task.',
	                        'source_url'    => 'crm/workspace/tasks/preview/'.$data['id'],
	                        'deadline'      => NULL, 
	                        'list_class'    => 'info',
	                        'created_date'  => date('Y-m-d H:i:sa'),
	                    ];

					$this->Admin_m->save('task_user', $taskUser);	
				    }
				    $this->Admin_m->save('notifications', $notification, true);

					$message = 'Task successfully saved';
				$this->db->trans_complete();
			}
			if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => ($_SERVER['HTTP_REFERER'] === base_url('crm/workspace/tasks') ? site_url('crm/workspace/tasks') : '')
                ]; 
            }

            echo json_encode($return);
		}
	
	}

	public function status(){

		$this->db->trans_start();
			$id = $this->input->post('id');
			$data['status'] = $this->input->post('status');
			$data['updated_at'] = date('Y-m-d h:i:s');

			$this->Admin_m->update('tasks', $data, array('id' => $id));

			$user = $this->Admin_m->find('employees', array('user_id' => getUserData('user_id')));

			$comment = [
				'task_id' => $id,
				'comment' => 'Task has been '.($data['status'] == 0 ? 'completed' : 'reopened').' by '.$user->first_name.' '.$user->last_name,
				'user_id' => getUserData('user_id')
			];

			$this->Admin_m->save('task_rev', $comment);
		$this->db->trans_complete();	

		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Status update successfull', 'detailMessage' => '');

		echo json_encode($returnData);

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('department', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

	public function view($id){
		$data['input'] = $this->Admin_m->findWorkTaskData($id);
		$data['class'] = 'index2';
        $data['page'] = 'crm/workspace/task/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}


	public function comment() {
		
		$this->form_validation->set_rules('comment', 'Comment', 'required');
        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($_POST as $key => $value):
                if($value === ''):
                    $return['message'][str_replace("[]","",$key)] = ucfirst($key).' field is required!';
                endif;
            endforeach;
            echo json_encode($return);
		} else {
			 $this->db->trans_start();

			$data = [
				'task_id' => $this->input->post('task_id'),
				'comment' => json_encode($this->input->post('comment')),
				'user_id' => getUserData('user_id')
			];

			$this->Admin_m->save('task_rev', $data);
			$message = 'Comment has been Posted';

		$this->db->trans_complete();
		    if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('crm/workspace/tasks/view/'.$data['task_id']),
                ]; 
            }

            echo json_encode($return);
        }
	}

	public function preview($id)
	{
		$data['project_task'] = $this->Admin_m->findWorkTaskData($id);
		$data['input'] = $this->Admin_m->find('tasks', array('id' => $id));
		$data['projectList'] = projectList(($data['input']->id ? [] : ['project_user.user_id' => getUserData('user_id')]));
		$data['users'] = projectUserList(array('project_id' => $data['input']->project_id));
		$data['input'] = $this->Admin_m->find('tasks', array('id' => $id));

		$data['input']->user_id = array();
		$users = $this->Admin_m->findAll('task_user', array('task_id' => $data['input']->id));
		
		foreach ($users as $key => $user) {
			array_push($data['input']->user_id, $user->user_id);
		}
		$data['class'] = 'index2';
        $data['page'] = 'crm/workspace/task/preview';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	function reports(){

		$lists = $this->Admin_m->findall_datatable(
	            'Admin_m', // Model name
	            '_get_work_tasks_query', // Function Name
	            'filter'  // Query type                 
	        );

	       	$data = array();
	       	
	        $no = $_POST['start'];

	        foreach ($lists as $key => $list) {

		        if ($list->status == 0) {
	               $status = '<span class="label label-sm label-success  arrowed arrowed-right">Completed</span>';
	            }else{
	               $status = '<span class="label label-sm label-primary arrowed-right arrowed-in">Active</span>';
	            }
	            $no++;
	            $row   = array();
	            
	            $row[] = $list->lead_name;
	            $row[] = $list->workspaces_name;
                $row[] = $list->projects_name;
                $row[] = $list->name;
                $row[] = $list->km;
	            $row[] = $list->deadline;
	            $row[] = $status;
	            $data[]= $row;
	        }

	        $output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Admin_m', '_get_work_tasks_query', 'count'),
	            "data" 				=> $data,
	        );
        
        //output to json format
        echo json_encode($output);
	}

	function report(){

		if($_REQUEST['columns'][0]['search']['value'] || $_REQUEST['columns'][1]['search']['value'] || $_REQUEST['columns'][2]['search']['value'] || $_REQUEST['columns'][3]['search']['value']):
			$lists = $this->Admin_m->findall_datatable(
	            'Report_m', // Model name
	            '_get_work_tasks_query', // Function Name
	            'filter'  // Query type                
	        );

	       $data = array();
	       // 	echo $this->db->last_query();
	       //dd($lists);
	        $no = $_POST['start'];

	        foreach ($lists as $key => $list) {

		        if ($list->status == 0) {
	               $status = '<span class="label label-sm label-success  arrowed arrowed-right">Completed</span>';
	            }else{
	               $status = '<span class="label label-sm label-primary arrowed-right arrowed-in">Active</span>';
	            }
	            $no++;
	            $row   = array();
	            
	            $row[] = $list->workspaces_name;
	            $row[] = $list->projects_name;
                $row[] = $list->name;
                $row[] = $list->km;
                $row[] = $list->employee_name;
	            $row[] = $list->deadline;
	            $row[] = $status;
	            $data[]= $row;
	        }

	        $output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> $this->Admin_m->findall_datatable('Report_m', '_get_work_tasks_query', 'count'),
	            "data" 				=> $data,
	        );
		else:
			$output = array(
	            "draw" 				=> $_POST['draw'],
	            "recordsTotal" 		=> '',
	            "recordsFiltered" 	=> 0,
	            "data" 				=> [],
	        );
		endif;	
        
        //output to json format
        echo json_encode($output);
	}

	public function savereport(){
        $data['lead_id'] = $this->input->post('lead_id');
        $data['status'] = $this->input->post('status');
        $data['from_date'] = $this->input->post('from_date');
        $data['to_date'] = $this->input->post('to_date');

        $lists['results'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_work_tasks_query', // Function Name
                '', // Query type    
                $data        
            );
       	//dd($lists['results']);
       	$options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('hr/reports/management/pdf/projecttasksreport',$lists);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->set_paper('A4', 'landscape');
        $dompdf->render();
        $dompdf->stream('projectreport_'.date('Ymd').'.pdf',array("Attachment"=>0));

    }

}