<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Workspace extends Admin_controller {

    static $model 	= array();
    static $helper	= array('file');

    public function __construct(){
        parent::__construct();
        siteStatus();

    }

    static $rules = array(
    	'workorder_no' => array(
                'field' => 'workorder_no', 
                'label' => 'Workorder No', 
                'rules' => 'trim|required'
        ),
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),
        'agreement_date' => array(
                'field' => 'agreement_date', 
                'label' => 'Agreement Date', 
                'rules' => 'trim|required'
        ),

        'client_id' => array(
                'field' => 'client_id', 
                'label' => 'Client', 
                'rules' => 'trim|required'
        ),

       'servicesid' => array(
                'field' => 'services_id[]', 
                'label' => 'Service', 
                'rules' => 'trim|required'
        ),
       'servicesid' => array(
                'field' => 'servicesid[]', 
                'label' => 'Service', 
                'rules' => 'trim|required'
        ),
       'service_cost'   => array(
                'field' => 'service_cost[]', 
                'label' => 'Service cost', 
                'rules' => 'trim|required'
        ),
       'task'   => array(
                'field' => 'task[]', 
                'label' => 'Task', 
                'rules' => 'trim|required'
        ),
       'description'   => array(
                'field' => 'description[]', 
                'label' => 'Description', 
                'rules' => 'trim|required'
        ),

       'department_id' => array(
                'field' => 'department_id[]', 
                'label' => 'Department', 
                'rules' => 'trim|required'
        ),
       'start_date'   => array(
                'field' => 'start_date[]', 
                'label' => 'Start Date', 
                'rules' => 'trim|required'
        ),
       'deadline'   => array(
                'field' => 'deadline[]', 
                'label' => 'Deadline', 
                'rules' => 'trim|required'
        ),
    );

    static $subrules = array(
    	'workorder_no' => array(
                'field' => 'workorder_no', 
                'label' => 'Workorder No', 
                'rules' => 'trim|required'
        ),
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),

        'client_id' => array(
                'field' => 'client_id', 
                'label' => 'Client', 
                'rules' => 'trim|required'
        ),

       'department_id' => array(
                'field' => 'department_id[]', 
                'label' => 'Department', 
                'rules' => 'trim|required'
        ),
       'start_date'   => array(
                'field' => 'start_date[]', 
                'label' => 'Start Date', 
                'rules' => 'trim|required'
        ),
       'deadline'   => array(
                'field' => 'deadline[]', 
                'label' => 'Deadline', 
                'rules' => 'trim|required'
        ),
    );

    static $rulesWorkBill = array(
    	'workspace_id' =>  array(
                'field' => 'workspace_id', 
                'label' => 'Workspaces', 
                'rules' => 'trim|required'
        ), 
        'ammount' => array(
                'field' => 'ammount', 
                'label' => 'Ammount', 
                'rules' => 'trim|required'
        ),
        'date' => array(
                'field' => 'date', 
                'label' => 'Date', 
                'rules' => 'trim|required'
        ),
    );

	public function index()
	{

        $data['class'] = 'index2';
        $data['page'] = 'crm/workspace/workspace/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
		
	}

	public function new_($callback = '',$workorder_no = '')
	{
		$input = new stdClass();
		$input->id 	    		= '';
		$input->work_id 	    = '';
		$input->workorder_no  	= '';
		$input->workorder_no    = ($workorder_no ? $workorder_no : '');
		$input->lead_id 	 	= '';
		$input->sub_order 	 	= '';
		$input->name 		 	= '';
		$input->agreement_date 	= '';
		$input->comment 		= '';
		$input->total_ammount	= '';
		$input->upload  		= '';
		$input->ammount  		= '';
		$input->date  	    	= '';
		$input->note  	    	= '';

		$input->services_id		= '';
		$input->department_id	= '';
		$input->deadline  		= '';
		$input->start_date      = '';
		$input->description     = '';
		$input->task            = '';
		$input->cost_breakdown  = '';
		$input->workorder_payment      = '';
		$input->projects      = '';


		$data['input'] 		 	= $input;

		$data['workorder']      = getWorkspace(['workspaces.sub_order' => NULL, 'where_in' => ['leads.km' => $this->Admin_m->myAssistants(getUserData('user_id'))]], true);    
	
		$data['callback'] 	 	= $callback;

		$users = $this->Admin_m->myAssistants(getUserData('user_id'));
       	if(getUserData('is_admin') == 1){
        	$data['leads'] = getClient(['leads.status' => 1], true);
	    } 
	    else {
	        $data['leads'] = getClient(['leads.status' => 1 ,'where_in' => ['leads.km' => $users]], true);
	    }
        $data['class'] = 'index2';
        $data['page'] = 'crm/workspace/workspace/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}

	public function getListData(){
		$users = $this->Admin_m->myAssistants(getUserData('user_id'));

		if(getUserData('is_admin') == 1){
			$where = ['workspaces.deleted_at =' => NULL];			
		} else {
			$where = ['workspaces.deleted_at =' => NULL,'where_in' => ['leads.km' => $users]];				
		}

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_workspace_query', // Function Name
                'filter', // Query type
                $where // coditions
            );

        $data = array();
        $no = $_POST['start'];
        foreach ($lists as $key => $list) {
            $button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/workspace/workspace/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="workspaces">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>';

            if(getUserData('user_type') != 5 && getUserData('user_type') != 6 && $list->sub_order == NULL):

                $button .= ' <a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" data-toggle="modal" data-target="#exampleModal" data-title="Work Bill" data-href="'.site_url('crm/workspace/workspace/workbill/'.$list->id).'" data-id="'.$list->id.'" data-html="form" data-selector="add" data-toggle="tooltip" data-placement="top" title="Work Bill">
                    <i class="zmdi zmdi-money table-icon"></i>
                </a> ';

	            $button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('crm/workspace/workspace/workbillprint/'.$list->id).'" data-title="Money Receipt" title="Money Receipt" data-html="form" data-selector="billtype">
	               <i class="zmdi zmdi-money-box table-icon"></i>
	            </a>';
		    endif;

            $no++;
            $row = array();
            $row[] = $list->workspace_name;
            $row[] = $list->client_name;
            $row[] = $list->km;
            $row[] = $button;
            $data[] = $row;
        }
        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_workspace_query', // Function Name
                'count',
                $where // coditions
            ),
            "data"              => $data,
        );
        //output to json format
        echo json_encode($output);
    }

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->findworkspace($id); 
		$data['workorder']      = getWorkspace(['workspaces.sub_order' => NULL, 'where_in' => ['leads.km' => $this->Admin_m->myAssistants(getUserData('user_id'))]], true);    
	
	//	$data['callback'] 	 	= $callback;

		$users = $this->Admin_m->myAssistants(getUserData('user_id'));
       	if(getUserData('is_admin') == 1){
        	$data['leads'] = getClient(['leads.status' => 1], true);
	    } 
	    else {
	        $data['leads'] = getClient(['leads.status' => 1 ,'where_in' => ['leads.km' => $users]], true);
	    }
        $data['class'] = 'index2';
        $data['page'] = 'crm/workspace/workspace/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function save()
	{
		$id	                   = $this->input->post('id');	
		$ammount               = $this->input->post('ammount');
		$note                  = $this->input->post('note');
        $date                  = $this->input->post('date');
        $sub_order             = $this->input->post('sub_order');

        if($sub_order) {
            $this->form_validation->set_rules(self::$subrules);
        } else {
            $this->form_validation->set_rules(self::$rules);
        }   
        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace('[]', '', $key)] = $value;
            }
            echo json_encode($return);
        }

         else {

			$this->db->trans_start();

				$workspaces = [
	                'lead_id'         => $this->input->post('client_id'),
	                'workorder_no'    => $this->input->post('workorder_no'),
	                'name'            => $this->input->post('name'),
	                'agreement_date'  => $this->input->post('agreement_date'),
	                'upload'          => $this->input->post('upload'),
	                'comment'         => $this->input->post('comment'),
	            ];

	            if(!empty($id)) {

		            $workspaces['updated_by'] = getUserData('user_id');
		            $workspaces['created_at'] = date('Y-m-d H:i:s');
	            	$this->Admin_m->update('workspaces', $workspaces, array('id' => $id));
	            	$saveid = $id;
		        } else {
		        	$workspaces['created_by'] = getUserData('user_id');
		            $workspaces['created_at'] = date('Y-m-d H:i:s');
					$saveid = $this->Admin_m->save('workspaces', $workspaces);
		        };

                foreach ($this->input->post('servicesid') as $s => $service) {
                    $workorder_cost_breakdown = [  
                    	'workspace_id' => $saveid,
                        'quantity'     =>  $this->input->post('quantity')[$s],                     
                        'unit_price'   =>  $this->input->post('unit_price')[$s],                     
                        'service_cost'  =>  $this->input->post('service_cost')[$s],                     
	                    'created_by'    => getUserData('user_id'),
				        'created_at'    => date('Y-m-d h:i:s')
                    ];
                    if (is_numeric($service)) {
					    $workorder_cost_breakdown['service_id']  = $service;
				    } else {
					    $workorder_cost_breakdown['other'] = $service;
					};
					if($this->input->post('cost_breakdown_id')[$s]){

						$this->Admin_m->update('workorder_cost_breakdown', $workorder_cost_breakdown, array('id' => $this->input->post('cost_breakdown_id')[$s]));
					} else {
						$this->Admin_m->save('workorder_cost_breakdown', $workorder_cost_breakdown);
					}
                }

               	foreach ($ammount as $key => $ammount) {
                    $workorder_payment = [
                        'ammount'       => $ammount,
                        'workspace_id'	=> $saveid,
	                    'date'          => $date[$key]	,
	                    'note'          => $note[$key] ,
	                    'created_by'    => getUserData('user_id'),
				        'created_at'    => date('Y-m-d h:i:s')
                    ];

                    if($this->input->post('workorder_payment_id')[$key]){
                    	$workorder_payment['updated_by'] = getUserData('user_id');
                    	$workorder_payment['updated_at'] = date('Y-m-d h:i:s');
                    	$this->Admin_m->update('workorder_payment', $workorder_payment, array('id' => $this->input->post('workorder_payment_id')[$key]));
                    } else {
                    	$workorder_payment['created_by'] = getUserData('user_id');
                    	$workorder_payment['created_at'] = date('Y-m-d h:i:s');
                    	$this->Admin_m->save('workorder_payment', $workorder_payment);	
                    }                    
                }

                foreach ($this->input->post('task') as $key => $name) {
                    $projects = [
                    	'name'          => $name,
                        'workspaces_id'	=> $saveid,
	                    'department_id' => $this->input->post('department_id')[$key],
	                    'services_id'   => $this->input->post('services_id')[$key],
	                    'description'   => $this->input->post('description')[$key],
	                    'start_date'    => $this->input->post('start_date')[$key],
	                    'deadline'      => $this->input->post('deadline')[$key],
                    ];

                    if($this->input->post('projects_id')[$key]){

                    	$projects['updated_by'] = getUserData('user_id');
                    	$projects['updated_at'] = date('Y-m-d h:i:s');
                    	$this->Admin_m->update('projects', $projects, array('id' => $this->input->post('projects_id')[$key]));
                    	
                    } else {
                    	$projects['created_by'] = getUserData('user_id');
                    	$projects['created_at'] = date('Y-m-d h:i:s');
                    	$this->Admin_m->save('projects', $projects);
                    }
				}

				$notification = [
		            'tbl_name'      => 'workspaces',
		            'tbl_pk'        => $saveid,
		            'user_id'       => getUserData('user_id'), 
		            'usertype_id'   => getUserData('user_type'),
		            'title'         => '<strong>'.getUserData('fullname').' '.($id ? 'update ' : 'create ').word_limiter(plainText($workspaces['name']), 10).'</strong> Workspace Created',
		            'source_url'    => 'crm/workspace/workspace/view/'.$saveid,
		            'deadline'      => NULL, 
		            'list_class'    => 'info',
		            'created_date'  => date('Y-m-d H:i:sa'),
		        ];
	        	$this->Admin_m->save('notifications', $notification);

				if(!empty($id)) {
					$message = 'Workspace Update successfull';
			    } else {
			      	$message = 'Workspace save successfull';			        	
			    };
				
			$this->db->trans_complete();
            if ($this->db->trans_status() === FALSE) {
            $return = [
                'type' => 'not_success', 
                'class' => 'warning',
                'message' =>  'Somthing wrong data not saved!',
            ]; 
        } else {
            $return = [
                'type' => 'save_success', 
                'class' => 'success',
                'message' =>  $message,
                'url' => site_url('crm/workspace/workspace'),
            ]; 
        }
        echo json_encode($return);
    }
        
	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('workspaces', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

	public function view($id)
    {
        $data['input'] = $this->Admin_m->findworkspace($id); 
        $data['sub']   = $this->Admin_m->findsubwork($id);
        if (!empty($data['input'])) {
        $data['class'] = 'index2';
        $data['page'] = 'crm/workspace/workspace/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
        }else{
           pageNotFound();
        }       
    }

	public function getServiceList(){
		$results = $this->Admin_m->findAll('services');
		$html = '';

		foreach ($results as $key => $result) {
			$html .= '<option value="'.$result->id.'">'.$result->name.'</option>';
		}		

		echo $html;
	}

	public function workbill($id = NULL)
	{
        if($id){
            $result = $this->Admin_m->getWorkorderCurrentPayStatus($id);
        }

		$input = new stdClass();
		$input->id			 	= '';
		$input->workspace_id 	= ($id ? $id : '');
        $input->total_ammount   = ($id && $result ? $result->total_ammount : '');
        $input->total_payment   = ($id && $result ? $result->total_payment : '');
		$input->ammount		 	= '';
		$input->date 			= '';
		$input->note 			= '';

		$data['input'] 		 	= $input;
		$data['workorder']      = getWorkspace(['workspaces.sub_order' => NULL, 'where_in' => ['leads.km' => $this->Admin_m->myAssistants(getUserData('user_id'))]], true);  
		
		$this->load->view('crm/workspace/workspace/workbill', $data);
	}

	public function saveWorkBill()
	{

		$data['workspace_id']   = $this->input->post('workspace_id');
		$data['ammount'] 		= $this->input->post('ammount');
		$data['date'] 			= $this->input->post('date');
		$data['note'] 			= $this->input->post('note');

		$this->form_validation->set_rules(self::$rulesWorkBill);
        if($this->form_validation->run() == FALSE) {
        $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return);
        } else {
			$this->db->trans_start();
				if(!empty($this->input->post('id'))) {
					$data['updated_by'] = getUserData('user_id');
					$data['updated_at'] = date('Y-m-d H:i:s');
					$this->Admin_m->update('workorder_payment', $data, array('id' => $id));
					$message = 'Work bill update successfull';				
				} else {	
					$data['created_by'] = getUserData('user_id');
					$data['created_at'] = date('Y-m-d H:i:s');
					$this->Admin_m->save('workorder_payment', $data);
					$message = 'Work bill save successfull';
				}
			$this->db->trans_complete();
			
			$return = array(
                'type'    => 'save_success', 
				'class' 		=> 'success', 
				'message' 		=> $message, 
                'url' => base_url('crm/workspace/workspace'),
			);
            echo json_encode($return);
		}
			
	}

	public function workinvoice($stream = TRUE)
	{  
        $id      = $this->input->post('id');
        $date    = $this->input->post('date');
        $ammount = $this->input->post('ammount');
        $note    = $this->input->post('note');
        $status             = $this->input->post('status');
        $data['printed_by'] = getUserData('user_id');
        $data['printed_at'] = date('Y-m-d H:i:s');
        $data['settings'] = $this->Admin_m->find('system_settings', array());
        $data['input'] = $this->Admin_m->findinvoice($this->input->post('workspace_id'));
	    
		foreach ($id as $key => $value)
        {
        	$print = [
			        'status'         => $status[$value]+1,
                    'printed_by'     => getUserData('user_id'),
			        'printed_at'     => date('Y-m-d h:i:s'),
                ];
            $this->Admin_m->update('workorder_payment', $print, array('id' => $value));

            $data['input']->bill[] = [
                'id'      => $value,
                'date'    => $date[$value],
                'ammount' => $ammount[$value],
                'note'    => $note[$value],
            ];

        }

        $data['settings'] = $this->Admin_m->find('system_settings', array());
        
        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $dompdf->set_paper('a4','landscape');
        $this->load->view('crm/workspace/workspace/pdf/money_receipt',$data);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->render();
        if ($stream) {
            $dompdf->stream('workbill_'.date('Ymd').'.pdf',array("Attachment"=>0));
        } else {
            return $dompdf->output();
        }
	}

	 public function workbillprint($id){
        
		$data['input'] = $this->Admin_m->findAll('workorder_payment', array('workspace_id' => $id));  
	
        $data['class'] = 'index2';
        $data['page']  = 'crm/workspace/workspace/workbillprint';
        $data['view']  = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function thisinvoice($work_id)
	{  
        $data['settings'] = $this->Admin_m->find('system_settings', array());
        $data['input'] = $this->Admin_m->findinvoice($work_id);
        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('crm/workspace/workspace/pdf/invoice',$data);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->render();
        $dompdf->stream('employee_'.date('Ymd').'.pdf',array("Attachment"=>0));


    }

}
