<?php
/**
 * 
 */
class Attendance extends Admin_controller
{
	
	public function __construct(){
		parent::__construct();
		siteStatus();
	}

	public function index()
	{

		$input         = new stdClass();
        $input->user_id       = '';
        $input->from_date     = '';
        $input->to_date       = '';
        $data['input']        = $input;
        $where = [];
        $data['lists'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_Att_Data', // Function Name
                '', // Query type  
                $where 
            ); 

		$data['class'] = 'index2';
        $data['page'] = 'hr/attendance/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}



	public function getAttendance()
	{	
		$where = [];
		if($this->input->post('parm')):
			foreach ($this->input->post('parm') as $key => $value) {
				if($key === 'id'):
					$where['attendance.id'] = $value;
				else:
					if($value['name'] === 'user_id' && !empty($value['value'])):
						$where['employees.user_id'] = $value['value'];
					endif;
					if ($value['name'] === 'from_date' && !empty($value['value'])) {
						$from_date = $value['value'];
						$where['date_format(attendance.timestamp, "%Y-%m-%d") >='] = $from_date;
					}
					if ($value['name'] === 'to_date' && !empty($value['value'])) {
						$to_date = $value['value'];
						$where['date_format(attendance.timestamp, "%Y-%m-%d") <='] = $to_date;
					}
				endif;
			}
		endif;

		$results = $this->Admin_m->findall_datatable(
			'Report_m', // Model name
			'_get_Att_Data', // Function Name
			'', // Query type
			$where
		);

		$att = [];

		if($results){
			foreach ($results as $key => $row):
				$att[$key] = [
					'lat' => $row->latitude,
					'lon' => $row->longitude,
					'title' => $row->fullname.' ('.$row->department.')',
					'descr' => '<p>'.$row->fullname.' ('.$row->department.')<br>'.date('F d Y h:i a', strtotime($row->timestamp)).'<br>'.getAddress($row->latitude,$row->longitude).'</p>',
					'address' => getAddress($row->latitude,$row->longitude),
					'time' => date('F d Y h:i a', strtotime($row->timestamp))
				];
			endforeach;
		}

		echo json_encode($att);
	}

	public function savereport() {

		$input         = new stdClass();
        $input->user_id       = $this->input->post('user_id');
        $input->from_date     = $this->input->post('from_date');
        $input->to_date       = $this->input->post('to_date');
        $data['input']        = $input;


        $data['lists'] = [];
        $where=[];
        if($this->input->post('user_id')):
            $where['employees.user_id'] = $this->input->post('user_id');
        endif; 
        if($this->input->post('from_date') && $this->input->post('to_date')):
            $where['date_format(attendance.timestamp, "%Y-%m-%d") >='] = $this->input->post('from_date');
            $where['date_format(attendance.timestamp, "%Y-%m-%d") <='] = $this->input->post('to_date');
        endif;
        if($where):
            $data['lists'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_Att_Data', // Function Name
                '',  // Query type  
                $where
            ); 
        endif;
        
        //output to json format
        $data['class'] = 'index2';
        $data['page'] = 'hr/attendance/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

    }

    public function status($value='')
    {
    	$this->db->trans_start();
			$id = $this->input->post('id');
			$data['status'] = ($this->input->post('status') == 0 ? 2 : $this->input->post('status'));

			$this->Admin_m->update('attendance', $data, array('id' => $id));
		$this->db->trans_complete();	

		if($_SERVER['HTTP_REFERER'] === base_url('hr/attendance')):
			$returnData = array('type' => 'save_success', 'class' => 'success', 'message' => 'Status update successfull');
		else:
			$returnData = array('hasError' => 0, 'type' => 'save_success', 'class' => 'success', 'message' => 'Status update successfull');
		endif;

		echo json_encode($returnData);
    }

}



















