<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Employee extends Admin_controller {

    public function __construct(){
        parent::__construct();
        siteStatus();
    }

    static $rules_add = array(
        'username' => array(
            'field' => 'username',
            'label' => 'User Name',
            'rules' => 'trim|required|is_unique[users.username]'
        ),
        'email' => array(
            'field' => 'email',
            'label' => 'Email',
            'rules' => 'trim|required|valid_email|is_unique[users.email]'
        ),
        'password' => array(
            'field' => 'password',
            'label' => 'Password',
            'rules' => 'trim|required'
        ),
        'usertype_id' => array(
            'field' => 'usertype_id',
            'label' => 'User Type',
            'rules' => 'trim|required'
        ),
        'employmenttype_id' => array(
            'field' => 'employmenttype_id',
            'label' => 'Employment Type',
            'rules' => 'trim|required'
        ),
        'emp_id' => array(
            'field' => 'emp_id',
            'label' => 'Employee ID',
            'rules' => 'trim|required'
        ),
        'designation_id' => array(
            'field' => 'designation_id',
            'label' => 'Designation',
            'rules' => 'trim|required'
        ),
        'joining_date' => array(
            'field' => 'joining_date',
            'label' => 'Joining Date',
            'rules' => 'trim|required'
        ),
        'department_id' => array(
            'field' => 'department_id',
            'label' => 'Department',
            'rules' => 'trim|required'
        ),
        'first_name' => array(
            'field' => 'first_name',
            'label' => 'First Name',
            'rules' => 'trim|required'
        ),
        'last_name' => array(
            'field' => 'last_name',
            'label' => 'Last Name',
            'rules' => 'trim|required'
        ),
        'gender' => array(
            'field' => 'gender',
            'label' => 'Gender',
            'rules' => 'trim|required'
        ),
        'nid_no' => array(
            'field' => 'nid_no',
            'label' => 'National ID',
            'rules' => 'trim|numeric|min_length[10]|max_length[17]|required'
        ),
        'father_name' => array(
            'field' => 'father_name',
            'label' => 'Father Name',
            'rules' => 'trim|required'
        ),
        'mother_name' => array(
            'field' => 'mother_name',
            'label' => 'Mother Name',
            'rules' => 'trim|required'
        ),
        'dob' => array(
            'field' => 'dob',
            'label' => 'Date of Birth',
            'rules' => 'trim|required'
        ),
        'permanent_address' => array(
            'field' => 'permanent_address',
            'label' => 'Permanent Address',
            'rules' => 'trim|required'
        ),
        'present_address' => array(
            'field' => 'present_address',
            'label' => 'Present Address',
            'rules' => 'trim|required'
        ),
        'contact_number' => array(
            'field' => 'contact_number[]',
            'label' => 'Contact Number',
            'rules' => 'trim|numeric|min_length[11]|max_length[17]|required'
        ),
        'emergency_contact' => array(
            'field' => 'emergency_contact[]',
            'label' => 'Emergency Contact',
            'rules' => 'trim|numeric|min_length[11]|max_length[17]|required'
        ),
        'basic' => array(
            'field' => 'basic',
            'label' => 'Basic',
            'rules' => 'trim|required'
        ),

        'houserent' => array(
            'field' => 'houserent',
            'label' => 'Houserent',
            'rules' => 'trim|required'
        ),

        'medical' => array(
            'field' => 'medical',
            'label' => 'Medical',
            'rules' => 'trim|required'
        ),

        'communication' => array(
            'field' => 'communication',
            'label' => 'Communication',
            'rules' => 'trim|required'
        ),
    );

    static $rules_update = array(
        'usertype_id' => array(
            'field' => 'usertype_id',
            'label' => 'User Type',
            'rules' => 'trim|required'
        ),
        'employmenttype_id' => array(
            'field' => 'employmenttype_id',
            'label' => 'Employment Type',
            'rules' => 'trim|required'
        ),
        'designation_id' => array(
            'field' => 'designation_id',
            'label' => 'Designation',
            'rules' => 'trim|required'
        ),
        'department_id' => array(
            'field' => 'department_id',
            'label' => 'Department',
            'rules' => 'trim|required'
        ),
        'joining_date' => array(
            'field' => 'joining_date',
            'label' => 'Joining Date',
            'rules' => 'trim|required'
        ),
        'first_name' => array(
            'field' => 'first_name',
            'label' => 'First Name',
            'rules' => 'trim|required'
        ),
        'last_name' => array(
            'field' => 'last_name',
            'label' => 'Last Name',
            'rules' => 'trim|required'
        ),
        'gender' => array(
            'field' => 'gender',
            'label' => 'Gender',
            'rules' => 'trim|required'
        ),
        'nid_no' => array(
            'field' => 'nid_no',
            'label' => 'National ID',
            'rules' => 'trim|numeric|min_length[10]|max_length[17]|required'
        ),
        'father_name' => array(
            'field' => 'father_name',
            'label' => 'Father Name',
            'rules' => 'trim|required'
        ),
        'mother_name' => array(
            'field' => 'mother_name',
            'label' => 'Mother Name',
            'rules' => 'trim|required'
        ),
        'dob' => array(
            'field' => 'dob',
            'label' => 'Date of Birth',
            'rules' => 'trim|required'
        ),
        'permanent_address' => array(
            'field' => 'permanent_address',
            'label' => 'Permanent Address',
            'rules' => 'trim|required'
        ),
        'present_address' => array(
            'field' => 'present_address',
            'label' => 'Present Address',
            'rules' => 'trim|required'
        ),
        'blood_group' => array(
            'field' => 'blood_group',
            'label' => 'Blood Group',
            'rules' => 'trim|required'
        ),
        'contact_number' => array(
            'field' => 'contact_number[]',
            'label' => 'Contact Number',
            'rules' => 'trim|numeric|min_length[10]|max_length[17]|required'
        ),
        'emergency_contact' => array(
            'field' => 'emergency_contact[]',
            'label' => 'Emergency Contact',
            'rules' => 'trim|numeric|min_length[10]|max_length[17]|required'
        ),

        'institute' => array(
            'field' => 'institute[]',
            'label' => 'Institute',
            'rules' => 'trim|required'
        ),
        'edu_level' => array(
            'field' => 'edu_level[]',
            'label' => 'Level of Education',
            'rules' => 'trim|required'
        ),
        'edu_title' => array(
            'field' => 'edu_title[]',
            'label' => 'Title',
            'rules' => 'trim|required'
        ),
        'majorgroup' => array(
            'field' => 'majorgroup[]',
            'label' => 'Concentration/Major/Group',
            'rules' => 'trim|required'
        ),
        'completion_year' => array(
            'field' => 'completion_year[]',
            'label' => 'Year',
            'rules' => 'trim|required'
        ),
        'result' => array(
            'field' => 'result[]',
            'label' => 'Result',
            'rules' => 'trim|required'
        ),

        'company_name' => array(
            'field' => 'company_name[]',
            'label' => 'Company Name',
            'rules' => 'trim'
        ),
        'responsibilities' => array(
            'field' => 'responsibilities[]',
            'label' => 'Responsibilities',
            'rules' => 'trim'
        ),
        'company_business' => array(
            'field' => 'company_business[]',
            'label' => 'Company Business',
            'rules' => 'trim'
        ),
        'designation' => array(
            'field' => 'designation[]',
            'label' => 'Designation',
            'rules' => 'trim'
        ),
        'department' => array(
            'field' => 'department[]',
            'label' => 'Department',
            'rules' => 'trim'
        ),
        'form_date' => array(
            'field' => 'form_date[]',
            'label' => 'Form Date',
            'rules' => 'trim'
        ),
        'to_date' => array(
            'field' => 'to_date[]',
            'label' => 'To Date',
            'rules' => 'trim'
        ),
        
        'basic' => array(
            'field' => 'basic',
            'label' => 'Basic',
            'rules' => 'trim|required'
        ),

        'houserent' => array(
            'field' => 'houserent',
            'label' => 'Houserent',
            'rules' => 'trim|required'
        ),

        'medical' => array(
            'field' => 'medical',
            'label' => 'Medical',
            'rules' => 'trim|required'
        ),

        'communication' => array(
            'field' => 'communication',
            'label' => 'Communication',
            'rules' => 'trim|required'
        ),
    );

    public function index()
    {
        $data['class'] = 'index2';
        $data['page'] = 'hr/employee/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function getListData(){

        $where = [];

        if(getUserData('is_admin') == 0):
            $where['users.is_admin'] = 0;
        endif;

        $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_emp_query', // Function Name
                'filter', // Query type
                $where // coditions
            );


        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '';
            $button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('hr/employee/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="employee">
                <i class="zmdi zmdi-eye table-icon"></i></a>
            </a>&nbsp;';

            if(getUserData('is_admin') == 1 && getUserData('user_type') != 5 && empty($list->deleted_at)):
            $button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('hr/employee/delete').'" data-id="'.$list->id.'">
                <i class="zmdi zmdi-delete table-icon"></i></a>
            </a> ';
            endif;
            

            $no++;
            $row = array();
            $row[] = '<img class="rounded-circle avatar img40" src="'.imagePath('empdocuments', $list->id).'" />'.
                    '<p class="c_name">'.$list->full_name.'<span class="badge badge-default m-l-10 hidden-sm-down">'.$list->user_type.'</span></p>';
            $row[] = $list->username;
            $row[] = '<span class="email"><a href="mailto:'.$list->email.'" target="_top" title=""><i class="zmdi zmdi-email m-r-5"></i>'.$list->email.'</a></span>';
            $row[] = $list->dep_name;
            $row[] = '<div class="flipswitch" data-toggle="tooltip" data-placement="top" title="Status Change">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-href="'.site_url('hr/Employee/status').'" data-usertype = "'.getUserData('user_type').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' '.(getUserData('is_admin') == 0 ? 'disabled': '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Admin_m->findall_datatable('Admin_m', '_get_emp_query', 'count', $where),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

    public function new_()
    {
        $input = new stdClass();
        $input->user_id = '';
        $input->employee_id = '';
        $input->salary_id = '';
        $input->education_id = '';
        $input->empdocuments_id = '';
        $input->supervisor_id = '';
        $input->emp_id = '';
        $input->joining_date = '';
        $input->employmenttype_id = '';
        $input->department_id = '';
        $input->designation_id = '';
        $input->username = '';
        $input->email = '';
        $input->password = '';
        $input->usertype_id = '';
        $input->is_admin = '';
        $input->first_name = '';
        $input->last_name = '';
        $input->dob = '';
        $input->gender = '';
        $input->nid_no = '';
        $input->marital_status = '';
        $input->spouse_name = '';
        $input->spouse_conatct = '';
        $input->father_name = '';
        $input->mother_name = '';
        $input->present_address = '';
        $input->permanent_address = '';
        $input->blood_group = '';
        $input->contact_number = '';
        $input->emergency_contact = '';

        $input->education = '';

        $input->basic = '';
        $input->houserent = '';
        $input->medical = '';
        $input->children = '';
        $input->communication = '';
        $input->spacial = '';
        $input->lta = '';
        $input->bouns = '';
        $input->doc_link = '';

        $input->expertise = '';
        $input->interest = '';

        $data['input']                  = $input;
        $data['detailRowDataList']      = array();
        $data['class'] = 'index2';
        $data['page'] = 'hr/employee/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function edit($id)
    {
        $data['input'] = $this->Admin_m->findUser($id);
        $data['class'] = 'index2';
        $data['page'] = 'hr/employee/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

        // if(getUserData('is_admin') == 1 || getUserData('user_id') == $id){

        //     $data['input'] = $this->Admin_m->findUser($id);
        //     if (!empty($data['input'])) {
        //         $this->load->view('hr/employee/form', $data);
        //     }else{
        //         pageNotFound();
        //     }
        // }else{
        //         pageNotFound();
            
        // }
    }

    public function save()
    {
        $user_id         = $this->input->post('user_id');
        $employee_id     = $this->input->post('employee_id');
        $education_id    = $this->input->post('education_id');
        $salary_id       = $this->input->post('salary_id');
        $empdocuments_id = $this->input->post('empdocuments_id');

        if($user_id) {
            $this->form_validation->set_rules(self::$rules_update);
        } else {
            $this->form_validation->set_rules(self::$rules_add);
        }

        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
            $this->db->trans_start();

                $users = [
                    'username' => $this->input->post('username'),
                    'email' => $this->input->post('email'),
                    'usertype_id' => $this->input->post('usertype_id'),
                    'is_admin' => ($this->input->post('is_admin') ? $this->input->post('is_admin') : 0)
                ];

                $employee = [
                    'first_name'         => $this->input->post('first_name'),
                    'last_name'          => $this->input->post('last_name'),
                    'gender'             => $this->input->post('gender'),
                    'nid_no'             => $this->input->post('nid_no'),
                    'father_name'        => $this->input->post('father_name'),
                    'mother_name'        => $this->input->post('mother_name'),
                    'dob'                => $this->input->post('dob'),
                    'permanent_address'  => $this->input->post('permanent_address'),
                    'present_address'    => $this->input->post('present_address'),
                    'blood_group'        => $this->input->post('blood_group'),
                    'marital_status'     => $this->input->post('marital_status'),
                    'spouse_name'        => $this->input->post('spouse_name'),
                    'spouse_conatct'     => $this->input->post('spouse_conatct'),
                    'emp_id'             => $this->input->post('emp_id'),
                    'joining_date'       => $this->input->post('joining_date'),
                    'employmenttype_id'  => $this->input->post('employmenttype_id'),
                    'designation_id'     => $this->input->post('designation_id'),
                    'department_id'      => $this->input->post('department_id'),
                    'contact_number'     => array_to_string(array_filter($this->input->post('contact_number'))),
                    'emergency_contact'  => array_to_string(array_filter($this->input->post('emergency_contact'))),
                    'expertise'          => array_to_string(array_filter($this->input->post('expertise'))),
                    'interest'           => array_to_string(array_filter($this->input->post('interest'))),
                    'supervisor_id'      => ($this->input->post('supervisor_id') ? $this->input->post('supervisor_id') : $user_id)
                ];
               
                
                $edu_level = $this->input->post('edu_level');
                $edu_title = $this->input->post('edu_title');
                $majorgroup = $this->input->post('majorgroup');
                $institute = $this->input->post('institute');
                $completion_year = $this->input->post('completion_year');
                $result = $this->input->post('result');

                $company_name = $this->input->post('company_name');
                $responsibilities = $this->input->post('responsibilities');
                $company_business = $this->input->post('company_business');
                $designation = $this->input->post('designation');
                $department = $this->input->post('department');
                $form_date = $this->input->post('form_date');
                $to_date = $this->input->post('to_date');


                $training_title = $this->input->post('training_title');
                $training_institute = $this->input->post('training_institute');
                $training_year = $this->input->post('training_year');
                
                $salaries = [
                    'basic' => $this->input->post('basic'),
                    'houserent' => $this->input->post('houserent'),
                    'medical' => $this->input->post('medical'),
                    'children' => $this->input->post('children'),
                    'communication' => $this->input->post('communication'),
                    'spacial' => $this->input->post('spacial'),
                    'lta' => $this->input->post('lta'),
                    'bouns' => $this->input->post('bouns'),
                ];

                $empdocuments = [
                    'doc_link'  => $this->input->post('doc_link')                    
                ];


                if($this->input->post('password')){
                    $users['password'] = hashdata($this->input->post('password'));
                }

                if (empty($user_id)){

                    $userid = $this->Admin_m->save('users', $users);
                    $employee['user_id'] = $userid; 
                    $this->Admin_m->save('employees', $employee);

                    if($edu_title){
                        foreach ($edu_title as $key => $etitle) {
                            if(!empty($etitle)){
                                $education = [
                                    'user_id' => $userid,
                                    'edu_level' => $edu_level[$key],
                                    'edu_title' => $etitle,
                                    'majorgroup' => $majorgroup[$key],
                                    'institute' => $institute[$key],
                                    'completion_year' => $completion_year[$key],
                                    'result' => $result[$key]
                                ];
                                $this->Admin_m->save('education', $education);
                            }
                        }    
                    }                    

                    if($company_name){
                        foreach ($company_name as $key => $comname) {
                            if(!empty($comname)){
                                $employee_experience = [
                                    'user_id' => $userid,
                                    'company_name' => $comname,
                                    'responsibilities' => $responsibilities[$key],
                                    'company_business' => $company_business[$key],
                                    'designation' => $designation[$key],
                                    'department' => $department[$key],
                                    'form_date' => $form_date[$key],
                                    'to_date' => $to_date[$key]
                                ];
                                $this->Admin_m->save('emp_experience', $employee_experience);
                            }
                        }
                    }

                    if($training_title){
                       foreach ($training_title as $key => $etraining) {
                            if(!empty($etraining)){
                               $employee_training = [
                                    'user_id' => $userid,
                                    'training_title' => $etraining,
                                    'training_institute' => $training_institute[$key],
                                    'training_year' => $training_year[$key],
                                ];
                                $this->Admin_m->save('emp_training', $employee_training); 
                            }
                        } 
                    }                    

                    $salaries['user_id'] = $userid; 
                    $this->Admin_m->save('salaries', $salaries);
                    $empdocuments['user_id'] = $userid; 
                    $this->Admin_m->save('empdocuments', $empdocuments);
                    $message = 'Item save successfull';

                } else {

                    $userid = $user_id;

                    unset($users['username']);
                    unset($users['email']);

                    $this->Admin_m->update('users', $users, array('id' => $user_id));
                    $this->Admin_m->update('employees', $employee, array('id' => $employee_id));                   
                    $this->Admin_m->delete('education', ['user_id' => $user_id]);
                    $this->Admin_m->delete('emp_experience', ['user_id' => $user_id]);
                    $this->Admin_m->delete('emp_training', ['user_id' => $user_id]);

                    if($edu_title){
                        foreach ($edu_title as $key => $etitle) {
                            if(!empty($etitle)){
                                $education = [
                                    'user_id' => $userid,
                                    'edu_level' => $edu_level[$key],
                                    'edu_title' => $etitle,
                                    'majorgroup' => $majorgroup[$key],
                                    'institute' => $institute[$key],
                                    'completion_year' => $completion_year[$key],
                                    'result' => $result[$key]
                                ];
                                $this->Admin_m->save('education', $education);
                            }
                        }    
                    }                    

                    if($company_name){
                        foreach ($company_name as $key => $comname) {
                            if(!empty($comname)){
                                $employee_experience = [
                                    'user_id' => $userid,
                                    'company_name' => $comname,
                                    'responsibilities' => $responsibilities[$key],
                                    'company_business' => $company_business[$key],
                                    'designation' => $designation[$key],
                                    'department' => $department[$key],
                                    'form_date' => $form_date[$key],
                                    'to_date' => $to_date[$key]
                                ];
                                $this->Admin_m->save('emp_experience', $employee_experience);
                            }
                        }
                    }

                    if($training_title){
                       foreach ($training_title as $key => $etraining) {
                            if(!empty($etraining)){
                               $employee_training = [
                                    'user_id' => $userid,
                                    'training_title' => $etraining,
                                    'training_institute' => $training_institute[$key],
                                    'training_year' => $training_year[$key],
                                ];
                                $this->Admin_m->save('emp_training', $employee_training); 
                            }
                        } 
                    }
                    $this->Admin_m->update('salaries', $salaries, array('id' => $salary_id));
                    if($empdocuments_id):
                        $this->Admin_m->update('empdocuments', $empdocuments, array('id' => $empdocuments_id));
                    else:
                        $empdocuments['user_id'] = $userid;
                        $this->Admin_m->save('empdocuments', $empdocuments);
                    endif;
                    $message = 'Item Update successfull';  

                    
                }
            $this->db->trans_complete();

            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('hr/employee'),
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('hr/employee'),
                ]; 
            }

            echo json_encode($return);

        }
    }

    public function status(){
        $this->db->trans_start();
            $id = $this->input->post('id');
            $data['status'] = $this->input->post('status');

            $this->Admin_m->update('users', $data, array('id' => $id));
        $this->db->trans_complete();

        if ($this->db->trans_status() === FALSE){
            $return = [
                'type' => 'not_success', 
                'class' => 'warning',
                'message' =>  'Somthing wrong data not saved!',
                'url' => site_url('hr/employee'),
                'query' => $this->db->last_query(),
            ]; 
        } else {
            $return = [
                'type' => 'save_success', 
                'class' => 'success',
                'message' =>  'Status update successfull',
                'url' => site_url('hr/employee'),
                'query' => $this->db->last_query(),
            ]; 
        }

        echo json_encode($return);

    }

    public function delete()
    {
        $id = $this->input->post('id');
        $data['status'] = 0;
        $this->db->trans_start();
            $this->Admin_m->update('users', $data, array('id' => $id));

            if(!empty($id)) {
                $this->Admin_m->destroy('users', array('id' => $id));
            }

            $returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Employee delete successfull', 'detailMessage' => '');
            echo json_encode($returnData);
        $this->db->trans_complete();
    }

    public function view($id)
    {
        $data['input'] = $this->Admin_m->findUser($id);
        $data['suser'] = $this->Admin_m->find('employees', ['id' => $data['input']->supervisor_id]);
        $data['class'] = 'index2';
        $data['page'] = 'hr/employee/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function filter_user($filter = false){
        $where = $_POST;
        $data = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_emp_query', // Function Name
                '', // Query type
                $where // coditions
            );
        if($filter == true):
            return $data;
        else:
            echo json_encode($data);
        endif;    
    }

    public function emp_pdf($id)
    {
        $data['input'] = $this->Admin_m->findUser($id);  
        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('hr/employee/employee_pdf',$data);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->render();
        $dompdf->stream('employee_'.date('Ymd').'.pdf',array("Attachment"=>0));

    }

    public function activeUserList()
    {
        $results = userList([], '', '', true);

        $data = [];
        foreach ($results as $key => $value) {
            $data[] = [
                'value' => $value['id'],
                'text' => $value['fullname']
            ];
        }

        echo json_encode($data);
    }

}