<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Billsubmission extends Admin_controller {
    


    public function __construct(){
            parent::__construct();
            siteStatus();

    }
    
    static $rules = array(

        'amount' => array(
                'field' => 'amount[]', 
                'label' => 'Amount', 
                'rules' => 'required'
        ),
        
        'cost_particulars' => array(
                'field' => 'cost_particulars[]', 
                'label' => 'Cost Particulars', 
                'rules' => 'required'
        ),

    );
    
    public function index() {
        $data['class'] = 'index2';
        $data['page'] = 'hr/bill/billSubmission/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

    }

    public function new_()
    {
        $input = new stdClass();    
        $input->id          = '';
        $input->visit_id    = (isset($_GET['vid']) ? $_GET['vid'] : '');  
        $input->total_cost  = '';
        $input->status      = '';
        $input->bill_no     = '';
        $input->description = '';
        $input->visitInfo   = '';
        
        $data['input'] = $input;
        $data['detailRowDataList']  = array();
        if(isset($_GET['vid'])):
            $input->visitInfo = $this->Admin_m->find('client_visit', ['id' => $_GET['vid']]);
        endif;
        $data['vrn'] = $this->Admin_m->findAll('client_visit', array('user_id' => getUserData('user_id'), 'status' => '2'));

        $data['class'] = 'index2';
        $data['page'] = 'hr/bill/billSubmission/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }
    
    public function getListData(){

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_billsubmission_query', // Function Name
                'filter', // Query type
                ['visit_bills.user_id' => getUserData('user_id'), 'client_visit.deleted_at' => NULL]
            );
// echo $this->db->last_query();        
// dd($lists);
        $data = array();

        $no = $_POST['start'];
        foreach ($lists as $key => $list) {

            $button = '';


            if ($list->status == 2) {
               $status = '<span class="badge badge-success">Approved</span>';
            }elseif ($list->status == 1) {
               $status = '<span class="badge badge-warning">Submitted</span>';
            }elseif ($list->status == 4) {
               $status = '<span class="badge badge-default">Paid</span>';
            }elseif ($list->status == 3){
               $status = '<span class="badge badge-info">Confirmed</span>';
            }
            else{
               $status = '<span class="badge badge-danger">Created</span>';
            }
            $button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('hr/bill/accounts/billsubmission/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="employee">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>&nbsp;';    

            if ($list->status == 0) {
            $button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('hr/bill/accounts/billsubmission/delete').'" data-id="'.$list->id.'">
                <i class="zmdi zmdi-delete table-icon"></i>
            </a> ';                
            }

            
            
            $no++;
            $row = array();
            $row[] = $list->bill_no;
            $row[] = ucwords($list->emp_name);
            $row[] = ($list->others ? $list->others : $list->leads_name);
            $row[] = $list->description;
            $row[] = $list->approved_by;
            $row[] = $status;
            $row[] = $button;
            $data[] = $row;
        }


        $output = array(
            "draw" => $_POST['draw'],
            "recordsTotal"    => '',
            "recordsFiltered" => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_billsubmission_query', // Function Name
                'count', // Query type
                ['visit_bills.user_id' => getUserData('user_id'), 'client_visit.deleted_at' => NULL]
            ),
            "data" => $data,
        );

        //output to json format
        echo json_encode($output);
    }

    public function edit($id)
    {
        $data['input'] = $this->Admin_m->findBill($id);
        $data['input']->cost = $this->Admin_m->findAll('client_visit_cost', ['visit_bill_id' => $id]);
        if( $data['input']->client_visit_id):
             $data['input']->visitInfo = $this->Admin_m->find('client_visit', ['id' =>  $data['input']->client_visit_id]);
        endif;
        $data['class'] = 'index2';
        $data['page'] = 'hr/bill/billSubmission/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function save()
    {
        $id = $this->input->post('id');
        $data['user_id'] = getUserData('user_id');
        $data['bill_no'] = $this->input->post('bill_no');
        if($this->input->post('visit_id')):
            $data['visit_id'] = $this->input->post('visit_id');
        endif;
        $data['description'] = $this->input->post('description');

        $cost_particulars = $this->input->post('cost_particulars');
        $amount = $this->input->post('amount');

        $this->form_validation->set_rules(self::$rules);
        
        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        }else { 

            $this->db->trans_start();
            if(!empty($id)) {
                if($this->input->post('saveType') === 'Approve'){
                    $cost_id = $this->input->post('cost_id');
                    $approved_amount = $this->input->post('approved_amount');
                    if ($approved_amount) 
                    {
                        $this->form_validation->set_rules('approved_amount[]', 'Approved Amount', 'required');
                            if($this->form_validation->run() == FALSE) {
                                $return['type'] = 'validation_error'; 
                                foreach ($this->form_validation->error_array() as $key => $value) {
                                    $return['message'][str_replace("[]","",$key)] = $value;
                                }
                                echo json_encode($return); 
                            }else {
                                foreach ($approved_amount as $key => $approved):
                                    $costparticulars = [
                                        'particulars' => $cost_particulars[$key],
                                        'amount' => $amount[$key],
                                        'approved_amount' => $approved,
                                    ];
                                    $this->Admin_m->update('client_visit_cost',$costparticulars, ['id' => $cost_id[$key]]);
                                endforeach;
                            $this->Admin_m->update('visit_bills',['status' => '2'], ['id' => $id]);
                        }
                    }
                    $message = 'Bill Approved';

                    $notification = [
                        'tbl_name'      => 'visit_bills',
                        'tbl_pk'        => $id,
                        'user_id'       => $this->input->post('user_id'), 
                        'usertype_id'   => 3,
                        'title'         => '<strong>'.getUserData('fullname').'</strong> Approve bill',
                        'source_url'    => 'hr/bill/accounts/billsubmission/view/'.$id,
                        'deadline'      => NULL, 
                        'list_class'    => 'info',
                        'created_date'  => date('Y-m-d H:i:sa'),
                    ];
                    $this->Admin_m->save('notifications', $notification); 
                }elseif($this->input->post('confirm') === 'Confirm') {
                    $this->Admin_m->update('visit_bills',['status' => '3', 'approved_by' => '3'], ['id' => $id]);
                    $message = 'Bill submited Confirmed';

                    $notification = [
                        'tbl_name'      => 'visit_bills',
                        'tbl_pk'        => $id,
                        'user_id'       => $this->input->post('user_id'), 
                        'usertype_id'   => 3, 
                        'title'         => '<strong>'.getUserData('fullname').'</strong> Comfirmed bill',
                        'source_url'    => 'hr/bill/billsubmission/view/'.$id,
                        'deadline'      => NULL, 
                        'list_class'    => 'info',
                        'created_date'  => date('Y-m-d H:i:sa'),
                    ];
                    $this->Admin_m->save('notifications', $notification);
                }
                elseif($this->input->post('paid') === 'Paid') {
                 //   dd($_POST);
                    $this->Admin_m->update('visit_bills',['status' => '4'], ['id' => $id]);
                    $message = 'Bill submited Confirmed and paid';

                    $notification = [
                        'tbl_name'      => 'visit_bills',
                        'tbl_pk'        => $id,
                        'user_id'       => $this->input->post('user_id'), 
                        'usertype_id'   => 3, 
                        'title'         => '<strong>'.getUserData('fullname').'</strong> Paid bill',
                        'source_url'    => 'hr/bill/billsubmission/view/'.$id,
                        'deadline'      => NULL, 
                        'list_class'    => 'info',
                        'created_date'  => date('Y-m-d H:i:sa'),
                    ];
                    $this->Admin_m->save('notifications', $notification);
                }elseif ($this->input->post('saveType') === 'Save & Submit') {
                        $data['status']  = '1';
                        $this->Admin_m->update('visit_bills', $data, ['id' => $id]);
                
                        $this->Admin_m->delete('client_visit_cost', ['visit_bill_id' => $id]);

                        //echo $this->db->last_query(); exit;
                        $message = 'Item update successfull';  

                        foreach ($cost_particulars as $key => $costs) {
                            $costparticulars = [
                                'visit_bill_id' => $id ,
                                'particulars' => $costs,
                                'amount' => $amount[$key],
                            ];
                            $this->Admin_m->save('client_visit_cost', $costparticulars);
                        }   
                       
                        $message = 'Bill saved and submited successfully';

                        $notification = [
                            'tbl_name'      => 'visit_bills',
                            'tbl_pk'        => $id,
                            'user_id'       => getUserData('supervisor'),
                            'usertype_id'   => getUserType(getUserData('supervisor')), 
                            'title'         => '<strong>'.getUserData('fullname').'</strong> submit a bill',
                            'source_url'    => 'hr/bill/accounts/billsubmission/view/'.$id,
                            'deadline'      => NULL, 
                            'list_class'    => 'info',
                            'created_date'  => date('Y-m-d H:i:sa'),
                        ];  
                        $this->Admin_m->save('notifications', $notification);
                }else {
                    $this->Admin_m->update('visit_bills', $data, ['id' => $id]);
                
                    $this->Admin_m->delete('client_visit_cost', ['visit_bill_id' => $id]);

                    //echo $this->db->last_query(); exit;
                    $message = 'Item update successfull';  

                    foreach ($cost_particulars as $key => $costs) {
                        $costparticulars = [
                            'visit_bill_id' => $id ,
                            'particulars' => $costs,
                            'amount' => $amount[$key],
                        ];
                        $this->Admin_m->save('client_visit_cost', $costparticulars);
                    }  
 
                    $message = 'Update successfull';     
                }  
            }else { 

                    if ($this->input->post('saveType') === 'Save & Submit') {
                        $data['status']  = '1';
                        $id = $this->Admin_m->save('visit_bills', $data);

                        foreach ($cost_particulars as $key => $costparticulars) {
                        $carticulars = [
                            'visit_bill_id' => $id ,
                            'particulars' => $costparticulars,
                            'amount' => $amount[$key],
                        ];
                        $this->Admin_m->save('client_visit_cost', $carticulars);
                        }

                        if($this->input->post('visit_id')):
                            $status_update = $this->Admin_m->update('client_visit',['status' => '0'],['id' => $data['visit_id']]);
                        endif;    
                       
                        $message = 'Bill saved and submited successfully';

                        $notification = [
                            'tbl_name'      => 'visit_bills',
                            'tbl_pk'        => $id,
                            'user_id'       => getUserData('supervisor'),
                            'usertype_id'   => getUserType(getUserData('supervisor')), 
                            'title'         => '<strong>'.getUserData('fullname').'</strong> submit a bill',
                            'source_url'    => 'hr/bill/accounts/billsubmission/view/'.$id,
                            'deadline'      => NULL, 
                            'list_class'    => 'info',
                            'created_date'  => date('Y-m-d H:i:sa'),
                        ];  
                        $this->Admin_m->save('notifications', $notification);
                  

                    }else{ 
                
                    $id = $this->Admin_m->save('visit_bills', $data);

                    foreach ($cost_particulars as $key => $costparticulars) {
                    $carticulars = [
                        'visit_bill_id' => $id ,
                        'particulars' => $costparticulars,
                        'amount' => $amount[$key],
                    ];
                    $this->Admin_m->save('client_visit_cost', $carticulars);
                    }

                    if($this->input->post('visit_id')):
                        $status_update = $this->Admin_m->update('client_visit',['status' => '0'],['id' => $data['visit_id']]);
                    endif;    
                   
                    $message = 'Item save successfull';
                }
            }
            $this->db->trans_complete();
            
            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('hr/bill/accounts/billsubmission/view/'.$id),
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('hr/bill/accounts/billsubmission/view/'.$id),
                ]; 
            }

        echo json_encode($return);

        }
    }

    public function approvebill(){
        $data['class'] = 'index2';
        $data['page'] = 'hr/bill/billSubmission/approve/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function getApproveListData(){

        if ((getUserData('is_admin') == 1) && (getUserData('user_type') != 3)) {
            $where = ['visit_bills.status >=' => '1'];
        }
        elseif((getUserData('user_type') != 3) && (getUserData('is_admin') != 1)){
            $where = ['employees.supervisor_id' => getUserData('user_id'), 'visit_bills.status' => '1'];
        }
        elseif(getUserData('user_type') == 3 && getUserData('is_admin') != 1){
            $where = ['visit_bills.status >=' => '3'];
        } else {
            $where = ['visit_bills.status >=' => '2'];
        }

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_billsubmission_query', // Function Name
                'filter', // Query type
                $where
            );

        $data = array();

        $no = $_POST['start'];
        foreach ($lists as $key => $list) {

            $button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('hr/bill/accounts/billsubmission/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="employee">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>&nbsp;';
            if ($list->status == 2) {
               $status = '<span class="badge badge-success">Approved</span>';
            }elseif ($list->status == 1) {
               $status = '<span class="badge badge-warning">Submitted</span>';
            }elseif ($list->status == 4) {
               $status = '<span class="badge badge-default">Paid</span>';
            }elseif ($list->status == 3){
               $status = '<span class="badge badge-info">Confirmed</span>';
            }
            else{
               $status = '<span class="badge badge-danger">Created</span>';
            }
            
            $no++;
            $row = array();
            $row[] = $list->bill_no;
            $row[] = ucwords($list->emp_name);
            $row[] = ucwords(getLead(['leads.id' => $list->lead_id]));
            $row[] = $list->description;
            $row[] = $status;
            $row[] = $list->approved_by;
            $row[] = $button;
            $data[] = $row;
        }


        $output = array(
            "draw" => $_POST['draw'],
            "recordsTotal"    => '',
            "recordsFiltered" => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_billsubmission_query', // Function Name
                'count', // Query type
                $where
            ),
            "data" => $data,
        );

        //output to json format
        echo json_encode($output);
    }
    
    
    public function view($id)
    {
        $users = $this->Admin_m->myAssistants(getUserData('user_id'));
        $data['input'] = $this->Admin_m->findBill($id);
        $data['input']->visit = $this->Admin_m->find('client_visit', ['id' => $data['input']->client_visit_id]);   
        if($data['input']->visit):      
            $data['input']->desc = $this->Admin_m->findAll('client_visit_desc', ['visit_id' => $data['input']->visit->id]);       
        endif;
        $data['input']->cost = $this->Admin_m->findAll('client_visit_cost', ['visit_bill_id' => $id]);

        $data['class'] = 'index2';
        $data['page'] = 'hr/bill/billSubmission/view';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

    }
    
    public function saveApprovebill()
    {
        $id = $this->input->post('bill_id');
        $status = $this->input->post('status');
        
        if($this->input->post('saveType') == 'Approve')
        {   
            $this->db->trans_start();         
                $bills = $this->Admin_m->findAll('client_visit_cost', ['visit_bill_id' => $id]);
                
                foreach ($bills as $key => $bill)
                {
                    $this->Admin_m->update('client_visit_cost',['approved_amount' => $bill->amount], ['id' => $bill->id]);
                }

                $this->Admin_m->update('visit_bills',['status' => $status, 'approved_by' => getUserData('user_id')], ['id' => $id]);

                $notification = [
                    'tbl_name'      => 'visit_bills',
                    'tbl_pk'        => $id,
                    'user_id'       => $this->input->post('user_id'), 
                    'usertype_id'   => 3,
                    'title'         => '<strong>'.getUserData('fullname').'</strong> Approve bill',
                    'source_url'    => 'hr/bill/accounts/billsubmission/view/'.$id,
                    'deadline'      => NULL, 
                    'list_class'    => 'info',
                    'created_date'  => date('Y-m-d H:i:s'),
                ];
                $this->Admin_m->save('notifications', $notification);  

                $return['type']    = 'success_top'; 
                $return['class']   = 'success';
                $return['message'] = 'Bill sucessfully Approved !!';
                $return['url'] = base_url('hr/bill/accounts/billsubmission/approvebill'); 
            $this->db->trans_complete();
                  
        } 
        elseif($this->input->post('saveType') == 'Paybill')
        {
            $id = $this->input->post('id');
            $approved_amount = $this->input->post('approved_amount');
            $description = $this->input->post('description');
            $bill_no = $this->input->post('bill_no');

            $data['input'] = $this->Admin_m->findUser($this->input->post('user_id'));
            
            foreach ($id as $key => $value)
            {
                $this->Admin_m->update('visit_bills',['status' => '4'], ['id' => $value]);       
                $data['input']->payment[] = [
                    'id' => $value,
                    'amount' => $approved_amount[$value],
                    'description' => $description[$value],
                    'bill_no' => $bill_no[$value],
                    'particulars' => $this->Admin_m->findAll('client_visit_cost', array('visit_bill_id' => $value))
                ];                
            }     

            $options = new \Dompdf\Options();
            $dompdf  = new \Dompdf\Dompdf();
            $options->setIsRemoteEnabled(true);
            $dompdf->setOptions($options);
            $this->load->view('hr/bill/billSubmission/paybill/pdf_bill',$data);
            $html = $this->output->get_output();

            $dompdf->loadHtml($html);
            $dompdf->set_paper('A4', 'portrait');
            $dompdf->render();

            // $output = $dompdf->output();
            // file_put_contents(APPPATH."third_party/bills/bill-".$data['input']->first_name." ".$data['input']->last_name."-".date('Y-m-d').".pdf", $output);
            $dompdf->stream($data['input']->first_name." ".$data['input']->last_name."-".date('Y-m-d').".pdf",array("Attachment"=>0));

            $dompdf->stream($data['input']->first_name." ".$data['input']->last_name."-".date('Y-m-d').".pdf");
        } 
        else 
        {
            $this->db->trans_start();
                $this->Admin_m->update('visit_bills',['status' => $status], ['id' => $id]);    

                $notification = [
                    'tbl_name'      => 'visit_bills',
                    'tbl_pk'        => $id,
                    'user_id'       => $this->input->post('user_id'), 
                    'usertype_id'   => 3,
                    'title'         => '<strong>'.getUserData('fullname').'</strong> confirmed bill',
                    'source_url'    => 'hr/bill/accounts/billsubmission/view/'.$id,
                    'deadline'      => NULL, 
                    'list_class'    => 'info',
                    'created_date'  => date('Y-m-d H:i:sa'),
                ];
                $this->Admin_m->save('notifications', $notification);  

                $return['type']    = 'success_top'; 
                $return['class']   = 'success';
                $return['message'] = 'Bill sucessfully Confirmed !!';
                $return['url'] = base_url('hr/bill/accounts/billsubmission/approvebill');    

            $this->db->trans_complete();
        }

        echo json_encode($return); 
    }

    public function payBill(){
        $data['users'] = $this->Admin_m->getBillUserList();
        $data['class'] = 'index2';
        $data['page'] = 'hr/bill/billSubmission/paybill/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function getPayListByUser(){
        $user_id = $this->input->post('user_id');

        $data = $this->Admin_m->getUserBill($user_id);

        $html = '<table class="table  table-bordered table-hover">
            <thead>
                <tr>
                    <th class="center">
                        <label class="pos-rel">
                            <input type="checkbox" class="ace" value="checkAll">
                            <span class="lbl"></span>
                        </label>
                    </th>
                    <th class="center">Bill No</th>
                    <th class="center">Description</th>
                    <th class="center">Approved Amount</th>
                </tr>
            </thead>
            <tbody>';
        foreach ($data as $key => $value) {
            $html .= '<tr class="row_element">
                <td class="center">
                    <label class="pos-rel">
                        <input type="checkbox" class="ace" name="id[]" value="'.$value->id.'">
                        <span class="lbl"></span>
                    </label>
                </td>
                <td>'.$value->bill_no.'</td>
                <td>'.$value->description.'</td>
                <td class="text-right">
                        <input type="hidden" class="ace" name="bill_no['.$value->id.']" value="'.$value->bill_no.'"><input type="hidden" class="ace" name="description['.$value->id.']" value="'.$value->description.'"><input type="hidden" class="approved_amount" name="approved_amount['.$value->id.']" value="'.$value->approved_amount.'">'.$value->approved_amount.'</td>
            </tr>';
        }    
        $html .= '</tbody>
            <tfoot>
                <tr>
                    <th colspan="4" class="text-center">
                        <div class="form-group">
                          <input type="submit" name="saveType" class="btn btn-theme btn-round btn-xs" value="Paybill"></input>
                        </div>
                    </th>
                </tr>
            </tfoot>
        </table>';
        

        echo $html;
    }  
    public function ajaxBill()
    {   
        $vrn_id  = $this->input->post('vrn_no');
        
        $vrn = $this->Admin_m->find('client_visit', ['id' => $vrn_id]);

        $html = '<div class="header">
                    <h2><strong>VRN</strong> Information</h2>
                </div>
                <div class="col-sm-12" >
                    <div class="body">
                        <div class="row clearfix">
                            <div class="col-sm-2">
                              <p><strong>Type: </strong>';
                                if(!empty($vrn)):
                                    if($vrn->type == 1):
                                      $html .= "lead";
                                    elseif($vrn->type == 2):
                                      $html .= "Client";
                                    else:
                                      $html .= "Other";
                                    endif;
                                endif;
                                $html .= '
                              </p>
                            </div>
                            <div class="col-sm-2">
                                <p><strong>Date: </strong> '.(!empty($vrn) ? ($vrn->type == 3 ? $vrn->others : getLead(['leads.id' => $vrn->lead_id])) : '').' </p>
                            </div>
                            <div class="col-sm-3">
                                <p><strong>For: </strong> '.(!empty($vrn) ? $vrn->location : '').'</p>
                            </div>
                            <div class="col-sm-3">
                                <p><strong>Purpose: </strong> '.(!empty($vrn) ? $vrn->purpose : '').'</p>
                            </div>
                            <div class="col-sm-2">
                                <p><strong>Location: </strong> '.(!empty($vrn) ? $vrn->location : '').'</p>
                            </div>
                        </div>
                    </div>
                </div>';
        echo $html; 
    } 



}
