<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Visitreport extends Admin_controller {

    public function __construct(){
        parent::__construct();
        siteStatus();
    }
    
    static $rules = array(
        'bill_type' => array(
                'field' => 'bill_type', 
                'label' => 'Bill Type', 
                'rules' => 'trim|required'
        ),
        'visit_date' => array(
                'field' => 'visit_date', 
                'label' => 'Visit Date', 
                'rules' => 'trim|required'
        ),
        'location' => array(
                'field' => 'location', 
                'label' => ':Location', 
                'rules' => 'trim|required'
        ),
        'purpose' => array(
                'field' => 'purpose', 
                'label' => ':Purpose', 
                'rules' => 'trim|required'
        ),
        'outcome' => array(
                'field' => 'outcome', 
                'label' => ':Outcome', 
                'rules' => 'trim|required'
        ),

    );
    
    public function index()
    {
        $data['class'] = 'index2';
        $data['page'] = 'hr/management/Visitreport/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

    }

    public function new_()
    {
            $input = new stdClass();	
            $input->id 	= '';
            $input->user_id 	= '';
            $input->usertype_id 	= '';
            $input->vrn_no = '';
            $input->others = '';
            $input->type = '';
            $input->lead_id = '';
            $input->email = '';
            $input->location = '';
            $input->purpose = '';
            $input->outcome = '';
            $input->visit_date = '';
            $input->status = '';

            $input->particulars = '';
            $input->date = '';

            $input->cost_particulars = '';
            $input->amount = '';


            
            $data['input'] = $input;
            $data['detailRowDataList'] 	= array();
            $users = $this->Admin_m->myAssistants(getUserData('user_id'));  

            if(getUserData('is_admin') == 1){
                $data['leads'] = getLead(['leads.status' => 0], true);
            } else {
                $data['leads'] = getLead(['leads.status' => 0 ,'where_in' => ['leads.km' => $users]], true);
            }

            $data['class'] = 'index2';
            $data['page'] = 'hr/management/Visitreport/form';
            $data['view'] = 'admin_panel';
            $this->load->view('master', $data);

    }

    public function edit($id)
    {
        $data['input'] = $this->Admin_m->find('client_visit', array('id' => $id));
        $data['input']->desc = $this->Admin_m->findAll('client_visit_desc', array('visit_id' => $data['input']->id));

        $data['leads'] = getLead([], true);
        $data['class'] = 'index2';
        $data['page'] = 'hr/management/Visitreport/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }


    public function save()
    {
        if($this->input->post('bill_type') != 3):
            self::$rules['lead_id'] = array(
                'field'   => 'lead_id', 
                'label'   => 'Lead/Client', 
                'rules'   => 'trim|required'
            );
        endif;

        $id  = $this->input->post('id');
        $data['user_id']  = getUserData('user_id');
        $data['vrn_no']   = $this->input->post('vrn_no');
        $data['type']= $this->input->post('bill_type');

        if($this->input->post('lead_id')):
            $data['lead_id']  = $this->input->post('lead_id');
        endif;
        $data['location'] = $this->input->post('location');
        $data['purpose']  = $this->input->post('purpose');
        $data['others']  = $this->input->post('others');
        $data['outcome']  = $this->input->post('outcome');
        $data['visit_date'] = $this->input->post('visit_date');
        $data['date']= date('Y-m-d h:i:s');

        $particulars = $this->input->post('particulars');
        $date = $this->input->post('date'); 

        $cost_particulars = $this->input->post('cost_particulars');
        $amount = $this->input->post('amount');
        $this->form_validation->set_rules(self::$rules);
     
        if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
            $this->db->trans_start();

            if ($this->input->post('submit') == 'Save & Submit') {
                $data['status'] = '2';
                if(!empty($id)) {
                    $save_id = $this->Admin_m->update('client_visit', $data, array('id' => $id));
                   // $message = 'Item update successfull';  

                    $this->Admin_m->delete('client_visit_desc', ['visit_id' => $id]);

                    foreach ($particulars as $key => $particulars) {
                        $particulars = [
                            'visit_id' => $id ,
                            'particulars' => $particulars,
                            'date' => timeConvertFormtoDB($date[$key]),
                            //'date' => date("H:i", strtotime($date[$key])),
                        ];
                        $this->Admin_m->save('client_visit_desc', $particulars);
                    }
                }else{
                    $save_id = $this->Admin_m->save('client_visit', $data);
                    //$message = 'Item save successfull';
                        
                    foreach ($particulars as $key => $particulars) {
                        $particulars = [
                            'visit_id' => $save_id ,
                            'particulars' => $particulars,
                            'date' => timeConvertFormtoDB($date[$key]),
                           // 'date' => date("H:i", strtotime($date[$key])),
                        ];
                        $this->Admin_m->save('client_visit_desc', $particulars);
                    }

                }

                $notification = [
                    'tbl_name'      => 'client_visit',
                    'tbl_pk'        => $save_id,
                    'user_id'       => getUserData('user_id'), 
                    'usertype_id'   => getUserData('user_type'),
                    'title'         => '<strong>'.getUserData('fullname').'</strong> Visitreport Created',
                    'source_url'    => 'hr/management/Visitreport/view/'.$save_id,
                    'deadline'      => NULL, 
                    'list_class'    => 'info',
                    'created_date'  => date('Y-m-d H:i:sa'),
                    ];
                $this->Admin_m->save('notifications', $notification);
                
                $message = 'Visitreport Saved and submited successfully';
 
            } else {
                if(!empty($id)) {
                    $this->Admin_m->update('client_visit', $data, array('id' => $id)); 

                    $this->Admin_m->delete('client_visit_desc', ['visit_id' => $id]);

                    foreach ($particulars as $key => $particulars) {
                        $particulars = [
                            'visit_id' => $id ,
                            'particulars' => $particulars,
                            'date' => timeConvertFormtoDB($date[$key]),
                            //'date' => date("H:i", strtotime($date[$key])),
                        ];
                        $this->Admin_m->save('client_visit_desc', $particulars);
                    }
                $message = 'Item update successfull';

                }else{
                    $save_id = $this->Admin_m->save('client_visit', $data);
                    $message = 'Item save successfull';
                        
                    foreach ($particulars as $key => $particulars) {
                        $particulars = [
                            'visit_id' => $save_id ,
                            'particulars' => $particulars,
                            'date' => date("H:i", strtotime($date[$key])),
                        ];
                        $this->Admin_m->save('client_visit_desc', $particulars);
                    }


                }
                     
            }                       

            $this->db->trans_complete();

            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                    'url' => site_url('hr/management/visitreport'),
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('hr/management/visitreport'),
                ]; 
            }

            echo json_encode($return);

        }
    }
    
    public function getListData(){
        $users = $this->Admin_m->myAssistants(getUserData('user_id'));
        $lists = $this->Admin_m->findall_datatable(
            'Admin_m', // Model name
            '_get_visitreport_query', // Function Name
            'filter', // Query type
            (getUserData('is_admin') == 1 ? (getUserData('user_type') == 6 ? ['employees.department_id' => 7] : []) : ['where_in' => ['employees.user_id' => $users]]) // coditions
        );

        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {
            if($list->user_id == getUserData('user_id') || $list->user_id != getUserData('user_id') && $list->status != 1):

                $button = '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('hr/management/visitreport/view/'.$list->id).'" data-toggle="tooltip" data-placement="top" title="View" data-html="form" data-selector="employee">
                <i class="zmdi zmdi-eye table-icon"></i>
            </a>&nbsp;';

               if($list->status == 2 && $list->user_id == getUserData('user_id')){
                $button .= '<a class="btn btn-default btn-icon btn-simple btn-icon-mini btn-round" href="'.site_url('hr/bill/accounts/billsubmission/new_/?vid='.$list->id).'" data-toggle="tooltip" data-placement="top" title="Add bill" data-html="form" data-selector="employee">
                <i class="zmdi zmdi-loupe table-icon"></i>
                    </a>';
                }
                    

                $no++;
                $row = array();
                
                $row[] = $list->vrn_no;
                $row[] = ucwords($list->first_name).' '.ucwords($list->last_name);
                $row[] = ($list->others ? $list->others : $list->client_name);
                $row[] = $list->location;
                $row[] = $list->purpose;
                $row[] = $button;
                $data[] = $row;
            endif;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Admin_m->findall_datatable(
                    'Admin_m', // Model name
                    '_get_visitreport_query', // Function Name
                    'count', // Query type
                    ['where_in' => ['employees.user_id' => $users]] // coditions
                ),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);

    }
    
    
    public function view($id)
    {
        $data['input'] = $this->Admin_m->find('client_visit', array('id' => $id));
        $data['input']->desc = $this->Admin_m->findAll('client_visit_desc', array('visit_id' => $data['input']->id));
        $data['input']->reviews = $this->Admin_m->findVisitreport($id);
        $data['leads'] = getLead([], true);
        $data['class'] = 'index2';
        $data['page']  = 'hr/management/Visitreport/view';
        $data['view']  = 'admin_panel';
        $this->load->view('master', $data);
    }


    function review() {
        $this->form_validation->set_rules('review', 'Review', 'required');
        
        if($this->form_validation->run() == FALSE) {
            $return['type']    = 'validation_error'; 
        } else {
            $this->db->trans_start();
            $data = [
                'visitreport_id' => $this->input->post('visitreport_id'),
                'comment' => $this->input->post('review'),
                'user_id' => getUserData('user_id')
            ];

            $this->Admin_m->save('visitreport_comment', $data);
            $message = 'Review has been Posted';

            $this->db->trans_complete();
            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Somthing wrong data not saved!',
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('hr/management/visitreport/view/'.$data['visitreport_id']),
                ]; 
            }

            echo json_encode($return);
    }
}
    
    public function report(){

        if($_REQUEST['columns'][0]['search']['value'] || $_REQUEST['columns'][1]['search']['value'] || $_REQUEST['columns'][2]['search']['value'] || $_REQUEST['columns'][3]['search']['value']):
            $users = $this->Admin_m->myAssistants(getUserData('user_id'));
            $lists = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_visitreport_query', // Function Name
                'filter' // Query type            
            );

            $data = array();

            $no = $_POST['start'];

            foreach ($lists as $key => $list) {
                if($list->user_id == getUserData('user_id') || $list->user_id != getUserData('user_id') && $list->status != 1):

                    $no++;
                    $row = array();                
                    $row[] = $list->vrn_no;
                    $row[] = ucwords($list->first_name).' '.ucwords($list->last_name);
                    $row[] = ($list->others ? $list->others : getLead(['leads.id' => $list->lead_id]));
                    $row[] = $list->location;
                    $row[] = $list->purpose;
                    $data[] = $row;
                endif;
            }

            $output = array(
                "draw"              => $_POST['draw'],
                "recordsTotal"      => '',
                "recordsFiltered"   => $this->Admin_m->findall_datatable(
                        'Report_m', // Model name
                        '_get_visitreport_query', // Function Name
                        'count' // Query type
                    ),
                "data"              => $data,
            );
        else:
            $output = array(
                "draw"              => '',
                "recordsTotal"      => '',
                "recordsFiltered"   => 0,
                "data"              => [],
            );
        endif;     

        //output to json format
        echo json_encode($output);
           
    }

    public function savereport(){

        $data['user_id'] = $this->input->post('user_id');
        $data['lead_id'] = $this->input->post('lead_id');
        $data['from_date'] = $this->input->post('from_date');
        $data['to_date'] = $this->input->post('to_date');


        $lists['results'] = $this->Admin_m->findall_datatable(
                'Report_m', // Model name
                '_get_visitreport_query', // Function Name
                '', // Query type    
                $data        
            );
        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('hr/reports/management/pdf/visitreport',$lists);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->set_paper('A4', 'landscape');
        $dompdf->render();
        $dompdf->stream('projectreport_'.date('Ymd').'.pdf',array("Attachment"=>0));
    }
    
}
