<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Inventory extends Admin_controller {



    public function __construct(){
        parent::__construct();

    }

    static $rules = array(
        'warehouse_id' => array(
            'field' => 'warehouse_id',
            'label' => 'Warehouse Name',
            'rules' => 'trim|required'
        ),
        'product_id' => array(
            'field' => 'product_id',
            'label' => 'Product',
            'rules' => 'trim|required'
        ),
        'product_brand' => array(
            'field' => 'product_brand',
            'label' => 'Product Brand',
            'rules' => 'trim|required'
        ),
        'model_no' => array(
            'field' => 'model_no',
            'label' => 'Model no',
            'rules' => 'trim|required'
        ),
        'description' => array(
            'field' => 'description',
            'label' => 'Description',
            'rules' => 'trim|required'
        ),
        'doc_link' => array(
            'field' => 'doc_link',
            'label' => 'Photo',
            'rules' => 'trim|required'
        ),
    );

    static $rules_assign  = array(
        'user_id' => array(
            'field' => 'user_id',
            'label' => 'Employee',
            'rules' => 'trim|required'
        ), 
        'cat_id' => array(
            'field' => 'cat_id[]',
            'label' => 'Category',
            'rules' => 'trim|required'
        ), 
        'product_id' => array(
            'field' => 'product_id[]',
            'label' => 'Product',
            'rules' => 'trim|required'
        ), 
        'inventory_id' => array(
            'field' => 'inventory_id[]',
            'label' => 'Inventory',
            'rules' => 'trim|required'
        ),
    );

    public function index()
    {
        $data['class'] = 'index2';
        $data['page'] = 'inventory/inventory/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function getListData(){

        $where = [];

        $lists = $this->Inventory_m->findall_datatable(
            'Inventory_m', // Model name
            '_get_inventory_query', // Function Name
            'filter', // Query type
            $where // coditions
        );
        
        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '';

            if ($list->status == 1) {
               $status = '<span class="badge badge-success">Available</span>';
            }elseif ($list->status == 2) {
               $status = '<span class="badge badge-info">Assigned</span>';
            }elseif ($list->status == 3) {
               $status = '<span class="badge badge-warning">Servicing</span>';
            }elseif ($list->status == 0){
               $status = '<span class="badge badge-danger">Wasted/lost</span>';
            }
            if ($list->status != 0) {
               $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm" data-toggle="tooltip" data-placement="top" title="Edit" data-html="form" data-selector="inventory" href="'.site_url('inventory/inventory/edit/'.$list->id).'">
                <i class="material-icons icons-padding">create</i>
            </a>';
            }
           

            $no++;
            $row = array();
            $row[] = $list->warehouse_name;
            $row[] = $list->product_name;
            $row[] = $list->product_brand_name;
            $row[] = $list->model_no;
            $row[] = $list->description;
            $row[] = $list->purchase_date;
            $row[] = $list->invoice_no;
            $row[] = $status;
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Inventory_m->findall_datatable('Inventory_m', '_get_inventory_query', 'count', $where),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

    public function new_()
    {
        $input = new stdClass();
        $input->id            = '';
        $input->warehouse_id  = '';
        $input->product_id    = '';
        $input->product_brand = '';
        $input->model_no      = '';
        $input->description   = '';
        $input->purchase_date = '';
        $input->invoice_no    = '';
        $input->status        = '';
        $input->criteria_desc = '';
        $input->doc_link      = '';


        $data['input']                  = $input;
        $data['detailRowDataList']      = array();
        $data['class'] = 'index2';
        $data['page'] = 'inventory/inventory/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function edit($id)
    {
        $data['input'] = $this->Inventory_m->find('inventory', array('id' => $id));
        $data['class'] = 'index2';
        $data['page'] = 'inventory/inventory/form';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);


        
        /*$data['input'] = $this->Inventory_m->find('inventory', array('id' => $id));
        if (!empty($data['input'])) {
            $this->load->view('inventory/inventory/form', $data);
        }else{
            pageNotFound();
        }*/
     
    }

    public function save()
	{
		$id	                   = $this->input->post('id');
		$data['warehouse_id']  = $this->input->post('warehouse_id');
		$data['product_id']    = $this->input->post('product_id');		
		$data['product_brand'] = $this->input->post('product_brand');
		$data['model_no']	   = $this->input->post('model_no');
		$data['description']   = $this->input->post('description');
		$data['purchase_date'] = $this->input->post('purchase_date');
        $data['invoice_no']    = $this->input->post('invoice_no');
        $data['criteria_desc'] = ($this->input->post('criteria') ? array_to_string($this->input->post('criteria')) : '');
        $data['doc_link']  = $this->input->post('doc_link');

        if($this->input->post('status')):
            $data['status']  = $this->input->post('status');
        endif;
		
        if($this->input->post('criteria')):
            self::$rules['criteria'] = array(
                'field'   => 'criteria[]', 
                'label'   => 'Criteria', 
                'rules'   => 'trim|required'
            );
        endif;

		$this->form_validation->set_rules(self::$rules);
		
		if($this->form_validation->run() == FALSE) {
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {  
			if(!empty($id)) {
                $data['updated_by']    = getUserData('user_id');
                $data['updated_at']    = date('Y-m-d H:m:i');

				$this->Inventory_m->update('inventory', $data, array('id' => $id));
				$message = 'Item update successfull';				
			} else {
                $data['created_by']    = getUserData('user_id');
                $data['created_at']    = date('Y-m-d H:m:i');
				$data['id'] 	= $this->Inventory_m->save('inventory', $data);
				$message = 'Item save successfull';
			}

            if ($this->db->trans_status() === FALSE){
                    $return = [
                        'type' => 'not_success', 
                        'class' => 'warning',
                        'message' =>  'Something is wrong!',
                        /*'url' => site_url('crm/lead/Leads/new_'),*/
                    ]; 
                } else {
                    $return = [
                        'type' => 'save_success', 
                        'class' => 'success',
                        'message' =>  $message,
                        'url' => site_url('inventory/inventory/'),
                    ]; 
                }

            echo json_encode($return);	
			
		}
	}

    public function assignInventory()
    {
        $data['class'] = 'index2';
        $data['page'] = 'inventory/inventory/assign';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function getInvetoryByEmp()
    {
        $results = $this->Inventory_m->findAll('assigned_inventory', ['user_id' => $this->input->post('user_id'), 'status' => '1']);

        $html = '';

        if($results):
            foreach ($results as $key => $row):
                $html .= '<tr class="multiple saved">
                    <td><input type="hidden" name="id" value="'.$row->id.'" class="id"/>'.
                        form_dropdown('cat_id[]' , listdata('product_category'), $row->cat_id, ['class' => 'cat_id'])
                    .'</td>
                    <td>'.
                        form_dropdown('product_id[]' , listdata('products'), $row->product_id, ['class' => 'product_id'])
                    .'</td>
                    <td>'.
                        form_dropdown('inventory_id[]' , getInventoryList(), $row->inventory_id, ['class' => 'inventory_id'])
                    .'</td>
                    <td>
                        <button type="button" class="btn btn-sm btn-round btn-danger divestInventory">
                            <i class="zmdi zmdi-close"></i> Divest
                        </button>
                    </td>
                </tr>';
            endforeach;
        endif;

        $requisition = $this->Inventory_m->findAll('inv_requisition', ['user_id' => $this->input->post('user_id'), 'status' => '0']);

        if($requisition):
            foreach($requisition as $row):
                $html .= '<tr class="multiple saved"  data-ele_name="assignRow" >
                    <td><input type="hidden" name="id" value="'.$row->id.'" class="id"/>'.
                        form_dropdown('cat_id[]' , listdata('product_category'), $row->category_id, ['class' => 'form-control cat_id'])
                    .'</td>
                    <td>'.
                        form_dropdown('product_id[]' , listdata('products', '', ['product_category' => $row->category_id]), '',['class' => 'form-control product_id'])
                    .'</td>
                    <td>'.
                        form_dropdown('inventory_id[]' , getInventoryList(), '', ['class' => 'form-control inventory_id'])
                    .'</td>
                    <td>
                        <button type="button" class="btn btn-sm btn-round btn-danger refuseInventory">
                            <i class="zmdi zmdi-close"></i> Refuse
                        </button>
                    </td>
                </tr>';
            endforeach;
        endif;

        if($results || $requisition):
            echo json_encode(['sataus' => 'success', 'data' => $html]);
        else:
            echo json_encode(['sataus' => 'error', 'data' => $html]);
        endif;

    }

    public function getCatProduct()
    {
        $result = $this->Inventory_m->findAll('products', ['product_category' => $this->input->post('cat_id'), 'status' => 1]);
        echo json_encode($result);
    }

    public function getProductInventory()
    {
        $product_id = $this->input->post('product_id');
        $cat_id = $this->input->post('cat_id');

        $result = getInventoryList(['inventory.product_id' => $product_id, 'inventory.status' => '1'], '', '', true);
        echo json_encode($result);
    }

    public function saveAssignInventory()
    {
        $this->form_validation->set_rules(self::$rules_assign);
        
        if($this->form_validation->run() == FALSE) {
            //dd($this->form_validation->error_array());
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
            $user_id = $this->input->post('user_id');
            $cat_id = $this->input->post('cat_id');
            $product_id = $this->input->post('product_id');
            $inventory_id = $this->input->post('inventory_id');
            
            $this->db->trans_start();

                $requisition = $this->Inventory_m->find('inv_requisition', ['user_id' => $user_id, 'status' => '0']);

                $this->Inventory_m->delete('assigned_inventory',['user_id' => $user_id]);
               
                foreach ($cat_id as $key => $cat) {
                    $this->Inventory_m->update('inventory', ['status' => '2'], ['id' => $inventory_id[$key]]);
                    $data[] = [
                        'user_id' => $user_id,
                        'cat_id' => $cat,
                        'product_id' => $product_id[$key],
                        'inventory_id' => $inventory_id[$key],
                    ];

                    if($requisition){
                        $data[$key]['requisition_id'] = $requisition->id;
                        $this->Inventory_m->update('inv_requisition', ['status' => '1'], ['id' => $requisition->id]);
                    } 
                }
                $this->Inventory_m->save('assigned_inventory', $data, true);
                $message = "Assigned successfully";

            $this->db->trans_complete();    
            
            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Something is wrong!',
                    /*'url' => site_url('crm/lead/Leads/new_'),*/
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('inventory/inventory/assignInventory'),
                ]; 
            }

            echo json_encode($return);
        }
    }

    public function divestInventory()
    {
        $id = $this->input->post('id');
        $this->db->trans_start();

            $this->Inventory_m->update('assigned_inventory',['status' =>'0'],['id' => $id]);
            $this->Inventory_m->update('inventory',['status' =>'1', 'updated_by' => getUserData('user_id'), 'updated_at' => date('Y-m-d H:m:i')],['id' => $this->Inventory_m->find('assigned_inventory', ['id' => $id])->inventory_id]);
            $this->Inventory_m->update('inv_requisition',['status' =>'3', 'updated_by' => getUserData('user_id'), 'updated_at' => date('Y-m-d H:m:i')],['id' => $this->Inventory_m->find('assigned_inventory', ['id' => $id])->requisition_id, 'category_id' => $this->Inventory_m->find('assigned_inventory', ['id' => $id])->cat_id]);

        $this->db->trans_complete();    

        if ($this->db->trans_status() === FALSE){
            $output = array(
                'hasError'      => 0, 
                'class'         => 'error', 
                'message'       => 'Something is wrong!', 
                'detailMessage' => ''
            );
        } else {
            $output = array(
                'hasError'      => 0, 
                'class'         => 'success', 
                'message'       => 'Item divest successfull', 
                'detailMessage' => ''
            );
        }

        echo json_encode($output);
    }

    public function refuseInventory($value='')
    {
        $id = $this->input->post('id');
        $this->db->trans_start();

            $this->Inventory_m->update('inv_requisition',['status' =>'2', 'updated_by' => getUserData('user_id'), 'updated_at' => date('Y-m-d H:m:i')],['id' => $id]);

        $this->db->trans_complete();    

        if ($this->db->trans_status() === FALSE){
            $output = array(
                'hasError'      => 0, 
                'class'         => 'error', 
                'message'       => 'Something is wrong!', 
                'detailMessage' => ''
            );
        } else {
            $output = array(
                'hasError'      => 0, 
                'class'         => 'success', 
                'message'       => 'Item refused successfull', 
                'detailMessage' => ''
            );
        }

        echo json_encode($output);
    }

    function requisition(){
        $this->load->view('inventory/requisition/list');

        }

    public function inventoryreport()
    {
        $data['class'] = 'index2';
        $data['page'] = 'inventory/report/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }


    function report(){
        if($_REQUEST['columns'][0]['search']['value'] || $_REQUEST['columns'][1]['search']['value'] || $_REQUEST['columns'][2]['search']['value']):
        $lists = $this->Inventory_m->findall_datatable(
            'Inventory_m', // Model name
            '_get_inventory_report_query', // Function Name
            'filter'  // Query type                 
        );
        $data = array();
        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $no++;
            $row   = array();
            
            $row[] = $list->product_user_name;
            $row[] = $list->cat_name;
            $row[] = $list->product_name;
            $data[]= $row;
        }
        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Inventory_m->findall_datatable('Inventory_m', '_get_inventory_report_query', 'count'),
            "data"              => $data,
        );
        else:
        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => 0,
            "data"              => [],
        );
        endif;
        //output to json format
        echo json_encode($output);
    }

    public function savereport(){
        $data['user_id'] = $this->input->post('user_id');
        $data['cat_id'] = $this->input->post('cat_id');
        $data['product_id'] = $this->input->post('product_id');
        $lists['results'] = $this->Inventory_m->findall_datatable(
                'Inventory_m', // Model name
                '_get_inventory_report_query', // Function Name
                '', // Query type    
                $data        
            );

        $options = new \Dompdf\Options();
        $dompdf  = new \Dompdf\Dompdf();
        $options->setIsRemoteEnabled(true);
        $dompdf->setOptions($options);
        $this->load->view('inventory/report/pdf/inventoryreport',$lists);
        $html = $this->output->get_output();
        $dompdf->loadHtml($html);
        $dompdf->render();
        $dompdf->stream('inventoryReport_'.date('Ymd').'.pdf',array("Attachment"=>0));
    }

}