<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Requisition extends Admin_controller {



    public function __construct(){
        parent::__construct();
        siteStatus();
    }

    static $rules = array(
        'from_date' => array(
            'field' => 'from_date',
            'label' => 'From Date',
            'rules' => 'trim|required'
        ), 
        'category_id' => array(
            'field' => 'category_id[]',
            'label' => 'Category',
            'rules' => 'trim|required'
        ),  
    );

    public function index()
    {
        $data['class'] = 'index2';
        $data['page'] = 'inventory/requisition/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
    }

    public function getListData(){

        $where = [];

        if(getUserData('is_admin') == 1 || getUserData('user_type') == 3):
            $where = ['inv_requisition.status' => '0'];            
        endif;

        $lists = $this->Inventory_m->findall_datatable(
            'Inventory_m', // Model name
            '_get_requisition_query', // Function Name
            'filter', // Query type
            $where // coditions
        );
        
        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('inventory/requisition/deny').'" data-id="'.$list->id.'">
                <i class="material-icons icons-padding">delete_forever</i>
            </a> ';

            if ($list->status == 2) {
               $status = '<span class="badge badge-danger">Refused</span>';
            }elseif ($list->status == 1) {
               $status = '<span class="badge badge-success">Assigned</span>';
           }elseif ($list->status == 3) {
               $status = '<span class="badge badge-info">Returned</span>';
           }elseif ($list->status == 0) {
               $status = '<span class="badge badge-warning">Pending</span>';
           }

           

            $no++;
            $row = array();
            $row[] = $list->fullname;
            $row[] = $list->cat_name;
            $row[] = $list->from_date;
            $row[] = $list->to_date;
            $row[] = $status;
            $row[] = ($list->status == 0 && getUserData('is_admin') == 1 || $list->status == 0 && getUserData('user_type') == 3 ? $button : '');
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => '',
            "recordsFiltered"   => $this->Inventory_m->findall_datatable('Inventory_m', '_get_requisition_query', 'count', $where),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

    public function new_()
    {

        $input = new stdClass();
        $input->id             = '';
        $input->description    = '';
        $input->from_date      = '';
        $input->to_date        = '';

        $data['input']                  = $input;
        $data['detailRowDataList']      = array();
        $this->load->view('inventory/requisition/form', $data);
    }

    public function save()
	{
		$this->form_validation->set_rules(self::$rules);
		
		if($this->form_validation->run() == FALSE) {
            //dd($this->form_validation->error_array());
            $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return); 
        } else {
            $this->db->trans_start();
                $category_id   = $this->input->post('category_id');

    			foreach ($category_id as $key => $cat):
                    $data[$key] = [
                        'req_no' => date('md').rand(pow(10, 4-1), pow(10, 4)-1),
                        'user_id' => getUserData('user_id'),
                        'category_id' => $cat,
                        'from_date' => $this->input->post('from_date'),
                        'to_date' => $this->input->post('to_date'),
                        'created_at' => date('Y-m-d H:m:i')
                    ];
                endforeach;

                $this->Inventory_m->save('inv_requisition', $data, true);
                $message = "Requisition successfully submited";
            $this->db->trans_complete();

            if ($this->db->trans_status() === FALSE){
                $return = [
                    'type' => 'not_success', 
                    'class' => 'warning',
                    'message' =>  'Something is wrong!',
                    /*'url' => site_url('crm/lead/Leads/new_'),*/
                ]; 
            } else {
                $return = [
                    'type' => 'save_success', 
                    'class' => 'success',
                    'message' =>  $message,
                    'url' => site_url('inventory/requisition/'),
                ]; 
            }

            echo json_encode($return);
        }
	}

    public function deny () {
        $id = $this->input->post('id');
       
        $data['status'] = '2';

        $id = $this->Inventory_m->update('inv_requisition', $data, array('id' => $id));
        $output = array('hasError' => 0, 'class' => 'success', 'message' => 'denied Successfully', 'detailMessage' => '');
        echo json_encode($output);

    }

   
}