<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Products extends Admin_controller {


    public function __construct(){
        parent::__construct();
        siteStatus();
    }

    static $rules_add = array(
        'product_category' => array(
                'field' => 'product_category', 
                'label' => 'product_category', 
                'rules' => 'trim|required[products.product_category]'
        ),
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required|is_unique[products.name]'
        ),
    );

    static $rules_update = array(
        'product_category' => array(
                'field' => 'product_category', 
                'label' => 'product_category', 
                'rules' => 'trim|required[products.product_category]'
            
        ),
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required[products.name]'
        ),
    );

	public function index()
	{
		$data['class'] = 'index2';
        $data['page'] = 'inventory/setup/products/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function new_()
	{
		$input = new stdClass();
		$input->id 		         = '';
        $input->product_category = '';
		$input->product_brand    = '';
		$input->name             = '';
		$input->product_code 	 = '';
		$input->description 	 = '';
		$data['input'] 		= $input;

		$this->load->view('inventory/setup/products/form', $data);
	}

	public function getListData(){

        $where = ['deleted_at'=> NULL, 'tbl_name' => 'products'];

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'filter', // Query type
                $where // coditions
            );
        
        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '';
                      
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm" data-toggle="modal" data-target="#exampleModal" data-title="Edit Products" data-href="'.site_url('inventory/setup/products/edit/'.$list->id).'" data-id="'.$list->id.'" data-html="form" data-selector="edit">
                <i class="material-icons icons-padding">create</i>
            </a> ';
         
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('inventory/setup/products/delete').'" data-id="'.$list->id.'">
                <i class="material-icons icons-padding">delete_forever</i>
            </a> ';
            $no++;
            $row = array();
            $row[] = listdata('product_category', false, ['id' => $list->product_category], true);
            $row[] = listdata('product_brand', false, ['id' => $list->product_brand], true);
            $row[] = $list->name;
            $row[] = $list->product_code;
            $row[] = $list->description;
            $row[] = '<div class="flipswitch">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-href="'.site_url('inventory/setup/products/status').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' '.(getUserData('is_admin') == 0 ? 'disabled': '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                '', // Query type
                $where // coditions
            ),
            "recordsFiltered"   => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'count', // Query type
                $where // coditions
            ),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->find('products', array('id' => $id));

		$this->load->view('inventory/setup/products/form', $data);
	}

	public function save()
	{
		$id	                        = $this->input->post('id');
        $data['product_category']   = $this->input->post('product_category');
		$data['product_brand']	    = $this->input->post('product_brand');
		$data['name']               = $this->input->post('name');		
		$data['product_code']	    = $this->input->post('product_code');
		$data['description']	    = $this->input->post('description');
		
		if($id) {
			$this->form_validation->set_rules(self::$rules_update);
		} else {
			$this->form_validation->set_rules(self::$rules_add);
		}	
		if($this->form_validation->run() == FALSE) {
        $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return);
        } else {

            if(!empty($id)) {
                $this->Admin_m->update('products', $data, array('id' => $id));
                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Item update successfull !!';
                $return['url'] = base_url('inventory/setup/products/');          
            } else {    
                $data['id']    = $this->Admin_m->save('products', $data);

                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Item added successfully !!';
                $return['url'] = base_url('inventory/setup/products/'); 
                
            }
            echo json_encode($return);
        }
	}

	public function status(){
		$id = $this->input->post('id');
		$data['status'] = $this->input->post('status');

		$this->Admin_m->update('products', $data, array('id' => $id));
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Status update successfull', 'detailMessage' => '');

		echo json_encode($returnData);

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('products', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

}