<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Warehouse extends Admin_controller {

    static $model 	= array();
    static $helper	= array();

    public function __construct(){
        parent::__construct();
        $this->load->database();
        $this->load->model(self::$model);
        $this->load->helper(self::$helper);
    }

    static $rules_add = array(
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required|is_unique[warehouse.name]'
        ),
        'address' => array(
                'field' => 'address', 
                'label' => 'Address', 
                'rules' => 'trim|required[warehouse.address]'
        ),
        'contact_person' => array(
                'field' => 'contact_person', 
                'label' => 'Contact person', 
                'rules' => 'trim|required[warehouse.contact_person]'
        ),
        'contact_number' => array(
                'field' => 'contact_number', 
                'label' => 'Contact number', 
                'rules' => 'trim|numeric|min_length[11]|max_length[14]|required[warehouse.contact_number]'
        ),
    );

    static $rules_update = array(
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),
        'address' => array(
                'field' => 'address', 
                'label' => 'Address', 
                'rules' => 'trim|required[warehouse.address]'
        ),
        'contact_person' => array(
                'field' => 'contact_person', 
                'label' => 'Contact person', 
                'rules' => 'trim|required[warehouse.contact_person]'
        ),
        'contact_number' => array(
                'field' => 'contact_number', 
                'label' => 'Contact number', 
                'rules' => 'trim|numeric|min_length[11]|max_length[17]|required[warehouse.contact_number]'
        ),
    );

	public function index()
	{
        $data['class'] = 'index2';
        $data['page'] = 'inventory/setup/warehouse/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);
	}

	public function new_()
	{
		$input = new stdClass();
		$input->id 		        = '';
		$input->name 	        = '';
		$input->address 	    = '';
		$input->contact_person 	= '';
		$input->contact_number 	= '';
		$data['input'] 		    = $input;

		$this->load->view('inventory/setup/warehouse/form', $data);
	}

	public function getListData(){

        $where = ['deleted_at'=> NULL, 'tbl_name' => 'warehouse'];

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'filter', // Query type
                $where // coditions
            );
        
        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '';
                      
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm" data-toggle="modal" data-target="#exampleModal" data-title="Edit Warehouse" data-href="'.site_url('inventory/setup/warehouse/edit/'.$list->id).'" data-id="'.$list->id.'" data-html="form" data-selector="edit">
                <i class="material-icons icons-padding">create</i>
            </a> ';
         
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('inventory/setup/warehouse/delete').'" data-id="'.$list->id.'">
                <i class="material-icons icons-padding">delete_forever</i>
            </a>';
            $no++;
            $row = array();
            $row[] = $list->name;
            $row[] = $list->address;
            $row[] = userList(['users.id' => $list->contact_person], '', true);
            $row[] = $list->contact_number;
            $row[] = '<div class="flipswitch">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-href="'.site_url('inventory/setup/warehouse/status').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' '.(getUserData('is_admin') == 0 ? 'disabled': '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                '', // Query type
                $where // coditions
            ),
            "recordsFiltered"   => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'count', // Query type
                $where // coditions
            ),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->find('warehouse', array('id' => $id));

		$this->load->view('inventory/setup/warehouse/form', $data);
	}

	public function save()
	{
		$id	= $this->input->post('id');
		$data['name']    = $this->input->post('name');		
		$data['address'] = $this->input->post('address');		
		$data['contact_person'] = $this->input->post('contact_person');		
		$data['contact_number'] = $this->input->post('contact_number');		

		if($id) {
			$this->form_validation->set_rules(self::$rules_update);
		} else {
			$this->form_validation->set_rules(self::$rules_add);
		}
        if($this->form_validation->run() == FALSE) {
        $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return);
        } else {

            if(!empty($id)) {
                $this->Admin_m->update('warehouse', $data, array('id' => $id));
                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Item update successfull !!';
                $return['url'] = base_url('inventory/setup/warehouse/');          
            } else {    
                $data['id']    = $this->Admin_m->save('warehouse', $data);

                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Item added successfully !!';
                $return['url'] = base_url('inventory/setup/warehouse/'); 
                
            }
            echo json_encode($return);
        }
	}

	public function status(){
		$id = $this->input->post('id');
		$data['status'] = $this->input->post('status');

		$this->Admin_m->update('warehouse', $data, array('id' => $id));
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Status update successfull', 'detailMessage' => '');

		echo json_encode($returnData);

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('warehouse', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

}