<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Service_modules extends Admin_controller {

	static $model 	= array();
	static $helper	= array();
	
	public function __construct(){
		parent::__construct();
        siteStatus();
	}

	static $rules_add = array(
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required|is_unique[service_modules.name]'
        ),
        'service_id' => array(
                'field' => 'service_id[]', 
                'label' => 'Service id', 
                'rules' => 'trim|required'
        ),
        'min_range' => array(
                'field' => 'min_range', 
                'label' => 'Min range', 
                'rules' => 'trim|required'
        ),
        'max_range' => array(
                'field' => 'max_range', 
                'label' => 'Max range', 
                'rules' => 'trim|required'
        ),
    );

    static $rules_update = array(
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),
        'service_id' => array(
                'field' => 'service_id[]', 
                'label' => 'Service id', 
                'rules' => 'trim|required'
        ),
        'min_range' => array(
                'field' => 'min_range', 
                'label' => 'Min range', 
                'rules' => 'trim|required'
        ),
        'max_range' => array(
                'field' => 'max_range', 
                'label' => 'Max range', 
                'rules' => 'trim|required'
        ),
    );

	public function index()
	{
		$data['class'] = 'index2';
        $data['page'] = 'setup/service_modules/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}

	public function new_($callback = '')
	{
		$input = new stdClass();
		$input->id 			= '';
		$input->service_id 	= '';
		$input->name 		= '';
		$input->description = '';
		$input->min_range   = '';
        $input->max_range   = '';
		$data['input'] 		= $input;

		$this->load->view('setup/service_modules/form', $data);
	}

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->find('service_modules', array('id' => $id));


		$this->load->view('setup/service_modules/form', $data);
	}


	public function save()
    {
        $id	= $this->input->post('id');
		$data['service_id']  = array_to_string($this->input->post('service_id'));		
		$data['name']        = $this->input->post('name');		
        $data['description'] = $this->input->post('description');       
		$data['status']      = '1';		
		if($this->input->post('max_range')):
            $data['min_range']   = $this->input->post('min_range');    
            $data['max_range']   = $this->input->post('max_range');    
        endif;

        if($id) {
            $this->form_validation->set_rules(self::$rules_update);
        } else {
            $this->form_validation->set_rules(self::$rules_add);
        }   
        if($this->form_validation->run() == FALSE) {
        $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return);
        } else {

            if(!empty($id)) {
                $this->Admin_m->update('service_modules', $data, array('id' => $id));
                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Services update successfull !!';
                $return['url'] = base_url('setup/service_modules');          
            } else {    
                $data['id']    = $this->Admin_m->save('service_modules', $data);

                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Services added successfully !!';
                $return['url'] = base_url('setup/service_modules'); 
                
            }
            echo json_encode($return);

        }
        
    }

    public function filterModule()
    {
        $id = $this->input->post('id');
        $parentId = $this->Admin_m->find('services', ['id' => $id]);
        $results = $this->Admin_m->getModuleList($id);

        $html = '';

        if($results){
            $html .= '<div class="col-sm-12 m-t-20 wrap">
                <table class="table">
                    <thead>
                        <tr>
                            <th width="20"></th>
                            <th width="25%">Module</th>
                            <th>Criteria</th>
                            <th width="200">Note</th>
                        </tr>
                    </thead>
                    <tbody>';
                        foreach ($results as $key => $result):
                            $html .= '<tr>
                                <td>
                                    <div class="form-group">
                                        <div class="checkbox">
                                            <input id="remember_me'.$id.$result['id'].'" type="checkbox" name="module_id['.$key.']['.$id.'][]" value="'.$result['id'].'" class="module_id">
                                            <label for="remember_me'.$id.$result['id'].'"></label>
                                        </div>
                                    </div>
                                </td>
                                <td><input type="text" name="module_name['.$key.']['.$id.']['.$result['id'].'][]" class="form-control" value="'.$result['name'].'" placeholder="Module name" readonly></td>
                                <td><div class="form-group">'.
                                    form_dropdown('criteria['.$key.']['.$id.']['.$result['id'].'][]', listdata('criterions', true, ['status' => '1', 'deleted_at' => NULL]), '', ['class' => 'criteria required', 'multiple' => 'multiple', 'placeholder' => 'Criteria', 'required' => 'required'])
                                .'</div></td>
                                <td>
                                    <div class="form-group">
                                        <textarea name="description['.$key.']['.$id.'][]" class="form-control description" placeholder="Description"></textarea>
                                    </div>
                                </td>
                            </tr>';
                        endforeach;
                    $html .='</tbody>                
                </table>
            </div>';
        }  

        $html .= '<div class="col-sm-12 m-t-20 wrap">
            <div class="form-group">
                <label for="form-field-9">Expected Order Value <span class="text-danger">*</span></label>
                <input name="exp_total_order_val['.$parentId->parent_id.'][]" class="form-control exp_total_order_val" placeholder="Expected Order Value">                    
            </div>
        </div>
        <div class="col-sm-12 m-t-20 wrap">
            <div class="form-group">
                <label for="form-field-9">Expected Order Date <span class="text-danger">*</span></label>
                <input name="exp_order_date['.$parentId->parent_id.'][]" class="form-control exp_order_date datemaxpicker" placeholder="Expected Order Date">                    
            </div>
        </div>
        <div class="col-sm-12 m-t-20 wrap">
            <button class="btn btn-info btn-sm addAnotherService">Add Another Service</button>
        </div>';

        echo $html;
    }




	public function status(){
		$id = $this->input->post('id');
		$data['status'] = $this->input->post('status');

		$this->Admin_m->update('service_modules', $data, array('id' => $id));
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Status update successfull', 'detailMessage' => '');

		echo json_encode($returnData);

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('service_modules', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

	public function getListData(){

        $where = ['deleted_at'=> NULL, 'tbl_name' => 'service_modules'];

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'filter', // Query type
                $where // coditions
            );
        
        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '';
                      
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm" data-toggle="modal" data-target="#exampleModal" data-title="Edit Bill Type" data-href="'.site_url('setup/service_modules/edit/'.$list->id).'" data-id="'.$list->id.'" data-html="form" data-selector="add">
                <i class="material-icons icons-padding">create</i>
            </a> ';
         
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('setup/service_modules/delete/').'" data-id="'.$list->id.'">
                <i class="material-icons icons-padding">delete_forever</i>
            </a> ';
            $no++;
            $row = array();
            $row[] = $list->name;
            $row[] = listdata('services', false, ['id' => $list->service_id], true);
            $row[] = $list->description;
            $row[] = $list->min_range;
            $row[] = $list->max_range;
            $row[] = '<div class="flipswitch" data-toggle="tooltip" data-placement="top" title="Status Change">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-href="'.site_url('setup/service_modules/status').'" data-usertype = "'.getUserData('user_type').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' '.(getUserData('is_admin') == 0 ? 'disabled': '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                '', // Query type
                $where // coditions
            ),
            "recordsFiltered"   => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'count', // Query type
                $where // coditions
            ),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

}