<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Services extends Admin_controller {

	static $model 	= array();
	static $helper	= array();
	
	public function __construct(){
		parent::__construct();
        siteStatus();
	}

	static $rules_add = array(
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required|is_unique[services.name]'
        ),
    );

    static $rules_update = array(
        'name' => array(
                'field' => 'name', 
                'label' => 'Name', 
                'rules' => 'trim|required'
        ),
    );

	public function index()
	{
		$data['class'] = 'index2';
        $data['page'] = 'setup/services/list';
        $data['view'] = 'admin_panel';
        $this->load->view('master', $data);

	}

	public function new_($callback = '')
	{
		$input = new stdClass();
		$input->id 			= '';
		$input->parent_id 	= '';
		$input->name 		= '';
		$input->description = '';
		$input->min_range   = '';
        $input->max_range   = '';
		$data['input'] 		= $input;

		$this->load->view('setup/services/form', $data);
	}

	public function edit($id)
	{
		$data['input'] = $this->Admin_m->find('services', array('id' => $id));


		$this->load->view('setup/services/form', $data);
	}


	public function save()
    {
        $id	= $this->input->post('id');
		if ($this->input->post('services')!='') {
		  $data['parent_id']   = $this->input->post('services');
		}		
		$data['name']        = $this->input->post('name');		
		$data['description'] = $this->input->post('description');		
		if($this->input->post('max_range')):
            $data['min_range']   = $this->input->post('min_range');    
            $data['max_range']   = $this->input->post('max_range');    
        endif;

        if($id) {
            $this->form_validation->set_rules(self::$rules_update);
        } else {
            $this->form_validation->set_rules(self::$rules_add);
        }   
        if($this->form_validation->run() == FALSE) {
        $return['type'] = 'validation_error'; 
            foreach ($this->form_validation->error_array() as $key => $value) {
                $return['message'][str_replace("[]","",$key)] = $value;
            }
            echo json_encode($return);
        } else {

            if(!empty($id)) {
                $this->Admin_m->update('services', $data, array('id' => $id));
                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Services update successfull !!';
                $return['url'] = base_url('setup/services');          
            } else {    
                $data['id']    = $this->Admin_m->save('services', $data);

                $return['type']    = 'save_success'; 
                $return['class']   = 'success';
                $return['message'] = 'Services added successfully !!';
                $return['url'] = base_url('setup/services'); 
                
            }
            echo json_encode($return);

        }
        
    }

    public function filterService()
    {
        $id = $this->input->post('id');
        $results = $this->Admin_m->findAll('services', ['parent_id' => $id, 'status' => '1', 'deleted_at' => NULL], 'result_array');

        if($results){
            $type = ['' => 'SELECT Services'];
            foreach ($results as $key => $row) {
                $type[$row['id']] = $row['name'];
            }

            $html = '<div class="col-sm-12 m-t-20 wrap">
                <div class="form-group">
                    <label for="form-field-9">Sub Services <span class="text-danger">*</span></label>'.
                    form_dropdown('sub_service['.$id.']' , $type, '', ['class' => 'form-control sub_service required', 'placeholder' => 'Sub Services'])
                .'</div>
            </div>';
        }  else {
            $html = '<div class="col-sm-12 m-t-20 wrap">
                <div class="form-group">
                    <label for="form-field-9">Expected Order Value <span class="text-danger">*</span></label>
                    <input name="exp_total_order_val['.$id.'][]" class="form-control exp_total_order_val" placeholder="Expected Order Value">                    
                </div>
            </div>
            <div class="col-sm-12 m-t-20 wrap">
                <div class="form-group">
                    <label for="form-field-9">Expected Order Date <span class="text-danger">*</span></label>
                    <input name="exp_order_date['.$id.'][]" class="form-control exp_order_date datemaxpicker" placeholder="Expected Order Date">                    
                </div>
            </div>
            <div class="col-sm-12 m-t-20 wrap">
                <button class="btn btn-info btn-sm addAnotherService">Add Another Service</button>
            </div>';
        }   

        echo $html;  
    }




	public function status(){
		$id = $this->input->post('id');
		$data['status'] = $this->input->post('status');

		$this->Admin_m->update('services', $data, array('id' => $id));
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Status update successfull', 'detailMessage' => '');

		echo json_encode($returnData);

	}

	public function delete()
	{
		$id = $this->input->post('id');

		if(!empty($id)) {
			$this->Admin_m->destroy('services', array('id' => $id));
		}
		
		$returnData = array('hasError' => 0, 'class' => 'success', 'message' => 'Item delete successfull', 'detailMessage' => '');
		echo json_encode($returnData);
	}

	public function getListData(){

        $where = ['deleted_at'=> NULL, 'tbl_name' => 'services'];

        $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'filter', // Query type
                $where // coditions
            );
        
        $data = array();

        $no = $_POST['start'];

        foreach ($lists as $key => $list) {

            $button = '';
                      
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm" data-toggle="modal" data-target="#exampleModal" data-title="Edit Bill Type" data-href="'.site_url('setup/services/edit/'.$list->id).'" data-id="'.$list->id.'" data-html="form" data-selector="add">
                <i class="material-icons icons-padding">create</i>
            </a> ';
         
            $button .= '<a class="btn btn-default btn-icon btn-icon-mini btn-simple btn-sm delete-confirm" data-toggle="tooltip" data-placement="top" title="Delete" data-href="'.site_url('setup/services/delete/').'" data-id="'.$list->id.'">
                <i class="material-icons icons-padding">delete_forever</i>
            </a> ';
            $no++;
            $row = array();
            $row[] = $list->name;
            $row[] = listdata('services', false, ['id' => $list->parent_id], true);
            $row[] = $list->description;
            $row[] = $list->min_range;
            $row[] = $list->max_range;
            $row[] = '<div class="flipswitch" data-toggle="tooltip" data-placement="top" title="Status Change">
                    <input type="checkbox" name="status" class="status flipswitch-cb" data-admin="'.getUserData('is_admin').'" data-href="'.site_url('setup/services/status').'" data-usertype = "'.getUserData('user_type').'" data-id="'.$list->id.'" id="status'.$list->id.'" value="'.$list->status.'" '.($list->status == 1 ? 'checked' : '').' '.(getUserData('is_admin') == 0 ? 'disabled': '').' onclick="return false" onkeydown="return false">
                    <label class="flipswitch-label" for="status'.$list->id.'">
                        <div class="flipswitch-inner"></div>
                        <div class="flipswitch-switch"></div>
                    </label>
                </div>';
            $row[] = $button;
            $data[] = $row;
        }

        $output = array(
            "draw"              => $_POST['draw'],
            "recordsTotal"      => $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                '', // Query type
                $where // coditions
            ),
            "recordsFiltered"   => $lists = $lists = $this->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_setup_query', // Function Name
                'count', // Query type
                $where // coditions
            ),
            "data"              => $data,
        );

        //output to json format
        echo json_encode($output);
    }

}