<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of MY_Model
 *
 * @author Hasib
 */
class MY_Model extends CI_Model{
    
    function __construct() {
        parent::__construct();
    }
    
    public function save($table, $data, $batch = false)
    {
        if($batch == true)
        {
            $this->db->insert_batch($table, $data);
            return true;
        }
        else
        {
            $this->db->insert($table, $data);      
            return $this->db->insert_id(); 
        } 
    }       
    
    public function find($table, $where = array(), $order = '')
    {
        $this->db->select('*');
        $this->db->from($table);
        $this->db->where($where);
        if(!empty($order)) $this->db->order_by($order);
        $query = $this->db->get();
        return $query->row();
    }

    public function findSelect($select, $table, $where = array(), $group = array(), $order = array())
    {
        $this->db->select($select);
        $this->db->from($table);
        $this->db->where($where);
        if(!empty($group)) $this->db->group_by($group);
        if(!empty($order)) $this->db->order_by($order);
        $query = $this->db->get();
        return $query->row();
    }

    public function countAll($table, $where = array(), $filterKey = '', $filterValue = '')
    {
        $this->db->select('*');
        $this->db->from($table);
        $this->db->where($where);
        if(!empty($filterValue)) { $this->db->like($filterKey, $filterValue); }
        $query = $this->db->count_all_results();
        return $query;
    }   

    public function findAll($table, $where = array(), $method = 'result')
    {
        $this->db->select('*');
        $this->db->from($table);
        $this->db->where($where);
        $query = $this->db->get();
        return $query->$method();
    }  
    
    public function update($table, $data, $where)
    {           
        $this->db->update($table, $data, $where);
        return true;
    }
    
    public function destroy($table, $where)
    {
        $this->db->set(['deleted_at' => date('Y-m-d H:i:s')])
            ->where($where)
            ->update($table);
    }
    
    public function delete($table, $where = []){
        $this->db->delete($table, $where);
    }


    /* ======================

    $model = give model name
    $function = give model function name 
    $type = filter or count of null

    ====================== */

    public function findall_datatable($model, $function, $type = null, $where = []){
        if($type == 'filter'){
            $term = $_REQUEST['search']['value'];
            $this->$model->$function($term, $where);
            if($_REQUEST['length'] != -1)
                $this->db->limit($_REQUEST['length'], $_REQUEST['start']);
            $query = $this->db->get();
            return $query->result();
        }else if($type == 'count'){
            $term = $_REQUEST['search']['value'];
            $this->$model->$function($term, $where);
            $query = $this->db->get();
            return $query->num_rows();
        }else{
            $this->$model->$function('', $where);
            $query = $this->db->get();
            return $query->result();
        }
    }
}
