<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');


/**
 * Die and dump an array or object
 *
 * @param  string  $data
 * @return string
 */
//start dd is die and dump
function dd($data = array() , $clean = false){
	if ($clean) {
		echo "<pre style='background-color:#ffffff; border:3px solid #ecf0f1; color:#df5000;'>";
		die(var_dump($data));
		echo "</pre>";
		die();
	}else{
		echo "<pre style='background-color:#ffffff; border:3px solid #ecf0f1; color:#df5000;'>";
		print_r($data);
		echo "</pre>";			
		die();
	}
}

function datetimepickerAssets(){
    $path = site_url('assets/');
    
    $assets = '<link rel="stylesheet" href="'.$path.'plugins/bootstrap-material-datetimepicker/css/bootstrap-material-datetimepicker.css">';
    $assets .= '<script src="'.$path.'plugins/momentjs/moment.js"></script>';
    $assets .= '<script src="'.$path.'plugins/bootstrap-material-datetimepicker/js/bootstrap-material-datetimepicker.js"></script>';

    return $assets;
}

function createBreadCrumb()
{
    $url = $_SERVER['REQUEST_URI']; 
    $url = explode('/', $url);
    $url = array_filter($url);
    $url = array_merge($url, array());
    
    // $html = '<div class="row">
    //     <div class="col-lg-7 col-md-6 col-sm-12">
    //         <h2> '.ucfirst((!empty($url[4]) && !is_numeric($url[4]) ? str_replace("_","",$url[4]) : (!empty($url[3]) && !is_numeric($url[3]) ? str_replace("_","",$url[3]) : (!empty($url[2]) && !is_numeric($url[2]) ? str_replace("_","",$url[2]) : str_replace("_","",$url[1]))))).'
    //         <small class="text-muted">Welcome to Safara OMS</small>
    //         </h2>
    //     </div>
    //     <div class="col-lg-5 col-md-6 col-sm-12">
            
    //     </div>
    // </div>';

    $html = '<div class="row">
        <div class="col-lg-7 col-md-6 col-sm-12">
            <h2> '.ucfirst(!empty($url[2]) ? $url[2] : $url[1]).'
            <small class="text-muted"></small>
            </h2>
        </div>
        <div class="col-lg-5 col-md-6 col-sm-12">
            
        </div>
    </div>';

    return $html;
}

/* get user agent */
function userAgent(){

    CI()->load->library('user_agent');
	if (CI()->agent->is_browser()) {
	    return CI()->agent->browser().' '.CI()->agent->version().' '.CI()->agent->platform();
	} elseif (CI()->agent->is_robot()) {
	    return CI()->agent->robot().' '.CI()->agent->platform();
	} elseif (CI()->agent->is_mobile()) {
	    return CI()->agent->mobile().' '.CI()->agent->platform();
	} else {
	    return 'Unidentified User Agent';
	}
}

/**
 * Collect the IP address
 * @return string IP address
 */
// getIP function
if ( ! function_exists('getIP'))
{
    function getIP() {
        $ip = $_SERVER['REMOTE_ADDR'];

        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {

            $ip = $_SERVER['HTTP_CLIENT_IP'];

        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {

            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];

        }

        return $ip;
    }
}


// end getIP function


// Get List Data
function listdata($table, $multiple = false, $condition = [], $row = false){

    if($condition){
        $where = $condition;
    } else {
        $where = ['status' => 1, 'deleted_at'=>NULL];    
    }

    if($row == true){
        $method = 'row_array';
    } else {
        $method = 'result_array';
    }

    $results = CI()->db->select('id, name')->where($where)->get($table)->$method();

    if($row == true){
        return $results['name'];
    } else {
        if($multiple === 'data'){
            return $results;
        } elseif ($multiple == true) {
           $type = [];
        }
        else {
            $type = ['' => 'SELECT '.strtoupper(str_replace('_',' ', $table))];
        }
        foreach ($results as $key => $row) {
            $type[$row['id']] = $row['name'];
        }
        return $type;   
    }   

}
// End list Data

// Get user list
function userList($where = [], $multiple = false, $row = false, $realData = false){

    if($row == true){
        $method = 'row_array';
    } else {
        $method = 'result_array';
    }

    CI()->db->select('CONCAT(employees.first_name," ",employees.last_name) fullname, users.id, department.name department_name')
        ->join('employees', 'employees.user_id = users.id')
        ->join('department', 'department.id = employees.department_id');
    $where_in = (isset($where['where_in']) ? $where['where_in'] : []);
    unset($where['where_in']);
    CI()->db->where('users.deleted_at', NULL);  
    CI()->db->where('users.status', 1);
    CI()->db->where($where);   
    foreach ($where_in as $key => $value) {
        CI()->db->where_in($key, $value);      
    }  

    $results = CI()->db->get('users')->$method();

    if($realData == true):
        return $results;
    else:
        if($row == true){
            return $results['fullname'];
        } else {
            if ($multiple == true) {
               $type = [];
            }
            else {
                $type = ['' => 'SELECT USER'];
            }
            foreach ($results as $key => $row) {
                $type[$row['id']] = $row['fullname'].' ('.$row['department_name'].')';
            }
            return $type;
        }
    endif;

}
// End user list

// Get last table id
function tblMaxId($table){
    $result = CI()->db->select('MAX(id) id')->get($table)->row_array();

    return $result['id'] + 1;
}
// Get last table id

// array and string  convertion
function array_to_string($data){

    if(is_array($data)){
        $keys = array_keys($data);
        $result = '';
        foreach ($data as $key => $value) {
            $result .= ($key == end($keys) ? $value : $value.',');
        }
        return $result;
    } else {
        $result = explode(',',$data);
        return $result;
    }

}
// array and string  convertion

function dateConvertFormtoDB($date){
    if(!empty($date)){
        $date = strtotime($date);
        return date('Y-m-d', $date);
    }
}

function dateConvertDBtoForm($date){
    if(!empty($date)){
        $date = strtotime($date);
        return date('d/m/Y', $date);
    }
}

function timeConvertFormtoDB($time){
    if(!empty($time)){
        return date("G:i", strtotime($time));
    }
}

function timeConvertDBtoForm($time){
    if(!empty($time)){
       return date('g:i A', strtotime($time));
    }
}
// Get Country Data
function countrydata($table){

    $results = CI()->db->select('id, name, country_code')->get($table)->result_array();

        $type = ['' => 'SELECT '.strtoupper(str_replace('_',' ', $table))];
 
    foreach ($results as $key => $row) {
        $type[$row['id']] = $row['name'].' ('.$row['country_code'].')';
    }

    return $type;

}
// End Country Data


/**/
function getLead($where = [], $result = false, $rawdata = false){

    if($result == true){
        $method = 'result_array';
    } else {
        $method = 'row_array';
    }

    CI()->db->select('leads.id, leads.name')->where('leads.status', 0);

    $where['leads.deleted_at ='] = NULL;

    if(array_key_exists('where_in', $where)){
        $where_in=$where['where_in'];
        unset($where['where_in']);
        CI()->db->where($where);
        CI()->db->where_in(key($where_in), $where_in[key($where_in)]);     
    } else {
        CI()->db->where($where);   
    } 

    $data = CI()->db->get('leads')->$method();

    if($result == false){
        return $data['name'];
    } else {
        if ($rawdata == true) {
            return $data;
        }
        else{
            $lead = ['' => 'SELECT LEAD'];
            foreach ($data as $key => $row) {
                $lead[$row['id']] = $row['name'];
            }
            return $lead;
        }
    }       
}

/**/
function getClient($where = [], $result = false, $rawdata = false) {
    if($result == true){
        $method = 'result_array';
    } else {
        $method = 'row_array';
    }

    CI()->db->select('clients.lead_id id, leads.name')
        ->join('leads', 'leads.id = clients.lead_id');
    if(array_key_exists('where_in', $where)){
        CI()->db->where_in(key($where['where_in']), $where['where_in'][key($where['where_in'])]);  
    } else {
        CI()->db->where($where);   
    } 
    $data = CI()->db->get('clients')->$method();

    if($result == false){
        return $data['name'];
    } else {
        if ($rawdata == true) {
            return $data;
        }
        else{
            $lead = ['' => 'SELECT CLIENT'];
            foreach ($data as $key => $row) {
                $lead[$row['id']] = $row['name'];
            }
            return $lead;
        }
    }
}

function getWorkspace($where = [], $result = false, $rawdata = false) {
    if($result == true){
        $method = 'result_array';
    } else {
        $method = 'row_array';
    }

    CI()->db->select('workspaces.id, workspaces.name, workspaces.workorder_no')
        ->join('leads', 'workspaces.lead_id = leads.id')
        ->order_by('workspaces.id', 'DESC');
    if(array_key_exists('where_in', $where)){
        $where_in=$where['where_in'];
        unset($where['where_in']);
        CI()->db->where($where);
        if(getUserData('is_admin') == 0){
            CI()->db->where_in(key($where_in), $where_in[key($where_in)]);         
        }        
    } else {
        CI()->db->where($where);   
    } 
    $data = CI()->db->get('workspaces')->$method();

    if($result == false){
        return $data['name'];
    } else {
        if ($rawdata == true) {
            return $data;
        }
        else{
            $lead = ['' => 'SELECT Workorder'];
            foreach ($data as $key => $row) {
                $lead[$row['id']] = $row['name'].($row['workorder_no'] ? ' ('.$row['workorder_no'].')' : '');
            }
            return $lead;
        }
    }
}

function workspaceClient($id){

    $client_id = CI()->db->select('lead_id')->where('id', $id)->get('workspaces')->row();
    return getClient(['clients.lead_id' => $client_id->lead_id], false);

}

function imagePath($table, $id){

    $where = ($table === 'empdocuments' ? ['user_id' => $id] : ['id' => $id]);

    $result = CI()->db->where($where)->get($table)->row();

    $path = site_url('uploads/thumb/');   

    if($result){
        if($result->doc_link){
            $url = $path.$result->doc_link;
        } 
         else {
            $url = 'https://via.placeholder.com/150x150';
        }
    } else {
        $url = 'https://via.placeholder.com/150x150';
    } 
// dd($url);
    return $url; 

}

function findAssistants($id){
    return CI()->db->select('user_id')
        ->where(['supervisor_id' => $id, 'id !=' => $id])
        ->get('employees')
        ->result_array();
}

function randString($digits = 4){
  $temp = "";

  for ($i = 0; $i < $digits; $i++) {
    $temp .= rand(0, 9);
  }

  return (int)$temp;
}

function workspaceList($where = [], $row = false){

    if($row == true){
        $method = 'row_array';
    } else {
        $method = 'result_array';
    }

    CI()->db->select('workspaces.id, workspaces.name')
        ->join('leads', 'leads.id = workspaces.lead_id')
        ->join('lead_manager', 'lead_manager.lead_id = leads.id');
    if($where): 
        $where_in = (isset($where['where_in']) ? $where['where_in'] : []);
        $or_where = (isset($where['or_where']) ? $where['or_where'] : []);
        unset($where['where_in']);
        unset($where['or_where']);
        CI()->db->where($where);
        foreach ($or_where as $k => $ow) {
            CI()->db->or_where($k, $ow);
        }   
        foreach ($where_in as $key => $value) {
            CI()->db->where_in($key, $value);      
        }
    else:
        CI()->db->where('workspaces.deleted_at =', NULL)
            ->where_in('leads.km', getUserData('supervisor_of'));
    endif;    

    $results = CI()->db->order_by('leads.id', 'DESC')
        ->get('workspaces')
        ->$method();

    if($row == true){
        return $results['name'];
    } else {
        $type = ['' => 'SELECT WORKSPACES'];

        foreach ($results as $key => $row) {
            $type[$row['id']] = $row['name'];
        }
        return $type;       
    }
    
}

function projectList($where = [], $row = false){
    if($row == true){
        $method = 'row_array';
    } else {
        $method = 'result_array';
    }
    CI()->db->select('projects.id, projects.name, leads.name lead_name')
        ->join('projects', 'projects.id = project_user.project_id')
        ->join('workspaces', 'workspaces.id = projects.workspaces_id')
        ->join('leads', 'leads.id = workspaces.lead_id');
    CI()->db->where('projects.status', 1);    
    if(array_key_exists('where_in', $where)){
        CI()->db->where_in(key($where['where_in']), $where['where_in'][key($where['where_in'])]);  
    } else {
        CI()->db->where($where);   
    } 
    $data = CI()->db->get('project_user')->$method();

    if($row == true){
        return $data['name'];
    } else {

        $project = ['' => 'Select Project'];
        foreach ($data as $key => $row) {
            $project[$row['id']] = ($row['name'] ? $row['name'] : $row['first_name'].' '.$row['last_name']).' ('.$row['lead_name'].')';
        }
        return $project;
    }
}

function projectUserList($where = []){
    CI()->db->select('employees.user_id id, concat(employees.first_name," ", employees.last_name) name')
        ->join('employees', 'employees.user_id = project_user.user_id');
    if(array_key_exists('where_in', $where)){
        CI()->db->where_in(key($where['where_in']), $where['where_in'][key($where['where_in'])]);  
    } else {
        CI()->db->where($where);   
    } 
    $data = CI()->db->get('project_user')->result_array();

    $project = [];
    foreach ($data as $key => $row) {
        $project[$row['id']] = ($row['name'] ? $row['name'] : $row['first_name'].' '.$row['last_name']);
    }
    return $project;   
}

function taskUserList($where = []){
    CI()->db->select('employees.user_id id, concat(employees.first_name," ", employees.last_name) name')
        ->join('employees', 'employees.user_id = task_user.user_id');
    if(array_key_exists('where_in', $where)){
        CI()->db->where_in(key($where['where_in']), $where['where_in'][key($where['where_in'])]);  
    } else {
        CI()->db->where($where);   
    } 
    $data = CI()->db->get('task_user')->result_array();

    $project = [];
    foreach ($data as $key => $row) {
        $project[$row['id']] = ($row['name'] ? $row['name'] : $row['first_name'].' '.$row['last_name']);
    }
    return $project;   
}

function pageNotFound(){
    CI()->load->view('404');
}

function calculate_time_span($date){
    $seconds  = strtotime(date('Y-m-d H:i:s')) - strtotime($date);

    $years = floor(($seconds / (60*60*24*30))/12);
    $months = floor($seconds / (60*60*24*30));
    $day    = floor($seconds / (60*60*24));
    $hours  = floor($seconds / (60*60));
    $mins   = floor(($seconds - ($hours*60*60)) / 60);
    $secs   = floor($seconds % 60);

    if($seconds < 60)
        $time = "Just now";
    else if($seconds < 60*60 )
        $time = $mins." minute(s) ago";
    else if($seconds < 24*60*60)
        $time = $hours." hour(s) ago";
    else if($seconds < 30*24*60*60)
        $time = $day." day(s) ago";
    else if($seconds < 12*30*24*60*60)
        $time = $months." month(s) ago";
    else
        $time = $years." year(s) ago";
    return $time;
}


function getNotification()
{
    //saveNotificationData();

    $last_viewed = CI()->db->select('id, last_checked')
        ->where('user_id', getUserData('user_id'))
        ->order_by('id', 'DESC')
        ->limit(1)
        ->get('notification_viewed')
        ->row();

    if($last_viewed):
        CI()->Admin_m->update('notification_viewed', ['last_checked' => date('Y-m-d H:m:i')], ['id' => $last_viewed->id]);
    else:    
        CI()->Admin_m->save('notification_viewed', ['user_id' => getUserData('user_id'), 'last_checked' => date('Y-m-d H:m:i')]);
    endif;    

    if(getUserData('user_type') == 3):
        $where = ['usertype_id' => 3];
        $count_where = ['created_date >=' => ($last_viewed ? $last_viewed->last_checked : date('Y-m-d 00:00:00')), 'usertype_id' => 3];
    else:
        $where = ['where_in' => ['user_id' => getUserData('supervisor_of')]];
        $count_where = ['created_date >=' => ($last_viewed ? $last_viewed->last_checked : date('Y-m-d 00:00:00')), 'where_in' => ['user_id' => getUserData('supervisor_of')]];
    endif;

    $_REQUEST['length'] = 5;
    $_REQUEST['start'] = 0;
    $_REQUEST['search']['value'] = [];
    $data = CI()->Admin_m->findall_datatable(
            'Admin_m', // Model name
            '_get_notification_query', // Function Name
            'filter',// Query type
            $where
        );
    return $result = [
        'total' => CI()->Admin_m->findall_datatable(
                'Admin_m', // Model name
                '_get_notification_query', // Function Name
                'count',// Query type
                $count_where
            ),
        'data' => $data,
    ];
}

function getProjectToLeadID($id){
    
    $data = CI()->db->select('workspaces.lead_id')
        ->join('workspaces', 'workspaces.id = projects.workspaces_id')
        ->where('projects.id', $id)
        ->get('projects')
        ->row();

    return $data->lead_id;    
}

function plainText($data){
    return strip_tags(preg_replace('/<[^>]*>/','',str_replace(array("&nbsp;","\n","\r"),"",html_entity_decode($data,ENT_QUOTES,'UTF-8'))));
}

function getUserType($id){
    $data = CI()->db->select('usertype_id')->where('id', $id)->get('users')->row();
    return $data->usertype_id;
}

function isJson($string) {
    json_decode($string);
    return (json_last_error() == JSON_ERROR_NONE);
}

function saveNotificationData()
{
    $data['date'] = [date('Y-m-d'), date('Y-m-d', strtotime(' +1 day')), date('Y-m-d', strtotime(' +2 day'))];
    $notification = [];

    $leadTask = CI()->Admin_m->taskExpData($data);
    if($leadTask):
        foreach ($leadTask as $key => $value):
            
            $value = [
                'tbl_name'      => 'tasks',
                'tbl_pk'        => $value['id'],
                'user_id'       => $value['user_id'], 
                'usertype_id'   => $value['usertype_id'], 
                'title'         => '<strong>Task</strong> '.word_limiter(plainText($value['name']), 10).' <strong>expire soon</strong>',
                'source_url'    => site_url('app#'.($value['status'] == 1 ? 'lead/tasks' : 'workspace/tasks').'/preview/'.$value['id']),
                'deadline'      => $value['deadline'], 
                'list_class'    => ($value['deadline'] == date('Y-m-d') ? 'danger' : 'warning'),
                'created_date'  => date('Y-m-d H:m:i'),
            ];
            array_push($notification, $value);
        endforeach;
    endif;

    $projects = CI()->Admin_m->projectExpData($data);
    if($projects):
        foreach ($projects as $key => $value):            
            $value = [
                'tbl_name'      => 'projects',
                'tbl_pk'        => $value['id'],
                'user_id'       => $value['user_id'], 
                'usertype_id'   => $value['usertype_id'], 
                'title'         => '<strong>Project</strong> '.word_limiter(plainText($value['name']), 10).' <strong>expire soon</strong>',
                'source_url'    => site_url('app#workspace/projects/view/'.$value['id']),
                'deadline'      => $value['deadline'], 
                'list_class'    => ($value['deadline'] == date('Y-m-d') ? 'danger' : 'warning'),
                'created_date'  => date('Y-m-d H:m:i'),
            ];
            array_push($notification, $value);
        endforeach;
    endif;
    
    if($notification):
        $result = CI()->Admin_m->save('notifications', $notification, true);
        if($result):
            $file = 'notification_log.txt';
            $person = date('Y-m-d H:m:i')." ".count($notification)." row insert\n";
            file_put_contents($file, $person, FILE_APPEND | LOCK_EX);
        endif; 
    endif;

    return true;
}

function convert_number_to_word($parm){
    
    $CI = &get_instance();
    $CI->load->library('Numbertowords');
    
    $Numbertotext = new Numbertowords();
    return $Numbertotext->convert_number($parm);
    
}


function getInventoryList($where = [], $multiple = false, $row = false, $rawdata = false)
{
    $results = CI()->db->select('inventory.id, product_brand.name brand_name, inventory.model_no')
        ->join('product_brand', 'product_brand.id = inventory.product_brand')
        ->where($where)
        ->get('inventory')
        ->result_array();

    if($rawdata == true){
        return ($results ? $results : []);
    } else {
        if($row == true){
            return $results['brand_name'] .' - '.$results['model_no'];
        } else {
            if ($multiple == true) {
               $type = [];
            }
            else {
                $type = ['' => 'SELECT INVENTORY'];
            }
            foreach ($results as $key => $row) {
                $type[$row['id']] = $row['brand_name'].' ('.$row['model_no'].')';
            }
            return $type;
        }
    }
}


if ( ! function_exists('getData'))
{
    function getData($table = null, $type = null, $columns = '*', $array = [], $wild = null, $or_array = [], $where = true, $order_by = null ) {
        
        if(!empty($table) || $table != null){
            $table = strtolower(trim($table));
        }else{
            echo "Table is not set! Please use a table name as first argument.";
            return false;
        }
        if (!is_array($array)) {
            echo "An associative array required!";
            return false;
        }
        if(!empty($type) || $type != null){
            $type = strtolower(trim($type));
        }else{
            $type = 'object';
        }
        if($columns === '*'){
            CI()->db->select('*');
        }else{
            CI()->db->select($columns);
        }
        CI()->db->from($table);
        if ($where) {
            CI()->db->where($array);
            if(is_array($or_array) && !empty($or_array)){
                CI()->db->or_where($or_array);
            }
        }else{
            CI()->db->like($array);
            if(is_array($or_array) && !empty($or_array)){
                CI()->db->or_like($or_array);
            }
        }
        if (!empty($order_by) && $order_by != null) {
            CI()->db->order_by($order_by);
        }
        if ($wild == null) {
            CI()->db->limit(1);
        }
        if (is_int($wild) && $wild != null){
            CI()->db->limit($wild);
        }
        $query = CI()->db->get();
        if($wild != '*' && !is_int($wild)){
            if($type == 'object'){
                return $query->row();
            }
            if($type == 'array'){
                return $query->row_array();
            }
        }else{
            if($type == 'object'){
                return $query->result();
            }
            if($type == 'array'){
                return $query->result_array();
            }
        }
    }
}

function siteStatus(){
    if(getUserData('loggedin') == true && getUserData('company') == base_url()):
        $settings = CI()->Admin_m->find('system_settings', array());
        if($settings->site_offline == 0 && getUserData('is_admin') == 0){
            redirect("offline");
        } else {
            return false;
        }
    else:
        redirect("login");
    endif;
}

function getSettings(){
   return $settings = CI()->Admin_m->find('system_settings', array());
    
}

function getServiceDataByLead($id) {
    return CI()->Report_m->servicedetail($id);
}

function generate_token($len = 32)
{
    // Array of potential characters, shuffled.
    $chars = array(
        'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 
        'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 
        'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'
    );
    shuffle($chars);
    $num_chars = count($chars) - 1;
    $token = '';
    // Create random token at the specified length.
    for ($i = 0; $i < $len; $i++)
    {
        $token .= $chars[mt_rand(0, $num_chars)];
    }
    return $token;
}

function leadStatistic($data){
    if(number_format($data->total_order_val) != 0 && $data->exp_order_date != '0000-00-00' && $data->exp_order_date != NULL && $data->query_date != '0000-00-00' && $data->used_services != '' && $data->require_competition != '' && $data->price_sensitivity != '' && $data->client_budget != '' && $data->client_segment && $data->probability != '' && $data->purchasing_power != ''):

        $status = 0;
        $status = 0;
        $status = 0;

        $date1 = date_create($data->query_date);
        $date2 = date_create($data->created_at);
        $date3 = date_create($data->query_date);
        
        /*  */
        $parm1 = date_diff(date_create($data->query_date),date_create($data->created_at))->format("%R%a");

        if($parm1 <= 45):
            $status += 3;
        elseif($parm1 >= 45 &&  $parm1 <= 60):
            $status += 2;        
        elseif($parm1 >= 60 &&  $parm1 <= 90):
            $status += 1;        
        else:
            $status += 0;        
        endif;

        /*  */
        $parm2 = date_diff(date_create($data->created_at),date_create($data->exp_order_date))->format("%R%a");

        if($parm2 <= 45):
            $status += 3;
        elseif($parm2 >= 45 &&  $parm2 <= 60):
            $status += 2;        
        elseif($parm2 >= 60 &&  $parm2 <= 90):
            $status += 1;        
        else:
            $status += 0;        
        endif;

        /*  */
        if($data->used_services == 1):
            $status += 2;        
        else:
            $status += 3;        
        endif;

        /*  */
        if($data->require_competition == 1):
            $status += 2;        
        else:
            $status += 3;        
        endif;

        /*  */
        if($data->price_sensitivity == 1):
            $status += 2;        
        else:
            $status += 3;        
        endif;

        /*  */
        if($data->client_budget == 1):
            $status += 2;        
        else:
            $status += 1;        
        endif;

        /*  */
        if($data->client_segment === 'C1' || $data->client_segment === 'C2'):
            $status += 1;        
        elseif($data->client_segment === 'B2'):
            $status += 2;     
        else:
            $status += 3;        
        endif;

        /*  */
        if($data->probability <= 2):
            $status += 1;        
        elseif($data->probability == 3):
            $status += 2;     
        else:
            $status += 3;        
        endif;

        /*  */
        if($data->purchasing_power == 2):
            $status += 3; 
        elseif($data->purchasing_power == 1):
             $status += 2; 
        else:
             $status += 1;
        endif;

        /*  */
        $services = CI()->Admin_m->findAll('lead_services', ['lead_id' => $data->id]);

        $modulePrice = 0;
        $orderPrice = 0;
        if($services):
            foreach ($services as $key => $service):
                if($service->sub_service != NULL):
                    $details = CI()->Admin_m->findAll('lead_services_detail', ['lead_id' => $data->id]);
                    foreach ($details as $detail):
                        $info = CI()->Admin_m->find('service_modules', ['id' => $detail->module_id]);
                        $modulePrice += $info->max_range;
                    endforeach;                    
                else:
                    $info = CI()->Admin_m->find('services', ['id' => $service->services_id]);
                    $modulePrice += $info->max_range;
                endif;
                $orderPrice += $service->exp_total_order_val;
            endforeach;

            $percentChange = percentChange($modulePrice, $orderPrice);

            if($percentChange >= -20 && $percentChange < 11):
                $status += 3;
            elseif($percentChange < 21 && $percentChange > 10):
                $status += 2;    
            elseif ($percentChange < 25 && $percentChange > 20):
                $status += 1; 
            else:
                $status += 0;   
            endif;
        endif;
        //return $status;
        return (($status / 100) * 30) / 10;
    else: 
        return 0;    
    endif;
}

function percentChange($val1, $val2)
{
    $val = (1 - $val1 / $val2) * 100;
    return number_format($val, 2);
}

/**
* Author: CodexWorld
* Author URI: http://www.codexworld.com
* Function Name: getAddress()
* $latitude => Latitude.
* $longitude => Longitude.
* Return =>  Address of the given Latitude and longitude.
**/
function getAddress($latitude,$longitude){
    if(!empty($latitude) && !empty($longitude)){
        //Send request and receive json data by address
        $geocodeFromLatLong = file_get_contents('https://maps.googleapis.com/maps/api/geocode/json?latlng='.trim($latitude).','.trim($longitude).'&key=AIzaSyAcvTpcnXDpTiFZd72E6Xsb7wtt8R6OSr0'); 

        $output = json_decode($geocodeFromLatLong);
        $status = $output->status;
        //Get address from json data
        $address = ($status=="OK")?$output->results[0]->formatted_address:'';


        //Return address of the given latitude and longitude
        if(!empty($address)){
            return $address;
        }else{
            return false;
        }
    }else{
        return false;   
    }
}

// ------------------------------------------------------------------------
/* End of file authentication_helper.php */
/* Location: ./application/helpers/authentication_helper.php */