<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Numbertowords {
	
	function convert_number($number) {
		if (($number < 0) || ($number > 999999999)) {
			throw new Exception("Number is out of range");
		}
		
		$Cr = floor($number / 10000000);
		/* crore (tera) */
		$number -= $Cr * 10000000;		
		$Gn = floor($number / 100000);
		/* Lakh (giga) */
		$number -= $Gn * 100000;
		$kn = floor($number / 1000);
		/* Thousands (kilo) */
		$number -= $kn * 1000;
		$Hn = floor($number / 100);
		/* Hundreds (hecto) */
		$number -= $Hn * 100;
		$Dn = floor($number / 10);
		/* Tens (deca) */
		$n = $number % 10;
		/* Ones */
		$res = "";
		
		if ($Cr) {
			$res .= $this->convert_number($Cr) .  " Crore";
		}
		if ($Gn) {
			$res .= $this->convert_number($Gn) .  " Lakh";
		}
		if ($kn) {
			$res .= (empty($res) ? "" : " ") .$this->convert_number($kn) . " Thousand";
		}
		if ($Hn) {
			$res .= (empty($res) ? "" : " ") .$this->convert_number($Hn) . " Hundred";
		}
		$ones = array("", "One", "Two", "Three", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten", "Eleven", "Twelve", "Thirteen", "Fourteen", "Fifteen", "Sixteen", "Seventeen", "Eightteen", "Nineteen");
		$tens = array("", "", "Twenty", "Thirty", "Fourty", "Fifty", "Sixty", "Seventy", "Eigthy", "Ninety");
		if ($Dn || $n) {
			if (!empty($res)) {
				$res .= " and ";
			}
			if ($Dn < 2) {
				$res .= $ones[$Dn * 10 + $n];				
			} else {
				$res .= $tens[$Dn];
				if ($n) {
					$res .= "-" . $ones[$n];
				}
			}
		}
		if (empty($res)) {
			$res = "zero";
		}		
		return $res;
	}
	
	//Convert Word
	function convertEnWordToBnWord($inputWord){
		$engWord = array("Zero", "One", "Two", "Three", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten", "Eleven", "Twelve", "Thirteen", "Fourteen", "Fifteen", "Sixteen", "Seventeen", "Eightteen", "Nineteen", "Twenty", "Twenty One", "Twenty Two", "Twenty Three", "Twenty Four", "Twenty Five", "Twenty Six", "Twenty Seven", "Twenty Eight", "Twenty Nine", "Thirty", "Thirty One", "Thirty Two","Thirty Three","Thirty Four","Thirty Five","Thirty Six", "Thirty Seven","Thirty Eight","Thirty Nine","Forty","Forty-one","forty-two","forty-three","forty-four","forty-five","forty-six","forty-seven","forty-eight","forty-nine","Fifty","Hundred","Thousand","Lakh","Crore");
		$bnWord = array("শূন্য", "এক","দুই","তিন","চার","পাঁচ","ছয়","সাত","আট","নয়","দশ","এগার","বার","তের","চৌদ্দ","পনের","ষোল","সতের","আঠার","ঊনিশ","বিশ","একুশ","বাইশ","তেইশ","চব্বিশ","পঁচিশ","ছাব্বিশ","সাতাশ","আঠাশ","ঊনত্রিশ","ত্রিশ","একত্রিশ","বত্রিশ","তেত্রিশ","চৌত্রিশ","পঁয়ত্রিশ","ছত্রিশ","সাঁইত্রিশ","আটত্রিশ","ঊনচল্লিশ","চল্লিশ","একচল্লিশ","বিয়াল্লিশ","তেতাল্লিশ","চুয়াল্লিশ"."পঁয়তাল্লিশ","ছেচল্লিশ","সাতচল্লিশ","আটচল্লিশ","ঊনপঞ্চাশ","পঞ্চাশ","শত","হাজার","লক্ষ","কোটি");
		$convertedWord = str_replace($engWord, $bnWord, $inputWord);
		return $convertedWord;
		
		// শূন্য zero 	১ এক one 	২ দুই two 	৩ তিন three 	৪ চার four 	৫ পাঁচ five 	৬ ছয় six 	৭ সাত seven 	৮ আট eight 	৯ নয় nine
		// ১০ দশ ten 	১১ এগার eleven 	১২ বার twelve 	১৩ তের thirteen 	১৪ চৌদ্দ fourteen 	১৫ পনের fifteen 	১৬ ষোল sixteen 	১৭ সতের seventeen 	১৮ আঠার eighteen 	১৯ ঊনিশ nineteen
		// ২০ বিশ twenty 	২১ একুশ twenty-one 	২২ বাইশ twenty-two 	২৩ তেইশ twenty-three 	২৪ চব্বিশ twenty-four 	২৫ পঁচিশ twenty-five 	২৬ ছাব্বিশ twenty-six 	২৭ সাতাশ twenty-seven 	২৮ আঠাশ twenty-eight 	২৯ ঊনত্রিশ twenty-nine
		// ৩০ ত্রিশ thirty 	৩১ একত্রিশ thirty-one  ৩২ বত্রিশ thirty-two 	৩৩ তেত্রিশ thirty-three 	৩৪ চৌত্রিশ thirty-four 	৩৫ পঁয়ত্রিশ thirty-five 	৩৬ ছত্রিশ thirty-six 	৩৭ সাঁইত্রিশ thirty-seven 	৩৮ আটত্রিশ thirty-eight 	৩৯ ঊনচল্লিশ thirty-nine
																																									// ৪০ চল্লিশ forty 	৪১ একচল্লিশ forty-one 	৪২ বিয়াল্লিশ forty-two 	৪৩ তেতাল্লিশ forty-three 	৪৪ চুয়াল্লিশ forty-four 	৪৫ পঁয়তাল্লিশ forty-five 	৪৬ ছেচল্লিশ forty-six 	৪৭ সাতচল্লিশ forty-seven 	৪৮ আটচল্লিশ forty-eight 	৪৯ ঊনপঞ্চাশ forty-nine
		// ৫০ পঞ্চাশ fifty 	৫১ একান্ন fifty-one 	৫২ বায়ান্ন fifty-two 	৫৩ তিপ্পান্ন fifty-three 	৫৪ চুয়ান্ন fifty-four 	৫৫ পঞ্চান্ন fifty-five 	৫৬ ছাপ্পান্ন fifty-six 	৫৭ সাতান্ন fifty-seven 	৫৮ আটান্ন fifty-eight 	৫৯ ঊনষাট fifty-nine
		// ৬০ ষাট sixty 	৬১ একষট্টি sixty-one 	৬২ বাষট্টি sixty-two 	৬৩ তেষট্টি sixty-three 	৬৪ চৌষট্টি sixty-four 	৬৫ পঁয়ষট্টি sixty-five 	৬৬ ছেষট্টি sixty-six 	৬৭ সাতষট্টি sixty-seven 	৬৮ আটষট্টি sixty-eight 	৬৯ ঊনসত্তর sixty-nine
		// ৭০ সত্তর seventy 	৭১ একাত্তর seventy-one 	৭২ বাহাত্তর seventy-two 	৭৩ তিয়াত্তর seventy-three 	৭৪ চুয়াত্তর seventy-four 	৭৫ পঁচাত্তর seventy-five 	৭৬ ছিয়াত্তর seventy-six 	৭৭ সাতাত্তর seventy-seven 	৭৮ আটাত্তর seventy-eight 	৭৯ ঊনআশি seventy-nine
		// ৮০ আশি eighty 	৮১ একাশি eighty-one 	৮২ বিরাশি eighty-two 	৮৩ তিরাশি eighty-three 	৮৪ চুরাশি eighty-four 	৮৫ পঁচাশি eighty-five 	৮৬ ছিয়াশি eighty-six 	৮৭ সাতাশি eighty-seven 	৮৮ আটাশি eighty-eight 	৮৯ ঊননব্বই eighty-nine
		// ৯০ নব্বই ninety 	৯১ একানব্বই ninety-one 	৯২ বিরানব্বই ninety-two 	৯৩ তিরানব্বই ninety-three 	৯৪ চুরানব্বই ninety-four 	৯৫ পঁচানব্বই ninety-five 	৯৬ ছিয়ানব্বই ninety-six 	৯৭ সাতানব্বই ninety-seven 	৯৮ আটানব্বই ninety-eight 	৯৯ নিরানব্বই ninety-nine


	}
	
	//Convert Date
	function convertDate($inputDate){
		
		$engDATE = array('1','2','3','4','5','6','7','8','9','0','January','February','March','April','May','June','July','August','September','October','November','December','Saturday','Sunday','Monday','Tuesday','Wednesday','Thursday','Friday');
		$bangDATE = array('১','২','৩','৪','৫','৬','৭','৮','৯','০','জানুয়ারী','ফেব্রুয়ারী','মার্চ','এপ্রিল','মে','জুন','জুলাই','আগস্ট','সেপ্টেম্বর','অক্টোবর','নভেম্বর','ডিসেম্বর','শনিবার','রবিবার','সোমবার','মঙ্গলবার','বুধবার','বৃহস্পতিবার','শুক্রবার');
		$convertedDATE = str_replace($engDATE, $bangDATE, $inputDate);
		return $convertedDATE;
	}
}
?>