<?php

	/*
		Only for Common functions.
		Please do not create custom functions here.

	*/

	class Admin_m extends MY_Model {

		static $users 	= array();
		
		public function __construct()
		{
			parent::__construct();
			ini_set("memory_limit","512M");
		}

		public function findLeads($where, $row = false){
			if($row == true){
				$method = 'row';
			} else {
				$method = 'result';
			}

			$datas = $this->db->select('leads.*, leads_company_data.*,CONCAT(employees.first_name," ",employees.last_name) lead_manager_name')
				->join('leads_company_data', 'leads_company_data.lead_id = leads.id', 'left')
				->join('lead_manager', 'lead_manager.lead_id = leads.id')				
				->join('employees', 'employees.user_id = lead_manager.user_id')
				->where($where)
				->order_by('leads.id', 'DESC')
				->get('leads')
				->$method();
			
			$datas->services = $this->db->select('lead_services.*, services.name, sub_services.name sub_services')
				->join('services', 'services.id = lead_services.services_id')
				->join('services sub_services', 'sub_services.id = lead_services.sub_service', 'left')
				->where('lead_id', $datas->id)
				->get('lead_services')
				->result();	

			if($datas->services):
				foreach ($datas->services as $key => $value):
					//dd($value->id);
					$datas->services[$key]->detail = $this->leadServiceDtl($value->id);
				endforeach;
			endif;

			if($row == true):

				$datas->contacts = $this->findAll('lead_contacts',['lead_id'=>$datas->id]);
				return $datas;

			else:

				foreach ($datas as $key => $data):
					if($data->type == 2):
						$user = $this->find('lead_contacts',['lead_id'=>$data->id]);
						$data->name = $user->first_name.' '.$user->last_name;
					endif;	
				endforeach;
				
				return $datas;

			endif;
			
		}

		public function leadServiceDtl($value)
		{
			return $this->db->select('lead_services_detail.*, service_modules.name')
				->join('service_modules', 'service_modules.id = lead_services_detail.module_id')
				->where('lead_services_detail.lead_services_id', $value)
				->get('lead_services_detail')
				->result();
		}

		public function myAssistants($user_id){
			
			$data = findAssistants($user_id);
			
			array_push(self::$users, $user_id);	

			foreach ($data as $key => $row) {
				$this->myAssistants($row['user_id']);
				if(!in_array($row['user_id'], self::$users, true)):
					array_push(self::$users, $row['user_id']);
				endif;
			}

			return self::$users;
		}

        public function findUser($id){
        	$data = $this->db->select('users.id user_id, users.username, users.email, users.password, users.usertype_id, users.is_admin, employees.first_name, employees.last_name, employees.gender, employees.nid_no, employees.id employee_id, employees.father_name, employees.mother_name, employees.spouse_name, employees.spouse_conatct, employees.dob, employees.permanent_address, employees.present_address, employees.blood_group, employees.marital_status, employees.emp_id, employees.joining_date, employees.employmenttype_id, employees.designation_id, employees.department_id, employees.contact_number, employees.emergency_contact, employees.supervisor_id, salaries.id salary_id, salaries.basic, salaries.houserent, salaries.medical, salaries.children, salaries.communication, salaries.spacial, salaries.lta, salaries.bouns, empdocuments.id empdocuments_id, empdocuments.doc_title, empdocuments.doc_link,designation.name d_name,department.name dep_name,employees.expertise,employees.interest')
        		->join('employees', 'employees.user_id = users.id')
        		->join('salaries', 'salaries.user_id = users.id')
        		->join('designation', 'designation.id = employees.designation_id')
        		->join('department', 'department.id = employees.department_id')
        		->join('empdocuments', 'empdocuments.user_id = users.id', 'LEFT')
        		->where(['users.id' => $id])
        		->get('users')
        		->row();
        		if ($data) {
        			$data->education = $this->db->select('*')->where('user_id', $data->user_id)->get('education')->result();	
		        	$data->experience = $this->db->select('*')->where('user_id', $data->user_id)->get('emp_experience')->result();	
		        	$data->training = $this->db->select('*')->where('user_id', $data->user_id)->get('emp_training')->result();
        		}

        	return $data;

        }

        /*  employee datatable query */
		public function _get_emp_query($term = '', $where = []){ 

			$order = array('users.id' => 'desc'); // default order
			$column_order = array('employees.first_name', 'users.username', 'users.email', 'usertypes.name'); //set column field database for datatable orderable

			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}

			if( !empty($_REQUEST['columns'][1]['search']['value'])):
				if($_REQUEST['columns'][1]['search']['value'] === 'old'):
					$where['users.deleted_at !='] = NULL;
				else:
					$where['users.deleted_at'] = NULL;						
				endif;
			else:
				$where['users.deleted_at'] = NULL;
			endif;

			$this->db->select('users.id, usertypes.name user_type, users.username, users.email,department.name dep_name,empdocuments.doc_link emp_image, CONCAT(employees.first_name," ",employees.last_name) full_name, users.status, users.deleted_at');
	        $this->db->join('employees', 'employees.user_id = users.id');
	        $this->db->join('usertypes', 'usertypes.id = users.usertype_id');
	        $this->db->join('department', 'department.id = employees.department_id');
	        $this->db->join('empdocuments', 'empdocuments.user_id = users.id');
			$this->db->from('users');
			
			if(array_key_exists('where_in', $where)){
        		$this->db->where_in(key($where['where_in']), $where['where_in'][key($where['where_in'])]);	
        	} else {
        		$this->db->where($where);	
        	}

	        if($term){
	        	$this->db->like('LOWER(users.username)', strtolower($term), 'after');
	        	$this->db->or_like('users.email', $term, 'after');
	        	$this->db->or_like('LOWER(usertypes.name)', strtolower($term), 'after');
		        $this->db->or_like('LOWER(employees.first_name)', strtolower($term), 'after');
		        $this->db->or_like('LOWER(employees.last_name)', strtolower($term), 'after');
	        }	        
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }

	    }
	    /*  employee datatable query */

        public function findLeadTasks($where, $row = false){
        	if($row == true){
				$method = 'row';
			} else {
				$method = 'result';
			}

        	return $this->db->select('tasks.*,CONCAT(employees.first_name," ",employees.last_name) employee_name')
        		->join('leads', 'leads.id = tasks.lead_id')
        		->join('lead_manager', 'lead_manager.lead_id = leads.id')
        		->join('employees', 'employees.user_id = lead_manager.user_id')
        		->where($where)
        		->order_by('tasks.id', 'DESC')
        		->get('tasks')
        		->$method();
        }

      	public function findTaskData($id) {

        	$data = $this->db->select('tasks.id, tasks.name, leads.name leads_name, tasks.deadline, tasks.status')
        	    ->join('leads', 'leads.id = tasks.lead_id')
        	    ->where(['tasks.id' => $id])
        	    ->get('tasks')
        	    ->row();  

        	$data->comments = $this->db->select('task_rev.comment, CONCAT(employees.first_name, " ", employees.last_name) name, task_rev.date, task_rev.user_id commentuser, empdocuments.doc_link image')
        		->join('employees', 'employees.user_id = task_rev.user_id')
        		->join('empdocuments', 'empdocuments.user_id = task_rev.user_id')
        		->where('task_id', $id)
        		->order_by('task_rev.id', 'ASC')
        		->get('task_rev')
        		->result();

        	return $data;

        }

        /*  leads datatable query */
		public function _get_leads_query($term = '', $where = []) { 
			
			$order = array('leads.id' => 'desc'); // default order 
			$column_order = array('leads.name', '', 'lead_manager_name', 'leads.status', '', 'total_order_val'); //set column field database for datatable orderable

			$users = $this->myAssistants(getUserData('user_id'));

			$date = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : '');
			$leadName = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : '');
			$user_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
			$leadstatus_id = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');			

			$this->db->select('`leads`.*, `lead_status`.`name` `lead_status_name`, CONCAT(employees.first_name, " ", employees.last_name) lead_manager_name, (SELECT lead_contacts.mobile FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact_no, (SELECT lead_contacts.first_name FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact, (SELECT SUM(exp_total_order_val) FROM lead_services WHERE lead_services.lead_id = leads.id) total_order_val, (SELECT min(exp_order_date) FROM lead_services WHERE lead_services.lead_id = leads.id) exp_order_date, `leads_secondary_info`.`purchasing_power`');

	        $this->db->join('employees', 'employees.user_id = leads.km');
	        $this->db->join('lead_status', 'lead_status.id = leads.leadstatus_id', 'left');
	        $this->db->join('leads_secondary_info', 'leads_secondary_info.lead_id = leads.id', 'left');
			$this->db->from('leads');
			
			$this->db->where('leads.status !=', 1);

			$this->db->where('leads.deleted_at =', NULL);			

			if($leadName){
				$this->db->like('LOWER(leads.name)', strtolower($leadName), 'after');
			}
			if($user_id){
				$this->db->where('leads.km', $user_id);
			}
			if($leadstatus_id){
				$this->db->where('leads.leadstatus_id', $leadstatus_id);
			}
			
			if($where){				
				if($date){
					$this->db->where('leads.created_at', $date);
				} else {
					$this->db->where('leads.created_at', date('Y-m-d'));	
				}				
			} else {
				if(getUserData('is_admin') == 0){
					$this->db->where_in('leads.km', $users);		
				}				
			}        
	        if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function findLeadAnalytics($id)
	    {
	    	return $this->db->select('`leads`.*, `lead_status`.`name` `lead_status_name`, CONCAT(employees.first_name, " ", employees.last_name) lead_manager_name, (SELECT lead_contacts.mobile FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact_no, (SELECT lead_contacts.first_name FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact, SUM(lead_services.exp_total_order_val) total_order_val, min(lead_services.exp_order_date) exp_order_date, `leads_secondary_info`.`purchasing_power`')
	    	->join('employees', 'employees.user_id = leads.km')
	        ->join('lead_status', 'lead_status.id = leads.leadstatus_id', 'left')
	        ->join('lead_services', 'lead_services.lead_id = leads.id', 'left')
	        ->join('leads_secondary_info', 'leads_secondary_info.lead_id = leads.id', 'left')
	        ->where('leads.id', $id)
	        ->group_by('lead_services.lead_id')
	        ->order_by('leads.id', 'DESC')
	        ->get('leads')
	        ->row();
	    }


	    public function _get_tasks_query($term = '', $where = null){ 

	    	$order = array('tasks.id' => 'desc'); // default order 
			$column_order = array('leads.name','tasks.status','tasks.status','employees.first_name','tasks.deadline','tasks.updated_at'); //set column field database for datatable orderable

	    	$tasks = $this->getProjectUser('task_user', 'task_id', $where);

	    	$column = array('leads.type','leads.name', 'leads.created_at');

	    	$date = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : '');
	    	$taskName = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : '');
	    	$user_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
	    	$lead_id = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');
	    	$leadstatus_id = (!empty($_REQUEST['columns'][4]['search']['value']) ? $_REQUEST['columns'][4]['search']['value'] : '');			

			if( !empty($_REQUEST['columns'][5]['search']['value']) ) {
				$status = ($_REQUEST['columns'][5]['search']['value'] === 'running' ? 1 : 0);
			} else {
				$status = 1;
			}

	        $this->db->select('DISTINCT(tasks.id), lead_status.name lead_status_name, tasks.lead_id, tasks.name, tasks.deadline, (SELECT date FROM task_rev WHERE task_rev.task_id=tasks.id ORDER BY id DESC LIMIT 1) updated_at, tasks.status, CONCAT(employees.first_name," ",employees.last_name) employee_name, leads.name lead_name');
			$this->db->from('tasks');
			$this->db->join('leads', 'leads.id = tasks.lead_id');
			$this->db->join('employees', 'employees.user_id = leads.km');
			$this->db->join('lead_status', 'lead_status.id = leads.leadstatus_id');
			$this->db->where('leads.status', 0);
			$this->db->where('leads.deleted_at', NULL);
			$this->db->where('tasks.status', $status);

			if($taskName){
				$this->db->like('LOWER(tasks.name)', strtolower($taskName), 'after');
			}
			if($user_id){
				$this->db->where('leads.km', $user_id);
			}
			if($lead_id){
				$this->db->where('leads.id', $lead_id);
			}
			if($leadstatus_id){
				$this->db->where('leads.leadstatus_id', $leadstatus_id);
			}

			if($where):
				if(getUserData('is_admin') == 0):
					
					$this->db->where_in('tasks.id', ($tasks ? $tasks : ['']));
				endif;
			else:
				if($date){
					$this->db->where('date_format(tasks.date, "%Y-%m-%d") = ', $date);
				} else {
					$this->db->where('date_format(tasks.date, "%Y-%m-%d") = ', date('Y-m-d'));
				}
			endif;       
	        
	  		if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    /*  employee datatable query */
		public function _get_setup_query($term = '', $where = []){ 

			if($where['tbl_name']){
				$table = $where['tbl_name'];
				unset($where['tbl_name']);
			}

			$order = array($table.'.id' => 'desc'); // default order
			$column_order = array($table.'.name'); //set column field database for datatable orderable

			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}

			$this->db->select('*');
	        $this->db->from($table);
			$this->db->where($where);

			if($term){
		        $this->db->like('LOWER(name)', strtolower($term), 'after');
		    }
	        
	         if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	    /*  employee datatable query */

	    /*  clients datatable query */
		public function _get_clients_query($term = '', $where = []){ 

			$order = array('clients.id' => 'desc'); // default order 
			$column_order = array('leads.name', 'km_name', 'leads.company_email', 'lead_contact', 'leads.query_date', 'clients.created_by'); //set column field database for datatable orderable
			$user_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
	    	$lead_id = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');

			$users = $this->myAssistants(getUserData('user_id'));

			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}

			$this->db->select('leads.id, leads.name, (SELECT lead_contacts.mobile FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact_no, (SELECT lead_contacts.first_name FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact, leads.company_email, leads.company_website, leads.query_date, clients.date, concat(employees2.first_name," ",employees2.last_name) km_name');
			$this->db->join('leads', 'leads.id = clients.lead_id');
			$this->db->join('employees employees2', 'employees2.user_id = leads.km');
	        $this->db->from('clients');
			$this->db->where('leads.deleted_at', NULL);			
			$this->db->where('leads.status', '1');
			if($user_id){
				$this->db->where('leads.km', $user_id);
			}
			if($lead_id){
				$this->db->where('leads.id', $lead_id);
			}

			if($where){
				$this->db->where($where);
			} else {
				if(getUserData('is_admin') == 0){
					$this->db->where_in('leads.km', $users);
				}
			}

			if($term){
		        $this->db->like('LOWER(leads.name)', strtolower($term), 'after');
		        $this->db->or_like('LOWER(employees2.first_name)', strtolower($term), 'after');
		      	$this->db->or_like('LOWER(employees2.last_name)', strtolower($term), 'after');
		    }
	        
         	if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	    /*  clients datatable query */

	    /*  clients datatable query */
		public function _get_workspace_query($term = '', $where = []){ 

			$order = array('workspaces.id' => 'desc'); // default order 
			$column_order = array('workspace_name', 'client_name'); //set column field database for datatable orderable
            $user_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
	    	$lead_id = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');
			if( !empty($_REQUEST['columns'][0]['search']['value']) ) {
				$term = $_REQUEST['columns'][0]['search']['value'];
			}

			$this->db->select('workspaces.id, workspaces.name workspace_name,leads.name client_name, concat(employees.first_name," ",employees.last_name) km, workspaces.status, workspaces.sub_order');
			$this->db->join('leads', 'leads.id = workspaces.lead_id');
			$this->db->join('employees', 'employees.user_id = leads.km');
	        $this->db->from('workspaces');
			
			$where_in = (isset($where['where_in']) ? $where['where_in'] : []);
			$or_where = (isset($where['or_where']) ? $where['or_where'] : []);
			unset($where['where_in']);
			unset($where['or_where']);
			$this->db->where($where);
			foreach ($or_where as $k => $ow) {
				$this->db->or_where($k, $ow);
			}	
			foreach ($where_in as $key => $value) {
				$this->db->where_in($key, $value);		
			}
            if($user_id){
				$this->db->where('leads.km', $user_id);
			}
			if($lead_id){
				$this->db->where('leads.id', $lead_id);
			}
			//dd($_REQUEST);
			if($term){
				$this->db->like('LOWER(workspaces.name)', strtolower($term), 'after');
	        	$this->db->or_like('LOWER(leads.name)', strtolower($term), 'before');	
			}	        
	        
    		if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	    /*  clients datatable query */

	    /*  client_visit datatable query */
		public function _get_visitreport_query($term = '', $where = []){ 

			$order = array('client_visit.id' => 'desc'); // default order 
			$column_order = array('client_visit.vrn_no', 'employees.first_name', 'client_name', 'client_visit.location'); //set column field database for datatable orderable 

			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}
			if( !empty($_REQUEST['columns'][1]['search']['value']) ){
				$user_id = $_REQUEST['columns'][1]['search']['value'];
			}
			$this->db->select('client_visit.id, client_visit.user_id, client_visit.vrn_no, client_visit.type, client_visit.lead_id, client_visit.location, client_visit.purpose, client_visit.outcome, client_visit.status, employees.user_id, employees.first_name, employees.last_name, client_visit.others, leads.name as client_name');
			$this->db->join('employees', 'employees.user_id = client_visit.user_id');
			$this->db->join('leads', 'leads.id = client_visit.lead_id', 'left');
	        $this->db->from('client_visit');
			if(array_key_exists('where_in', $where)){

        		$whereIn = $where['where_in'];
				unset($where['where_in']);
				$this->db->where($where);
        		$this->db->where_in(key($whereIn), $whereIn[key($whereIn)]);	
        	} else {
        		$this->db->where($where);	
        	}

	        if($term){
	        	$this->db->like('LOWER(client_visit.vrn_no)', strtolower($term), 'after');
	        	$this->db->or_like('LOWER(leads.name)', strtolower($term), 'after');
	        }
	        if(isset($user_id)){
	        	$this->db->where('client_visit.user_id', $user_id);
	        }
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	     /*   emp_workreport datatable query */
		public function _get_workreport_query($term ='', $where = []){

			$order = array('emp_workreport.id' => 'desc'); // default order 
			$column_order = array('fullname', 'employees.department_id', 'supervisorname'); //set column field database for datatable orderable 

			$to_date = date('Y-m-d', strtotime('-1 day'));
			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$department_id = $_REQUEST['columns'][0]['search']['value'];
			}
			if( !empty($_REQUEST['columns'][1]['search']['value']) ){
				$date = $_REQUEST['columns'][1]['search']['value'];
			}
			$this->db->select('department.id,department.name,concat(employees.first_name," ",employees.last_name) fullname, concat(employees2.first_name," ",employees2.last_name) supervisorname,emp_workreport.id ,emp_workreport.date,emp_workreport.description, employees.department_id ');
			$this->db->join('employees', 'employees.user_id = emp_workreport.user_id');
			$this->db->join('department', 'department.id = employees.department_id');
			$this->db->join('employees employees2', 'employees2.user_id = employees.supervisor_id');
	        $this->db->from('emp_workreport');
			if(isset($department_id)){
				$this->db->where('employees.department_id', $department_id);	
			}
			if(getUserData('is_admin') == 1 && getUserData('user_type') == 6){
				$this->db->where('employees.department_id', 7);
			}
			if(getUserData('is_admin') == 1){
				if(isset($date)){
					$this->db->where('date_format(emp_workreport.	date, "%Y-%m-%d") = ', $date);	
				} else {
					$this->db->where('date_format(emp_workreport.	date, "%Y-%m-%d") >= ', $to_date);	
				}
			}
			if(getUserData('is_admin') == 0 && getUserData('user_id') != 23){
				$this->db->where_in('employees.user_id', $where);
			}
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	    /*  clients datatable query */

	    public function findworkreport($id)
	    {
        	$data = $this->db->select('concat(employees.first_name," ",employees.last_name) fullname, concat(employees2.first_name," ",employees2.last_name) supervisorname,emp_workreport.id ,emp_workreport.date,emp_workreport.description, emp_workreport.user_id')
        		->join('employees', 'employees.user_id = emp_workreport.user_id')
        		->join('employees employees2', 'employees2.user_id = employees.supervisor_id')
        		->where('emp_workreport.id', $id)
        		->order_by('emp_workreport.id', 'ASC')
        		->get('emp_workreport')
        		->row();

        	$data->reviews = $this->db->select('emp_workreport_comment.comment, CONCAT(employees.first_name, " ", employees.last_name) name, emp_workreport_comment.date, emp_workreport_comment.user_id commentuser,')
        		->join('employees', 'employees.user_id = emp_workreport_comment.user_id')
        		->where('workreport_id', $id)
        		->order_by('emp_workreport_comment.id', 'ASC')
        		->get('emp_workreport_comment')
        		->result();	

        	return $data;
        }

        public function _get_todo_query($term ='', $where = []){ 

        	//$users = $this->Admin_m->myAssistants(getUserData('user_id'));

			$this->db->select('emp_todo.id,department.name,concat(employees.first_name," ",employees.last_name) fullname, concat(employees2.first_name," ",employees2.last_name) supervisorname, emp_todo.id ,emp_todo.created_date,emp_todo.description,emp_todo.status,emp_todo.user_id, employees.department_id ');
			$this->db->join('employees', 'employees.user_id = emp_todo.user_id');
			$this->db->join('department', 'department.id = employees.department_id');
			$this->db->join('employees employees2', 'employees2.user_id = employees.supervisor_id', 'left');
	        $this->db->from('emp_todo');
			$this->db->order_by('emp_todo.id', 'DESC');
			$this->db->where('emp_todo.deleted_at', NULL);
			$this->db->where('emp_todo.status', '1');
			if(getUserData('is_admin') == 0){
				$this->db->where('emp_todo.user_id', getUserData('user_id'));
				//$this->db->where_in('employees.user_id', $where);
			}
	        
	        if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else
	        {
	            $order = $this->order;
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function findtodo($id)
	    {
        	$data = $this->db->select('concat(employees.first_name," ",employees.last_name) fullname, emp_todo.id,emp_todo.datetime,emp_todo.created_date,emp_todo.description,emp_todo.user_id, emp_todo.status')
        		->join('employees', 'employees.user_id = emp_todo.user_id')
        		->join('employees employees2', 'employees2.user_id = employees.supervisor_id', 'left')
        		->where('emp_todo.id', $id)
        		->order_by('emp_todo.id', 'ASC')
        		->get('emp_todo')
        		->row();

        	return $data;
        }

        public function findtodolist($status = NULL, $user_id = NULL)
	    {
        	$this->db->select('department.id,department.name dept_name,concat(employees.first_name," ",employees.last_name) fullname, concat(employees2.first_name," ",employees2.last_name) supervisorname, emp_todo.id ,emp_todo.created_date,emp_todo.datetime,emp_todo.description,emp_todo.status,emp_todo.user_id, employees.department_id ');
			$this->db->join('employees', 'employees.user_id = emp_todo.user_id');
			$this->db->join('department', 'department.id = employees.department_id');
			$this->db->join('employees employees2', 'employees2.user_id = employees.supervisor_id');
	        $this->db->from('emp_todo');
			$this->db->order_by('emp_todo.id', 'DESC');
			$this->db->where('emp_todo.deleted_at', NULL);
			$this->db->where('emp_todo.status', ($status === 'running' ? '1' : '0'));
			if ($user_id != NULL) {
			$this->db->where('emp_todo.user_id', $user_id);
			}
			if(getUserData('is_admin') == 0) {
				$this->db->where('emp_todo.user_id', getUserData('user_id'));
			}
			return $this->db->get()->result_array();
        }

        public function findtasklist($where = null, $status = NULL)
	   	{
		    $tasks = $this->getProjectUser('task_user', 'task_id', $where);
	        $this->db->select('tasks.id, tasks.name,tasks.description, tasks.deadline, tasks.status, leads.name lead_name')
				->join('leads', 'leads.id = tasks.lead_id')
				->where('tasks.status', ($status === 'running' ? '1' : '0'));
			if($where && getUserData('is_admin') == 0):
				$this->db->where_in('tasks.id', ($tasks ? $tasks : ['']));
			endif;
				
			$tasklist = $this->db->get('tasks')
				->result_array();
			

			return $tasklist;
        }

        public function findCompletedTodo()
	    {
        	$this->db->select('emp_todo.description');
	        $this->db->from('emp_todo');
			$this->db->order_by('emp_todo.id', 'DESC');
			//$this->db->where('emp_todo.deleted_at', NULL);
			$this->db->where('emp_todo.status', '0');
			$this->db->where('emp_todo.user_id', getUserData('user_id'));
			$this->db->where('date_format(emp_todo.completed_date, "%Y-%m-%d") = ', date('Y-m-d'));
			
			return $this->db->get()->result_array();
        }

	    /*  client_visit datatable query */
		public function _get_project_query($term = '', $where = null)
		{ 
			$order = array('projects.id' => 'desc'); // default order 
			$column_order = array('leads.name', 'workspace_name', 'department_name', 'services_name', 'name', 'fullname', 'km', 'start_date', 'deadline'); //set column field database for datatable orderable

			$projects = CI()->Admin_m->getProjectUser('project_user', 'project_id', getUserData('user_id'));

			$date = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : '');
			$projectName = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : '');
			$lead_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
			$user_id = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');

			if( !empty($_REQUEST['columns'][4]['search']['value']) ){
				$status = ($_REQUEST['columns'][4]['search']['value'] === 'running' ? 1 : 0);
			} else {
				$status = 1;
			}

			$this->db->select('DISTINCT(projects.id), concat(employees.first_name," ",employees.last_name) fullname,workspaces.name workspace_name, department.name department_name, services.name services_name, projects.name, projects.start_date, projects.deadline, workspaces.lead_id, projects.status, concat(employees2.first_name," ",employees2.last_name) km, leads.name lead_name');
			$this->db->join('workspaces', 'workspaces.id = projects.workspaces_id');
			$this->db->join('leads', 'leads.id = workspaces.lead_id');
			$this->db->join('employees employees2', 'employees2.user_id = leads.km');
			$this->db->join('department', 'department.id = projects.department_id');
			$this->db->join('services', 'services.id = projects.services_id');
			$this->db->join('employees', 'employees.user_id = projects.created_by');
	        $this->db->from('projects');
			$this->db->where('leads.status', 1);
			$this->db->where('projects.status', $status);
			if($projectName){
				$this->db->like('LOWER(projects.name)', strtolower($projectName), 'after');
			}
			if($lead_id){
				$this->db->where('leads.id', $lead_id);
			}
			if($user_id){
				$this->db->where('leads.km', $user_id);
			}

			if($where):
				if(getUserData('is_admin') == 0):				
					$this->db->where_in('projects.id', ($projects ? $projects : ['']));					
				endif;
			else:
			if($date){
					$this->db->where('date_format(projects.created_at, "%Y-%m-%d") = ', $date);				
				} else {
					$this->db->where('date_format(projects.created_at, "%Y-%m-%d") = ', date('Y-m-d'));					
				}
			endif;
	        
			if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    /*  clients datatable query */

	    /* Workspace datatable query */
		public function _get_work_tasks_query($term = '', $where = []){ 

			$order = array('projects.id' => 'desc'); // default order 
			$column_order = array('leads_name', 'workspaces.name', 'projects_name', 'name', 'km', 'deadline', 'created_employee'); //set column field database for datatable orderable

			$tasks = $this->getProjectUser('task_user', 'task_id', $where);
			
			$column = array();

			$date = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : '');
			$taskName = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : '');
			$lead_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
			$user_id = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');

			if( !empty($_REQUEST['columns'][4]['search']['value']) ){
				$status = ($_REQUEST['columns'][4]['search']['value'] === 'running' ? 1 : 0);
			} else {
				$status = 1;
			}

			$condition = [];

	        $this->db->select('DISTINCT(tasks.id), workspaces.name workspaces_name, projects.name projects_name, tasks.name, tasks.deadline, concat(employees.first_name, " ", employees.last_name) created_employee, leads.name leads_name, tasks.status, leads.name lead_name, concat(employees2.first_name," ",employees2.last_name) km');
	        $this->db->join('projects', 'projects.id = tasks.project_id');
	        $this->db->join('workspaces', 'workspaces.id = projects.workspaces_id');
	        $this->db->join('employees', 'employees.user_id = tasks.created_by');
	        $this->db->join('leads', 'leads.id = tasks.lead_id');
	        $this->db->join('employees employees2', 'employees2.user_id = leads.km');
			$this->db->from('tasks');
			$this->db->where('leads.status', 1);
			$this->db->where_in('projects.status', [1,0]);
			$this->db->where('tasks.status', $status);

			if($taskName){
				$this->db->like('LOWER(tasks.name)', strtolower($taskName), 'after');
			}
			if($lead_id){
				$this->db->where('leads.id', $lead_id);
			}
			if($user_id){
				$this->db->where('leads.km', $user_id);
			}

			if($where):
				if(getUserData('is_admin') == 0):
					$this->db->where_in('tasks.id', ($tasks ? $tasks : ['']));			
				endif;				
			else:
				if($date){
					$this->db->where('date_format(tasks.date, "%Y-%m-%d") = ', $date);
				} else {
					$this->db->where('date_format(tasks.date, "%Y-%m-%d") = ', date('Y-m-d'));
				}
			endif;	
	        
			if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function _get_billsubmission_query($term = '', $where = []){ 

	    	$order = array('visit_bills.id' => 'desc'); // default order 
			$column_order = array('visit_bills.id', 'visit_bills.bill_no', 'emp_name', 'client_visit.lead_id', 'employees.supervisor_id' ,'visit_bills.approved_by'); //set column field database for datatable orderable

			$billno = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : '');
			$userid =  (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : '');
			$status =  (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : '');

			$this->db->select('visit_bills.id, visit_bills.bill_no, visit_bills.status, visit_bills.approved_by, visit_bills.description, concat(employees.first_name," ",employees.last_name) emp_name, employees.supervisor_id, visit_bills.description, client_visit.lead_id, client_visit.others, leads.name leads_name, concat(employees2.first_name," ",employees2.last_name) approved_by');
			$this->db->join('client_visit', 'client_visit.id = visit_bills.visit_id', 'LEFT');
			$this->db->join('leads', 'leads.id = client_visit.lead_id', 'LEFT');
			$this->db->join('employees', 'employees.user_id = visit_bills.user_id');
			$this->db->join('employees employees2', 'employees2.user_id = visit_bills.approved_by', 'LEFT');
	        $this->db->from('visit_bills');
			if($billno){
				$this->db->where('visit_bills.bill_no', $billno);
			}
			if($userid){
				$this->db->where('visit_bills.user_id', $userid);
			}
			if($status){
				$this->db->where('visit_bills.status', $status);
			}
			if(array_key_exists('where_in', $where)){
				$where_in = $where['where_in'];
				unset($where['where_in']);
				$this->db->where($where);	
				foreach ($where_in as $key => $value) {
					$this->db->where_in($key, $value);		
				}        		
        	} else {
        		foreach ($where as $key => $w) {
        			$condition[$key] = $w;
        		}

        		$this->db->where($condition);	
        	}
	        if($term){
	        	$this->db->like('LOWER(visit_bills.bill_no)', strtolower($term), 'after');
		        $this->db->or_like('LOWER(employees.first_name)', strtolower($term), 'after');
		        $this->db->or_like('LOWER(employees.last_name)', strtolower($term), 'after');
	        }
	        
	 		if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function findBill($id){
	    	return $this->db->select('visit_bills.id,visit_bills.user_id, client_visit.id client_visit_id, client_visit.vrn_no, visit_bills.description, visit_bills.visit_id, visit_bills.bill_no, visit_bills.status, employees.supervisor_id')
	    			->join('client_visit', 'client_visit.id = visit_bills.visit_id', 'LEFT')
	    			->join('employees', 'employees.user_id = visit_bills.user_id')
	    			->where('visit_bills.id', $id)
	    			->get('visit_bills')
	    			->row();
	    }

	    public function findWorkTaskData($id){

        	$data = $this->db->select('id, name, deadline, status')->where(['id' => $id])->get('tasks')->row();


        	$data->comments = $this->db->select('task_rev.comment, CONCAT(employees.first_name, " ", employees.last_name) name, task_rev.date, task_rev.user_id commentuser, empdocuments.doc_link image')
        		->join('employees', 'employees.user_id = task_rev.user_id')
        		->join('empdocuments', 'empdocuments.user_id = task_rev.user_id')
        		->where('task_id', $id)
        		->order_by('task_rev.id', 'ASC')
        		->get('task_rev')
        		->result();

        	return $data;

        }


        // in dashboard count all the value function are write down below
        public function countLeads($users, $status){
			$this->db->where(['leads.status' => $status]);
			if(getUserData('is_admin') != 1):
				$this->db->where_in('km', $users);
			endif;
			$query = $this->db->get('leads');
			return $query->num_rows();
		}

		public function getGoodOrBadLeads($users = [])
		{
			$this->db->select('`leads`.*, `lead_status`.`name` `lead_status_name`, CONCAT(employees.first_name, " ", employees.last_name) lead_manager_name, (SELECT lead_contacts.mobile FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact_no, (SELECT lead_contacts.first_name FROM lead_contacts WHERE lead_contacts.lead_id = leads.id ORDER BY id DESC LIMIT 1) lead_contact, (SELECT SUM(exp_total_order_val) FROM lead_services WHERE lead_services.lead_id = leads.id) total_order_val, (SELECT min(exp_order_date) FROM lead_services WHERE lead_services.lead_id = leads.id) exp_order_date, `leads_secondary_info`.`purchasing_power`')
				->join('employees','`employees`.`user_id` = `leads`.`km`')
				->join('lead_status','`lead_status`.`id` = `leads`.`leadstatus_id`', 'LEFT')
				->join('leads_secondary_info','`leads_secondary_info`.`lead_id` = `leads`.`id`', 'LEFT')
				->where(['`leads`.`status` !=' => 1, '`leads`.`deleted_at`' => NULL]);
			if(getUserData('is_admin') != 1):
				$this->db->where_in('leads.km', $users);
			endif;	
			$results = $this->db->order_by('leads.id', 'DESC')
				->get('leads')
				->result();

			$data = [
				'insufficient' => 0,
				'good' => 0,
				'bad' => 0	
			];	

			if($results):
				foreach ($results as $key => $row):
					if(leadStatistic($row) == 0):
						$data['insufficient'] += 1;
					elseif (leadStatistic($row) < 0.6):
						$data['bad'] += 1;
					else:
						$data['good'] += 1;
					endif;
				endforeach;	
			endif;	

			return $data;
		}

		public function countProject($where){
			$where_in = [];
			if(isset($where['where_in'])):
				$where_in = $where['where_in'];
				unset($where['where_in']);
			endif;
			$projects = $this->getProjectUser('project_user', 'project_id', $where_in);

		    $this->db->select('projects.*');
	    	$this->db->where($where);
	    	if ($projects):
	    	$this->db->where_in('projects.id', $projects);
	    	endif;
	    	
	    	$query = $this->db->get('projects');

	    	return $query->num_rows();
		}
		
		public function countTasks($where){
			$where_in = [];
			if(isset($where['where_in'])):
				$where_in = $where['where_in'];
				unset($where['where_in']);
			endif;

			$tasks = $this->getProjectUser('task_user', 'task_id', $where_in);

			$this->db->select('tasks.*');  
		    if($tasks): 	
	    	$this->db->where_in('tasks.id', $tasks);
	    	endif;
	    	$this->db->where($where);
	    	$query = $this->db->get('tasks');
	    	return $query->num_rows();
		}

		

		public function taskExpData($data){
			return $this->db->select('tasks.id, tasks.deadline, tasks.name, task_user.user_id, leads.status, users.usertype_id')
				->join('tasks', 'tasks.id = task_user.task_id')
				->join('leads', 'leads.id = tasks.lead_id')
				->join('users', 'users.id = task_user.user_id')
				->where('leads.deleted_at', NULL)
				->where('tasks.status', 1)
				->where_in('tasks.deadline', $data['date'])
				->order_by('tasks.id', 'DESC')
				->get('task_user')
				->result_array();
		}

		public function projectExpData($data)
		{

			return $this->db->select('projects.id, projects.deadline, projects.name, project_user.user_id, users.usertype_id')
			    ->join('projects', 'projects.id = project_user.project_id')
				->join('workspaces', 'workspaces.id = projects.workspaces_id')
				->join('leads', 'leads.id = workspaces.lead_id')
				->join('users', 'users.id = project_user.user_id')
				->where('leads.status', 1)
				->where('projects.status', 1)
				->where_in('projects.deadline', $data['date'])
				->get('project_user')
				->result_array();
		}	

		public function projectTaskExpData($data)
		{
			$projects = $this->getProjectUser('project_user', 'project_id', $data['users']);
			
			return $this->db->select('DISTINCT(tasks.id), tasks.deadline, tasks.name')
				->join('projects', 'projects.id = tasks.project_id')
		        ->join('workspaces', 'workspaces.id = projects.workspaces_id')
		        ->join('leads', 'leads.id = workspaces.lead_id')
				->join('lead_manager', 'lead_manager.lead_id = leads.id')
				->where('projects.status', 1)
				->where('tasks.status', 1)
				->where_in('tasks.project_id', ($projects ? $projects : ['']))
				->or_where('leads.status', 1)
				->where('lead_manager.status', 1)
				->where_in('lead_manager.user_id', $data['users'])
				->where_in('tasks.deadline', $data['date'])
				->order_by('tasks.id', 'DESC')
				->get('tasks')
				->result_array();
		}

		public function getProjectUser($table, $field, $data = [])
		{
			$this->db->select($field);
			if(getUserData('is_admin') != 1):
				$this->db->where_in('user_id', ($data ? $data : ['']));
			endif;
			$projects = $this->db->get($table)->result_array();

			$pid = [];
			if($projects):
				foreach ($projects as $key => $project) {
					array_push($pid, $project[$field]);				
				}
			endif;

			return array_unique($pid);
		}

		public function getLeadByManager($data) {
			$leads = $this->db->select('lead_id')
			    ->where('status', 1)
			    ->where_in('user_id', ($data ? $data : ['']))
			    ->get('lead_manager')
			    ->result_array();

			$lid = [];
			if($leads):
				foreach ($leads as $key => $lead) {
					array_push($lid, $lead['lead_id']);				
				}
			endif;

			return array_unique($lid);	
		}

		public function getBillUserList()
		{
			$results = $this->db->select('DISTINCT(visit_bills.user_id) id, CONCAT(employees.first_name," ",employees.last_name) name')
				->join('employees', 'employees.user_id = visit_bills.user_id')
			    ->where('status', '3')
			    ->get('visit_bills')
			    ->result_array();
			$lid = ['' => 'SELECT USER'];
			if($results):
				foreach ($results as $key => $result) {
					$lid[$result['id']] = $result['name'];
				}
			endif;

			return $lid;	
		}

		function getUserBill($id){
			return $this->db->select('SUM(client_visit_cost.approved_amount) approved_amount, visit_bills.id, visit_bills.bill_no, visit_bills.description')
				->join('client_visit_cost', 'client_visit_cost.visit_bill_id = visit_bills.id')
				->where(['visit_bills.user_id' => $id, 'visit_bills.status' => '3'])
				->group_by('visit_bills.id')
				->get('visit_bills')
				->result();
		}

		public function findVisitreport($id)
	    {
        	$data = $this->db->select('visitreport_comment.comment, CONCAT(employees.first_name, " ", employees.last_name) name, visitreport_comment.date, visitreport_comment.user_id comment_user')
        		->join('employees', 'employees.user_id = visitreport_comment.user_id')
        		->where('visitreport_id', $id)
        		->order_by('visitreport_comment.id', 'ASC')
        		->get('visitreport_comment')
        		->result();	

        	return $data;
        }

        public function _get_notification_query($term = '' , $where = '')
        {
        	$order = array('notifications.id' => 'desc'); // default order
			$column_order = array(); //set column field database for datatable orderable

        	if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}
			
			$where_in = (isset($where['where_in']) ? $where['where_in'] : []);
			unset($where['where_in']);
		
    	    $this->db->select('*');
    	    if($where):
	    	    $this->db->where($where);
	    	endif;
			foreach ($where_in as $key => $value):
				$this->db->where_in($key, $value);		
			endforeach;
    		$this->db->from('notifications');
    		$this->db->order_by('id', 'DESC');

        	if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
        }

        function getFunnelData($where){
			$this->db->select('lead_status.name, count(leads.leadstatus_id) total, lead_status.bg_color, SUM(lead_services.exp_total_order_val) total_val')
				->join('leads', 'lead_status.id = leads.leadstatus_id', 'LEFT')
				->join('lead_services', 'lead_services.lead_id = leads.id', 'LEFT');

			$where_in = (isset($where['where_in']) ? $where['where_in'] : []);
			unset($where['where_in']);
			$this->db->where($where);
			foreach ($where_in as $key => $value) {
				$this->db->where_in($key, $value);		
			}	
			$results = $this->db->group_by('lead_status.id')
				->order_by('lead_status.id')
				->get('lead_status')
				->result_array();
				
			$data = [];	

			if($results):
				foreach ($results as $key => $result) {
					$data[$key] = [
						($result['total'] ? $result['total'] : "0"), $result['name'], $result['bg_color'], $result['total_val']
					];
				}
			else:
				$data[] = [
					0, '', '#ffffff'
				];
			endif;

			$this->db->select('lead_status.name, count(leads.leadstatus_id) total, lead_status.bg_color, SUM(lead_services.exp_total_order_val) total_val')
				->join('leads', 'lead_status.id = leads.leadstatus_id', 'LEFT')
				->join('lead_services', 'lead_services.lead_id = leads.id', 'LEFT');

			$where['leads.status'] = 1;
			$where['leads.leadstatus_id'] = 7;

			$this->db->where($where);
			foreach ($where_in as $key => $value) {
				$this->db->where_in($key, $value);		
			}	
			$clients = $this->db->group_by('lead_status.id')
				->order_by('lead_status.id')
				->get('lead_status')
				->row_array();

			if($clients):
				$data[] = [
					($clients['total'] ? $clients['total'] : "0"), 'Clients', '#2c3e50', $clients['total_val']
				];
			endif;

			return json_encode($data);
		}

		public function findworkspace($id){
        	$data = $this->db->select('workspaces.*, workspaces.id work_id')
        		->join('workorder_cost_breakdown', 'workorder_cost_breakdown.workspace_id = workspaces.id', 'left')
        		->join('workorder_payment', 'workorder_payment.workspace_id = workspaces.id', 'left')
        		->where(['workspaces.id' => $id])
        		->group_by('workorder_cost_breakdown.workspace_id')
        		->get('workspaces')
        		->row();

        		if ($data) {
        			$data->workorder_payment = $this->db->where('workspace_id', $data->work_id)->get('workorder_payment')->result();	
        			$data->cost_breakdown = $this->db->where('workspace_id', $data->work_id)->get('workorder_cost_breakdown')->result();
		        	$data->projects = $this->db->where('workspaces_id', $data->work_id)->get('projects')->result();

        		}

        	return $data;

        }

        public function findsubwork($id){
        	$results = $this->db->select('workspaces.id, workspaces.lead_id, workspaces.workorder_no,workspaces.sub_order, workspaces.name, workspaces.agreement_date, workspaces.upload,workspaces.comment, workspaces.status')
        		->where(['workspaces.sub_order' => $id])
        		->get('workspaces')
        		->result_array();

        	$data = [];
        	
        	foreach ($results as $key => $result) {
    			$data[$key] = $result;


    			$data[$key]->workorder_payment = $this->db->select('*')->where('workspace_id', $result->work_id)->get('workorder_payment')->result();
    			$data[$key]->cost_breakdown = $this->db->select('*')->where('workspace_id', $result->work_id)->get('workorder_cost_breakdown')->result_array();

    			$data[$key]->projects = $this->db->select('*')->where('workspaces_id', $result->work_id)->get('projects')->result();

    		}	
        		
        	return $data;

        }

        public function findinvoice($id)
	    {
        	$data = $this->db->select('workspaces.id,workspaces.workorder_no,workspaces.name,leads.name,leads.company_email, leads.street, leads.street2, leads.city, leads.state, leads.zip,CONCAT(lead_contacts.first_name," ",lead_contacts.last_name) lead_contact_name,lead_contacts.email lead_contact_email,lead_contacts.mobile lead_contact_mobile')
        	    ->join('leads', 'leads.id = workspaces.lead_id')
        	    ->join('lead_contacts', 'lead_contacts.lead_id = workspaces.lead_id')
        	    ->join('workorder_cost_breakdown', 'workorder_cost_breakdown.workspace_id = workspaces.id') 
        		->where(['workspaces.id' => $id])
        		->get('workspaces')
        		->row(); 


        	if ($data) {
        				
		        	//$data->cost_breakdown = $this->db->select('*')->where('workspace_id', $data->id) ->where('other', NULL)->get('workorder_cost_breakdown')->result();	

        			$data->cost_breakdown = $this->db->select('*')
		        	->where('workspace_id', $data->id)->get('workorder_cost_breakdown')->result_array();	

        		}

        	return $data;
        }

        public function getWorkorderCurrentPayStatus($id='')
        {
        	return $this->db->select('sum(workorder_cost_breakdown.service_cost) total_ammount, sum(workorder_payment.ammount) total_payment')
        		->join('workorder_cost_breakdown', 'workorder_cost_breakdown.workspace_id = workspaces.id')
        		->join('workorder_payment', 'workorder_payment.workspace_id = workspaces.id')
        		->where(['workspaces.id' => $id])
        		->group_by('workorder_cost_breakdown.workspace_id')
        		->get('workspaces')
        		->row();
        }

        public function getDataForCal($id = NULL)
        {
        	$events = array();
			
        	$todo = $this->db->select('id, datetime, description')
        		->where('date_format(datetime, "%Y-%m-%d") >= ', date('Y-m-d'))
        		->where('user_id', ($id ? $id : getUserData('user_id')))
        		->get('emp_todo')
        		->result_array();

			if($todo):
				foreach ($todo as $key => $row):
					$e = array();
				    $e['id'] = $row['id'];
				    $e['title'] = 'TODO: '.$row['description'];
				    $e['start'] = $row['datetime'];
				    $e['url'] = base_url('hr/management/todo');
				    $e['color'] = '#d9edf7';
				    $e['textColor'] = '#31708f';
				    array_push($events, $e);
				endforeach;
			endif;

			$projects = $this->db->select('projects.id, projects.name, projects.deadline')
				->join('project_user', 'project_user.project_id = projects.id')
				->where('projects.deadline >=', date('Y-m-d'))
				->where('project_user.user_id', ($id ? $id : getUserData('user_id')))
				->get('projects')
				->result_array();

			if($projects):	
				foreach ($projects as $key => $row):
					$e = array();
				    $e['id'] = $row['id'];
				    $e['title'] = 'Project Deadline: '.$row['name'];
				    $e['start'] = $row['deadline'];
				    $e['url'] = base_url('crm/workspace/projects/view/'.$row['id']);
				    $e['color'] = '#fcf8e3';
				    $e['textColor'] = '#8a6d3b';	    
					array_push($events, $e);
				endforeach;
			endif;

			$tasks = $this->db->select('tasks.id, tasks.name, tasks.deadline')
				->join('task_user', 'task_user.task_id = tasks.id')
				->where('tasks.deadline >=', date('Y-m-d'))
				->where('task_user.user_id', ($id ? $id : getUserData('user_id')))
				->get('tasks')
				->result_array();

			if($tasks):	
				foreach ($tasks as $key => $row):
					$e = array();
				    $e['id'] = $row['id'];
				    $e['title'] = 'Task Deadline: '.$row['name'];
				    $e['start'] = $row['deadline'];
				    $e['url'] = base_url('crm/workspace/tasks/preview/'.$row['id']);
				    $e['color'] = '#fcf8e3';
				    $e['textColor'] = '#8a6d3b';
				    array_push($events, $e);
				endforeach;
			endif;

			$users = $this->db->select('users.id, concat(employees.first_name," ",employees.last_name) name, employees.dob deadline')
				->join('employees', 'employees.user_id = users.id')
				->where(['users.status' => 1, 'users.deleted_at' => NULL])
				->get('users')
				->result_array();

			if($users):
				foreach ($users as $key => $row):
					$e = array();
				    $e['id'] = $row['id'];
				    $e['title'] = 'Birthday: '.$row['name'];
				    $e['start'] = date('Y').'-'.date("m-d", strtotime($row['deadline']));
				    $e['url'] = base_url('hr/employee/view/'.$row['id']);
				    $e['color'] = '#7CFC00';
				    $e['textColor'] = '#006400';
				    array_push($events, $e);
				endforeach;
			endif;	
			
			return $events;
        }

        public function deliverableDataDtl($users)
        {
        	$tasks_id = [];
        	$data = [];
        	if(getUserData('is_admin') != 1):
        		$results = $this->db->select('task_id')->where_in('user_id', $users)->get('task_user')->result_array();        		
        		foreach ($results as $key => $row):
        			$tasks_id[] = $row['task_id'];
        		endforeach;        		
        	endif;
        	
			$this->db->from("tasks")
				->where(['tasks.updated_at >=' => date('Y-m-01', strtotime('-1 month', strtotime(date('Y-m-d')))), 'tasks.updated_at <=' => date('Y-m-t', strtotime('-1 month', strtotime(date('Y-m-d')))), 'tasks.status' => 0]);	
			if(getUserData('is_admin') != 1):
				$this->db->where_in('id', ($tasks_id ? $tasks_id : ['']));
			endif;
			$completed_task = $this->db->count_all_results();
			$data['info'][] = [
				$completed_task, 'Completed', '#82AF6F'
			];

			$this->db->from("tasks")
				->where(['tasks.updated_at >=' => date('Y-m-01', strtotime('-1 month', strtotime(date('Y-m-d')))), 'tasks.updated_at <=' => date('Y-m-t', strtotime('-1 month', strtotime(date('Y-m-d')))), 'tasks.status' => 1]);
			if(getUserData('is_admin') != 1):
				$this->db->where_in('id', ($tasks_id ? $tasks_id : ['']));
			endif;
			$running_task = $this->db->count_all_results();
			$data['info'][] = [
				$running_task, 'Running', '#3A87AD'
			];

			$this->db->from("tasks")
				->where(['tasks.updated_at >=' => date('Y-m-01', strtotime('-1 month', strtotime(date('Y-m-d')))), 'tasks.updated_at <=' => date('Y-m-t', strtotime('-1 month', strtotime(date('Y-m-d')))), 'date_format(deadline, "%Y-%m-%d") <= ' => date('Y-m-d'), 'status' => 1]);
			if(getUserData('is_admin') != 1):
				$this->db->where_in('id', ($tasks_id ? $tasks_id : ['']));
			endif;
			$failed_task = $this->db->count_all_results();
			$data['info'][] = [
				$failed_task, 'Failed', '#D15B47'
			];

			$data['total'] = $completed_task + $running_task + $failed_task;

			return json_encode($data);        
		}

		public function viewProjectInfo($id)
		{
			$result = $this->db->select('*')->where('id', $id)->get('projects')->row();
			
			if($result):
				$result->project_user = $this->db->select('employees.id, CONCAT(employees.first_name," ",employees.last_name) fullname, department.name department_name, designation.name designation_name, empdocuments.doc_link')
					->join('employees', 'employees.user_id = project_user.user_id')
					->join('users', 'users.id = employees.user_id')
					->join('department', 'department.id = employees.department_id')
					->join('designation', 'designation.id = employees.designation_id')
					->join('empdocuments', 'empdocuments.user_id = employees.user_id')
					->where(['project_user.project_id' => $id, 'users.status' => '1'])
					->get('project_user')
					->result();
			endif;

			return $result;
		}

		public function getModuleList($value)
		{
			return $this->db->query('select * from service_modules where find_in_set('.$value.',service_id) <> 0')->result_array();
		}

		public function getAttData($where = [])
		{
			if(empty($where)){
				$where = ['date_format(attendance.timestamp, "%Y-%m-%d") =' => date('Y-m-d')];
			}

			$this->db->select('attendance.*, concat(employees.first_name," ",employees.last_name) fullname, department.name department')
				->join('employees', 'employees.user_id = attendance.user_id')
				->join('department', 'department.id = employees.department_id')->where($where);

			if(getUserData('is_admin') != 1):
				$this->db->where_in('attendance.user_id', getUserData('supervisor_of'));
			endif;	

			return $this->db->get('attendance')->result_array();
		}

	}