<?php

	/*
		Only for Common functions.
		Please do not create custom functions here.

	*/

	class Inventory_m extends MY_Model {

		static $users 	= array();
		
		public function __construct()
		{
			parent::__construct();
			ini_set("memory_limit","512M");
		}

		/*  inventory datatable query */
		public function _get_inventory_query($term = '', $where = []){ 

			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}

			// id, inventory.warehouse_id, inventory.product_id, inventory.product_brand, inventory.model_no, inventory.description,inventory.status, inventory.purchase_date, inventory.invoice_no,
			$this->db->select('inventory.*, warehouse.name warehouse_name, products.name product_name, product_brand.name product_brand_name ');
			$this->db->join('warehouse', 'warehouse.id = inventory.warehouse_id');
			$this->db->join('products', 'products.id = inventory.product_id');
		    $this->db->join('product_brand', 'product_brand.id = inventory.product_brand');
			$this->db->from('inventory');
			$this->db->order_by('inventory.id', 'DESC');
        	$this->db->where($where);	

	        if($term){
	        	$this->db->like('LOWER(inventory.product_id)', strtolower($term), 'after');
	        	$this->db->or_like('inventory.product_brand', $term, 'after');
	        }	        
	        
	        if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $order = $this->order;
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	   

	    /*  inventory report query */
		public function _get_inventory_report_query($term = '', $where = []){ 

			$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));
			$cat_id = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['cat_id'] : ''));
			$product_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['product_id'] : ''));
			

			$this->db->select('assigned_inventory.*, concat(employees.first_name," ",employees.last_name) product_user_name, products.name product_name,product_category.name cat_name');
			$this->db->join('employees', 'employees.user_id = assigned_inventory.user_id');
			$this->db->join('products', 'products.id = assigned_inventory.product_id');
			$this->db->join('product_category', 'product_category.id = assigned_inventory.cat_id');
	        $this->db->from('assigned_inventory');
			$this->db->order_by('assigned_inventory.id', 'DESC');

			if($user_id){
				$this->db->where('assigned_inventory.user_id', $user_id);	
			}
			if($cat_id){
				$this->db->where('assigned_inventory.cat_id', $cat_id);		
			}
			if($product_id){
				$this->db->where('assigned_inventory.product_id', $product_id);		
			}
			
	        
	        if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $order = $this->order;
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function _get_requisition_query($term ='', $where = []){ 

			$column_order = array('fullname', 'cat_name', 'inv_requisition.from_date', 'inv_requisition.to_date'); //set column field database for datatable orderable

        	//$users = $this->Admin_m->myAssistants(getUserData('user_id'));

			$this->db->select('concat(employees.first_name," ",employees.last_name) fullname, inv_requisition.id, product_category.name cat_name, inv_requisition.status, inv_requisition.from_date, inv_requisition.to_date')
				->join('employees', 'employees.user_id = inv_requisition.user_id')
				->join('product_category', 'product_category.id = inv_requisition.category_id')
				->from('inv_requisition')
				->order_by('inv_requisition.id', 'DESC');
			$this->db->where($where);
			if(getUserData('is_admin') == 0){
				$this->db->where('inv_requisition.user_id', getUserData('user_id'));
			}
	        
	        
	        if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $order = $this->order;
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }


	}