<?php

	/*
		Only for Common functions.
		Please do not create custom functions here.

	*/

	class Report_m extends MY_Model {

		public function __construct()
		{
			parent::__construct();
			ini_set("memory_limit","512M");
		}

		/*  client_visit datatable query */
		public function _get_visitreport_query($term = '', $where = []){ 

			$order = array('client_visit.id' => 'desc'); // default order
			$column_order = array('client_visit.vrn_no','employees.first_name', 'client_visit.lead_id'); //set column field database for datatable orderable

			$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));
			$lead_id = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['lead_id'] : ''));
			$from_date = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['to_date'] : ''));

			$this->db->select('client_visit.id, client_visit.user_id, client_visit.vrn_no, client_visit.type, client_visit.lead_id, client_visit.location, client_visit.purpose, client_visit.outcome, client_visit.status, employees.user_id, employees.first_name, employees.last_name, client_visit.others');
			$this->db->join('employees', 'employees.user_id = client_visit.user_id');
			$this->db->join('leads', 'leads.id = client_visit.lead_id', 'left');
	        $this->db->from('client_visit');

			if($user_id){
				$this->db->where('client_visit.user_id', $user_id);	
			}
			if($lead_id){
				$this->db->where('client_visit.lead_id', $lead_id);	
			}
			if($from_date && $to_date){
				$this->db->where('client_visit.visit_date >=', $from_date);
				$this->db->where('client_visit.visit_date <=', $to_date);	
			}
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

		/*  daily report query */
		public function _get_dailyreport_query($term = '', $where = []){
			$order = array('emp_workreport.id' => 'desc'); // default order
			$column_order = array('employees.first_name','department.name','employees.supervisor_id','emp_workreport.description','emp_workreport.date'); //set column field database for datatable orderable 

			$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));
			$department_id = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['department_id'] : ''));
			$from_date = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['to_date'] : ''));
			

			$this->db->select('department.id,department.name,concat(employees.first_name," ",employees.last_name) fullname, concat(employees2.first_name," ",employees2.last_name) supervisorname,emp_workreport.id ,emp_workreport.date,emp_workreport.description, employees.department_id ');
			$this->db->join('employees', 'employees.user_id = emp_workreport.user_id');
			$this->db->join('department', 'department.id = employees.department_id');
			$this->db->join('employees employees2', 'employees2.user_id = employees.supervisor_id');
	        $this->db->from('emp_workreport');
			
			if($user_id){
				$this->db->where('employees.user_id', $user_id);	
			}
			if($department_id){
				$this->db->where('employees.department_id', $department_id);		
			}
			if($from_date && $to_date){
				$this->db->where('date_format(emp_workreport.date, "%Y-%m-%d") >=', $from_date);
				$this->db->where('date_format(emp_workreport.date, "%Y-%m-%d") <=', $to_date);		
			}
	        
	        if(isset($_REQUEST['order'])) // here order processing
	        {
	        	$this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    /*  leads report datatable query */
		public function _get_leads_query($term = '', $where = []){ 

			$order = array('leads.id' => 'desc'); // default order
			$column_order = array('leads.name','employees.first_name','department.name','employees.supervisor_id','emp_workreport.description','emp_workreport.date'); //set column field database for datatable orderable 

			$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));
			$leadstatus_id = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['leadstatus_id'] : ''));
			$from_date = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['to_date'] : ''));

			$this->db->select('leads.*, lead_status.name lead_status_name,CONCAT(employees.first_name," ",employees.last_name) lead_manager_name,CONCAT(leads.company_email,"<br> ",leads.company_contact) lead_contact');
	        $this->db->join('employees', 'employees.user_id = leads.km');
	        $this->db->join('lead_status', 'lead_status.id = leads.leadstatus_id');
			$this->db->from('leads');
			$this->db->order_by('leads.id', 'DESC');
			$this->db->where('leads.status', 0);
			$this->db->where('leads.deleted_at =', NULL);


			if($user_id){
				$this->db->where('leads.km', $user_id);	
			}
			if($leadstatus_id){
				$this->db->where('leads.leadstatus_id', $leadstatus_id);	
			}
			if($from_date && $to_date){
				$this->db->where('leads.created_at >=', $from_date);
				$this->db->where('leads.created_at <=', $to_date);	
			}

	        
	        if(isset($_REQUEST['order'])) // here order processing
	        {
	            $this->db->order_by($column_order[$_REQUEST['order']['0']['column']], $_REQUEST['order']['0']['dir']);
	        }
	        else if(isset($this->order))
	        {
	            $this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function servicedetail($id){

	    	$services = $this->db->select('lead_services.*, services.name, sub_services.name sub_services')
				->join('services', 'services.id = lead_services.services_id')
				->join('services sub_services', 'sub_services.id = lead_services.sub_service', 'left')
				->where('lead_id', $id)
				->get('lead_services')
				->result();	

			if($services):
				foreach ($services as $key => $value):
					$services[$key]->detail = $this->Admin_m->leadServiceDtl($value->id);
				endforeach;
			endif;
			return $services;
	    }

	   	/*  leads task report datatable query */
		public function _get_lead_tasks_query($term = '', $where = []){ 

			$order = array('tasks.id' => 'desc'); // default order
			$column_order = array('leads.name','lead_status.name','department.name','employees.supervisor_id','emp_workreport.description','emp_workreport.date'); //set column field database for datatable orderable 

			$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));
			$leadstatus_id = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['leadstatus_id'] : ''));
			$lead_id = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['lead_id'] : ''));
			$status = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['status'] : ''));
			$from_date = (!empty($_REQUEST['columns'][4]['search']['value']) ? $_REQUEST['columns'][4]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][5]['search']['value']) ? $_REQUEST['columns'][5]['search']['value'] : ($where ? $where['to_date'] : ''));
			$order = array('tasks.id' => 'desc'); // default order
			$column_order = array('leads.name','lead_status.name','tasks.name','employees.first_name','tasks.description','tasks.deadline'); //set column field database for datatable orderable 

			$this->db->select('DISTINCT(tasks.id), lead_status.name lead_status_name, tasks.lead_id, tasks.name, leads.name leads_name, tasks.deadline, (SELECT date FROM task_rev WHERE task_rev.task_id=tasks.id ORDER BY id DESC LIMIT 1) updated_at, tasks.status, CONCAT(employees.first_name," ",employees.last_name) employee_name');
			$this->db->from('tasks');
			$this->db->join('leads', 'leads.id = tasks.lead_id');
			$this->db->join('employees', 'employees.user_id = leads.km');
			$this->db->join('lead_status', 'lead_status.id = leads.leadstatus_id');
			$this->db->where('leads.status', 0);

			if($user_id){
				$this->db->where('leads.km', $user_id);	
			}
			if($lead_id){
				$this->db->where('leads.id', $lead_id);	
			}
			if($leadstatus_id){
				$this->db->where('leads.leadstatus_id', $leadstatus_id);	
			}
			if($status){
				$this->db->where('tasks.status', ($status === 'running' ? 1 : 0));	
			}
			if($from_date && $to_date){
				$this->db->where('date_format(tasks.date, "%Y-%m-%d") >=', $from_date);
				$this->db->where('date_format(tasks.date, "%Y-%m-%d") <=', $to_date);	
			}

	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    public function _get_clients_query($term = '', $where = []){ 

			$order = array('clients.id' => 'desc'); // default order
			$column_order = array('leads.name','km_name','leads.company_email','leads.company_contact'); //set column field database for datatable orderable 

			$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));
			$from_date = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['to_date'] : ''));

			$this->db->select('DISTINCT(leads.id), leads.name, leads.company_contact, leads.company_email, leads.company_website, clients.date, concat(employees.first_name," ",employees.last_name) emp_name, concat(employees2.first_name," ",employees2.last_name) km_name');
			$this->db->join('leads', 'leads.id = clients.lead_id', 'INNER');
			$this->db->join('employees', 'employees.user_id = clients.created_by', 'INNER');
			$this->db->join('lead_manager', 'lead_manager.lead_id = leads.id', 'INNER');
			$this->db->join('employees employees2', 'employees2.user_id = lead_manager.user_id', 'INNER');
	        $this->db->from('clients');
			
			$this->db->where('leads.status', 1);
			$this->db->where('lead_manager.status', 1);

			if($user_id){
				$this->db->where('lead_manager.user_id', $user_id);	
			}
			if($from_date && $to_date){
				$this->db->where('date_format(clients.date, "%Y-%m-%d") >=', $from_date);
				$this->db->where('date_format(clients.date, "%Y-%m-%d") <=', $to_date);		
			}

	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	    /* Project Report query */
		public function _get_project_query($term = '', $where = null)
		{ 
			$order = array('projects.id' => 'desc'); // default order
			$column_order = array('leads.name','workspace_name','department_name','services_name', 'projects.name', 'km'); //set column field database for datatable orderable 

			$client_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['lead_id'] : ''));
			$department_id = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['id'] : ''));
			$service = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['services_id'] : ''));
			$status = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['status'] : ''));
			$from_date = (!empty($_REQUEST['columns'][4]['search']['value']) ? $_REQUEST['columns'][4]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][5]['search']['value']) ? $_REQUEST['columns'][5]['search']['value'] : ($where ? $where['to_date'] : ''));

			if( !empty($_REQUEST['columns'][0]['search']['value']) ){
				$term = $_REQUEST['columns'][0]['search']['value'];
			}

			$this->db->select('DISTINCT(projects.id), concat(employees.first_name," ",employees.last_name) fullname,workspaces.name workspace_name, department.name department_name, services.name services_name, projects.name, projects.deadline, workspaces.lead_id, leads.name lead_name, projects.status, concat(employees2.first_name," ",employees2.last_name) km');
			$this->db->join('workspaces', 'workspaces.id = projects.workspaces_id');
			$this->db->join('leads', 'leads.id = workspaces.lead_id');
			$this->db->join('employees employees2', 'employees2.user_id = leads.km');
			$this->db->join('department', 'department.id = projects.department_id');
			$this->db->join('services', 'services.id = projects.services_id');
			$this->db->join('employees', 'employees.user_id = projects.created_by');
	        $this->db->from('projects');
			$this->db->where('leads.status', 1);

			if($client_id){
				$this->db->where('leads.id', $client_id);	
			}
			if($department_id){
				$this->db->where('employees.department_id', $department_id);		
			}
			if($service){
				$this->db->where('services.id', $service);		
			}
			if($status){
				$this->db->where('projects.status', ($status === 'running' ? 1 : 0));	
			}
			if($from_date && $to_date){
				$this->db->where('date_format(projects.created_at, "%Y-%m-%d") >=', $from_date);
				$this->db->where('date_format(projects.created_at, "%Y-%m-%d") <=', $to_date);	
			}
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }
	    /*  workspace task query */
	    public function _get_work_tasks_query($term = '', $where = []){ 

	    	$order = array('tasks.id' => 'desc'); // default order
			$column_order = array('leads.name','workspaces.name', 'projects.name', 'tasks.name', 'km'); //set column field database for datatable orderable 

	    	$client_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['lead_id'] : ''));
			$status = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['status'] : ''));
			$from_date = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][3]['search']['value']) ? $_REQUEST['columns'][3]['search']['value'] : ($where ? $where['to_date'] : ''));
			

			$this->db->select('DISTINCT(tasks.id), workspaces.name workspaces_name, projects.name projects_name, tasks.name, tasks.deadline, concat(employees.first_name, " ", employees.last_name) employee_name, leads.name lead_name, tasks.status, concat(employees2.first_name," ",employees2.last_name) km');	        
	        $this->db->join('projects', 'projects.id = tasks.project_id');
	        $this->db->join('workspaces', 'workspaces.id = projects.workspaces_id');
	        $this->db->join('employees', 'employees.user_id = tasks.created_by');
	        $this->db->join('leads', 'leads.id = tasks.lead_id');
	        $this->db->join('employees employees2', 'employees2.user_id = leads.km');
			$this->db->from('tasks');
			$this->db->where('leads.status', 1);
			$this->db->where_in('projects.status', [1,0]);

			if($client_id){
				$this->db->where('leads.id', $client_id);	
			}

			if($status){
				$this->db->where('tasks.status', ($status === 'running' ? 1 : 0));	
			}
			if($from_date && $to_date){
				$this->db->where('date_format(tasks.date, "%Y-%m-%d") >=', $from_date);
				$this->db->where('date_format(tasks.date, "%Y-%m-%d") <=', $to_date);	
			}
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
	    }

	   	public function _get_notification_query($term = '' , $where = '')
        {
        	$order = array('notifications.id' => 'desc'); // default order
			$column_order = array('employee_name'); //set column field database for datatable orderable 

        	$user_id = (!empty($_REQUEST['columns'][0]['search']['value']) ? $_REQUEST['columns'][0]['search']['value'] : ($where ? $where['user_id'] : ''));

			$from_date = (!empty($_REQUEST['columns'][1]['search']['value']) ? $_REQUEST['columns'][1]['search']['value'] : ($where ? $where['from_date'] : ''));
			$to_date = (!empty($_REQUEST['columns'][2]['search']['value']) ? $_REQUEST['columns'][2]['search']['value'] : ($where ? $where['to_date'] : ''));
		
    	    $this->db->select('notifications.id,notifications.user_id,notifications.title,notifications.source_url,notifications.created_date, concat(employees.first_name, " ", employees.last_name) employee_name');
    	    $this->db->join('employees', 'employees.user_id = notifications.user_id');
    		$this->db->from('notifications');

	        if($user_id){
				$this->db->where('employees.user_id', $user_id);	
			}
		
			if($from_date && $to_date){
				$this->db->where('date_format(notifications.created_date, "%Y-%m-%d") >=', $from_date);
				$this->db->where('date_format(notifications.created_date, "%Y-%m-%d") <=', $to_date);		
			}
	        
			if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
        }

        public function _get_Att_Data($term = '', $where = [])
		{
			$order = array('attendance.id' => 'desc'); // default order 
			$column_order = array('fullname','attendance.latitude','attendance.timestamp'); //set column field database for datatable orderable 
			if(empty($where)){
				$where = ['date_format(attendance.timestamp, "%Y-%m-%d") =' => date('Y-m-d')];
			}

			$this->db->select('attendance.*, CONCAT(employees.first_name," ",employees.last_name) fullname,department.name department');
			$this->db->join('employees', 'employees.user_id = attendance.user_id');
			$this->db->join('department', 'department.id = employees.department_id');
			$this->db->from('attendance');
			$this->db->where($where);
        	 


			if(getUserData('is_admin') != 1):
				$this->db->where_in('attendance.user_id', getUserData('supervisor_of'));
			endif;	
          
           if(isset($_POST['order'])) // here order processing
			{
				$this->db->order_by($column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
			}
	        else if(isset($order))
	        {
	        	$this->db->order_by(key($order), $order[key($order)]);
	        }
		}

	}
