<div class="dataTables_wrapper form-inline no-footer">
    <div class="row">
        <div class="col-sm-10">
            <div class="row">                    
                <div class="col-sm-2">
                    <div class="form-group">
                        <label for="user_id">Lead name</label>
                        <input placeholder="Lead name" class="form-control input-sm filter-value" type="search" value="" style="width: calc(100% - 5px);">
                    </div>
                </div> 
                <div class="col-sm-2">
                    <div class="form-group">
                        <label for="user_id">KM</label>
                        <?php echo form_dropdown('user_id' , userList((getUserData('is_admin') == 0 ? ['where_in' => ['users.id' => getUserData('supervisor_of')]] : [])), '', ['class' => 'select2', 'id' => 'user_id']);
                           ?> 
                    </div>
                </div>       
                <div class="col-sm-2">
                    <div class="form-group">
                        <label for="lead_id">Lead status</label>
                        <?php echo form_dropdown('leadstatus_id' , listdata('lead_status'), '', ['class' => 'select2','tabindex'=>'3', 'id' => 'leadstatus_id']);?> 
                    </div>
                </div> 
            </div>
        </div> 
        <div class="col-sm-2">
            <div class="btn-group">
                <?php if(getUserData('user_type') != 5):?>
                <a class="btn btn-sm btn-primary ajax-load filterBtnMT" href="<?php echo site_url('#lead/leads/new_'); ?>" data-title="New Lead" data-html="form" data-selector="lead">
                    <i class="ace-icon glyphicon glyphicon-plus bigger-110"></i> New Lead
                </a>
                <?php endif;?>
            </div>
        </div>     
    </div>
    
	<div class="row">
		<div class="col-sm-12">
		    <div class="table-responsive">
	            <table id="ajax_data_table_leads" class="table table-striped table-hover dataTable ">
    	            <thead >
    	            	<tr class="">	
                            <th>Name</th>
                            <th>KM</th>
                            <th>Email</th>
                            <th>Phone</th>
                            <th>Website</th>
                            <th>Services</th>
                            <th width="120">Lead Status</th>
                            <th width="180"></th>
    	                </tr>
    	            </thead>
    	        </table> 
	        </div>
		</div>
	</div>
</div>

<script>
    $(document).ready(function() {
        var width = "30px";
        var fixCol = "true";

        if($(window).width() > 767){
            width = "180px";
            fixCol = "false";
        }

        //datatables
        var isMobile = window.matchMedia("only screen and (max-width: 760px)");
        var dataTable = $('#ajax_data_table_leads').DataTable({

            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "ordering": false, //Feature control DataTables' filtering.
            "order": [], //Initial no order.

            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": '<?php echo base_url('lead/leads/getListData')?>',
                "type": "POST"
            },

            //Set column definition initialisation properties.
            "columnDefs": [
                {
                    "targets": [ -1 ], //last column
                    "orderable": false, //set not orderable
                    "width": width
                },
                {
                    "targets": [ -2 ], //last column
                    "orderable": false, //set not orderable
                },
            ],
            scrollX:        fixCol,
            fixedColumns:   {
                leftColumns: 0,
                rightColumns: 1,  //last column fixed
                heightMatch: 'auto'
            } 
        });
        
        $("#ajax_data_table_leads_filter").css("display","none");  // hiding global search box
        $("#ajax_data_table_leads_info").css("display","none");  // hiding global table info
        $('.filter-value').on( 'keypress', function (e) {   // for select box
            if(e.which == 13){
            var v =$(this).val();  
            if(v.length >= 3){
                dataTable.columns(1).search(v).draw();
            } else {
                v = '';
                dataTable.columns(1).search(v).draw();
            }          
        }
        });
        $('#user_id').on( 'change', function (e) {   // for select box
            var v =$(this).val();  
            dataTable.columns(2).search(v).draw();
        }); 
        $('#leadstatus_id').on( 'change', function (e) {   // for select box
            var v =$(this).val();  
            dataTable.columns(3).search(v).draw();
        });
    });

    $(document).on('click', '.contenteditable', function(){
        var $this = $(this),
            $value = $this.html(),
            $status_id = $this.data('status'),
            $id = $this.data('id')
            $html = '';

        if($this.attr('class') === 'contenteditable'){
            $this.addClass('active');
            $this.attr('data-old_value', $value);
            $.getJSON( URL.getSiteAction('setup/leadstatus/getLeadStatus'), function( data ) {
                $html += '<form action="'+URL.getSiteAction('lead/leads/updateLead')+'" class="form"><div class="form-group"><input type="hidden" name="id" value="'+$id+'"></div><button class="btn btn-xs btn-block btn-success updateLead" style="margin:3px 0 0 4px">Update</button></form>';
                $this.html($html);
                $this.find('.form-group').append(createElement('select', 'leadstatus', data));
                $this.find('option').filter('[value='+$status_id+']').attr('selected', true);
            }); 
        }        
    });

    $(document).on('click', '.updateLead', function(event){
        event.preventDefault();
        var $this = $(this),
            $form = $this.parents('form'),
            $lstatus = $this.parents('.contenteditable').data('old_value'),
            $lstatus_text = $this.parents('form').find('.leadstatus option:selected').text();

        $.ajax({
            url: URL.getSiteAction('lead/leads/updateLead'),
            dataType: 'text json',
            type: 'POST',
            data: $form.serialize(),
            success: function( data ){
                if(data.alert === 'success'){
                    $this.parents('.contenteditable').html($lstatus_text);
                } else {
                    $this.parents('.contenteditable').html($lstatus);
                }
            },
            error: function( jqXhr, textStatus, errorThrown ){
                console.log( errorThrown );
            }
        }); 

    });
</script>