<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class="header">
                <h2><strong>Projects</strong> List </h2>
				<ul class="header-dropdown">
				    <li class="remove">
				        <a role="button" class=""><i class="zmdi zmdi-circle ash"></i></a>
				    </li>
				</ul>
            </div>
            <div class="body">
                    <div class="row clearfix">
                        <div class="col-sm-2">
                            <div class="form-group">
                                <label for="lead_id">Search by</label>                                   
                                <input placeholder="search by project name" class="form-control input-sm filter-value" type="search" value="">                                   
                            </div>
                        </div>
                        
                        <div class="col-sm-2">
                            <div class="form-group" >  
                                <label for="lead_id">Client</label>
                                <?php echo form_dropdown('lead_id' , getClient((getUserData('is_admin') == 0 ? ['leads.deleted_at' => NULL, 'where_in' => ['leads.km' => getUserData('supervisor_of')]] : []), true), '', ['class' => 'form-control select2', 'id' => 'lead_id']);
                                ?> 
                                                        
                            </div>
                        </div>
                        <div class="col-sm-2">
                            <div class="form-group" >  
                                <label for="user_id">KM</label>
                                <?php echo form_dropdown('user_id' , userList([]), '', ['class' => 'form-control select2', 'id' => 'user_id']);
                               ?>                                              
                            </div>
                        </div>
                        <div class="col-sm-2">
                            <div class="form-group">
                                <label for="projectStatus">Project Status</label>
                                <select id="projectStatus" name="status" class="form-control select2" style="width: 100%">
                                    <option value="" checked>SELECT STATUS</option>
                                    <option value="running" checked>Running</option>
                                    <option value="completed">Completed</option>
                                </select>
                            </div>
                        </div>
                    </div>
                <table id="table_work_projects" class=" table_work_projects table table-hover dataTable table_leads" width="100%">
                    <thead>
                        <tr class="btn-theme">
                            <th>Client</th>
                            <th>Workspace</th>
                            <th>Department</th>
                            <th>Services</th>
                            <th>Project</th>
                            <th>KM</th>
                            <th width="120">Created By</th>
                            <th width="120">Start date</th>
                            <th>Deadline</th>
                            <th>Status</th>
                            <th width="120"></th>
                        </tr>
                    </thead>
                    <tbody>  
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>




<script>
    $(document).ready(function() {
        var width = "30px";
        var fixCol = "true";

        if($(window).width() > 767){
            width = "100px";
            fixCol = "false";
        }


        setTimeout(function(){  
            //datatables
            dataTable = $('.table_work_projects').DataTable({
                "serverSide": true, //Feature control DataTables' server-side processing mode.
                "ordering": true, //Feature control DataTables' filtering.
                "order": [], //Initial no order.

                // Load data for the table's content from an Ajax source
                "ajax": {
                    "url": '<?php echo base_url('crm/workspace/projects/getListData')?>',
                    "type": "POST"
                },

                //Set column definition initialisation properties.
                "columnDefs": [
                    {
                        "targets": [ -1 ], //last column
                        "orderable": false, //set not orderable
                        "width": width
                    },
                    {
                        "targets": [ -2 ], //last column
                        "orderable": false, //set not orderable
                    },
                ],
                scrollX:        fixCol,
                fixedColumns:   {
                    leftColumns: 0,
                    rightColumns: 1,  //last column fixed
                    heightMatch: 'auto'
                }
            });       
            $(".dataTables_filter").css("display","none");  // hiding global search box     
            $(".dataTables_info").css("display","none");  // hiding global table info
        }, 1000);

        $('.filter-value').on( 'keypress', function (e) {   // for select box
            if(e.which == 13){
                var v =$(this).val();  
                if(v.length >= 3){
                    dataTable.columns(1).search(v).draw();
                } else {
                    v = '';
                    dataTable.columns(1).search(v).draw();
                }          
            }
        });
        $('#lead_id').on( 'change', function (e) {   // for select box
            var v =$(this).val();  
            dataTable.columns(2).search(v).draw();
        });     
        $('#user_id').on( 'change', function (e) {   // for select box
            var v =$(this).val();  
            dataTable.columns(3).search(v).draw();
        }); 
        $('#projectStatus').on( 'change', function (e) {   // for select box
            var v = $(this).val();  
            dataTable.columns(4).search(v).draw();
        });
    });
</script>

