<!-- Exportable Table -->
<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class="header">
                <h2><strong>Employee</strong> List </h2>
				<ul class="header-dropdown">
				    <li class="remove">
				        <a role="button" class=""><i class="zmdi zmdi-circle ash"></i></a>
				    </li>
				</ul>
            </div>
            <div class="body contact">
                <div class="row clearfix">
                    <div class="col-sm-3">
                        <div class="form-group">                                    
                            <input placeholder="search here" class="form-control input-sm filter-value" type="search" value="">                                   
                        </div>
                    </div>
                    <?php if(getUserData('is_admin') == 1):?>
                    <div class="col-sm-3">
                        <div class="form-group">   
                            <select id="empStatus" class="form-control select2">
                                <option value="running">Running</option>
                                <option value="old">Old</option>
                            </select>                                   
                        </div>
                    </div>
                    <?php endif;?>
                    <?php if(getUserData('is_admin') == 1 && getUserData('user_type') != 5):?>
                    <div class=" col-sm-6" >
                        <a class="btn  btn-theme float-right btn-round"  data-type="button" href="<?php echo site_url('hr/employee/new_') ?>" data-title="New Visit" data-html="form" data-selector="add">
                        <i class="zmdi zmdi-plus"></i>&nbsp;New Employee
                        </a>
                    </div>
                <?php endif; ?>
                </div>
                <input type="hidden" name="csrf_name">
                <table class="table table-hover m-b-0 c_list dataTable table_employee" width="100%">
                    <thead>
                        <tr class="btn-theme">
                            <th width="315">Name</th>
                            <th>Username</th>
                            <th>Email</th>
                            <th>Department</th>
                            <th>Status</th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        
                    </tbody>
                </table>
            </div>            
        </div>
    </div>
</div>
<!-- #END# Exportable Table --> 

<script type="text/javascript">

    $(document).ready(function() {

        let width = "30px";
        let fixCol = "true";
        let dataTable;

        if($(window).width() > 767){
            width = "120px";
            fixCol = "false";
        }

        setTimeout(function(){  
            //datatables
            dataTable = $('.table_employee').DataTable({
                "serverSide": true, //Feature control DataTables' server-side processing mode.
                "ordering": true, //Feature control DataTables' filtering.
                "order": [], //Initial no order.

                // Load data for the table's content from an Ajax source
                "ajax": {
                    "url": '<?php echo base_url('hr/employee/getListData')?>',
                    "dataType": "json",
                    "type": "POST",
                    "data": {csrf_name: Cookies.get('csrf_cookie')},
                    complete: function(response) {
                       var data  = JSON.parse(response.responseText).data;
                       console.log(data);                      
                       $(document).find('input[name=csrf_name]').val(Cookies.get('csrf_cookie'));
                    },
                },

                //Set column definition initialisation properties.
                "columnDefs": [
                    {
                        "targets": [ -1 ], //last column
                        "orderable": false, //set not orderable
                        "width": width
                    },
                    {
                        "targets": [ -2 ], //last column
                        "orderable": false, //set not orderable
                    },
                ],
                scrollX:        fixCol,
                fixedColumns:   {
                    leftColumns: 0,
                    rightColumns: 1,  //last column fixed
                    heightMatch: 'auto'
                }
            });       
            $(".dataTables_filter").css("display","none");  // hiding global search box     
            $(".dataTables_info").css("display","none");  // hiding global table info
        }, 1000);

        
        $('.filter-value').on( 'keypress', function (e) {   // for select box
            if(e.which == 13){
            let v =$(this).val();  
            if(v.length >= 3){
                dataTable.columns(0).search(v).draw();
            } else {
                v = '';
                dataTable.columns(0).search(v).draw();
            }          
        }
        });
        $('#empStatus').on( 'change', function (e) {   // for select box
            let v =$(this).val();  
            dataTable.columns(1).search(v).draw();
        });
    });

</script>