<?php echo datetimepickerAssets();?>

<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class="header">
                <h2><strong>Report</strong> Dailyreport </h2>
				<ul class="header-dropdown">
				    <li class="remove">
				        <a role="button" class=""><i class="zmdi zmdi-circle ash"></i></a>
				    </li>
				</ul>
            </div>
            <div class="body">
              <form id="dailyreportfilter" action="<?php echo site_url('hr/management/dailyreport/savereport') ?>" method="post">
                  <div class="row clearfix">
                      <div class="col-sm-2">
                          <div class="form-group" > 
                            <?php echo form_dropdown('id' , listdata('department'), '', ['class' => 'form-control select2',   'id' => 'department_id']);
                            ?>                                                               
                          </div>
                      </div>
                      <div class="col-sm-2">
                          <div class="form-group" > 
                            <?php echo form_dropdown('user_id' , userList([]), '', ['class' => 'form-control select2',  'id' => 'user_id']);
                            ?>                                                                    
                          </div>
                      </div>
                      <div class="col-sm-2" style="padding-top: 5px;" >
                         <div class="input-group">
                              <span class="input-group-addon">
                                  <i class="zmdi zmdi-calendar"></i>
                              </span>
                              <input type="text" class="form-control datemaxpicker" name="from_date" id="from_date" placeholder="Form date" value=""/>
                          </div>
                      </div>
                      <div class="col-sm-2" style="padding-top: 5px;" >
                         <div class="input-group">
                              <span class="input-group-addon">
                                  <i class="zmdi zmdi-calendar"></i>
                              </span>
                              <input type="text" class="form-control datemaxpicker" name="to_date" id="to_date" placeholder="To date" value=""/>
                          </div>
                      </div>
                      <div class=" col-sm-4">
                        <button type="submit" class="btn  btn-theme  btn-round filterBtnMT"><i class="zmdi zmdi-pdf" aria-hidden="true"></i> Download PDF</button>
                      </div>
                  </div>
                </form>
                <table id="table_dailyreport" class="table table-bordered table-striped table-hover dataTable table_dailyreport" width="100%">
                    <thead>
                        <tr class="btn-theme">
                             <th>Name</th>
                             <th>Department</th>
                             <th>Supervisor</th>
                             <th>Report Description</th>
                             <th>Date & Time</th>
                        </tr>
                    </thead>
                    <tbody>
                        
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>


<script>
  $(document).ready(function() {

        let width = "30px";
        let fixCol = "true";
        let dataTable;

        if($(window).width() > 767){
            width = "120px";
            fixCol = "false";
        }

        setTimeout(function(){  
            //datatables
            dataTable = $('.table_dailyreport').DataTable({
                "serverSide": true, //Feature control DataTables' server-side processing mode.
                "ordering": true, //Feature control DataTables' filtering.
                "order": [], //Initial no order.

                // Load data for the table's content from an Ajax source
                "ajax": {
                    "url": '<?php echo base_url('hr/management/dailyreport/report')?>',
                    "dataType": "json",
                    "type": "POST",
                    "data": {csrf_name: Cookies.get('csrf_cookie')},
                    complete: function(response) {
                       var data  = JSON.parse(response.responseText).data;
                       console.log(data);                      
                       $(document).find('input[name=csrf_name]').val(Cookies.get('csrf_cookie'));
                    },
                },
            });       
            $(".dataTables_filter").css("display","none");  // hiding global search box     
            $(".dataTables_info").css("display","none");  // hiding global table info
        }, 1000);

        
        $('#user_id').on( 'change', function (e) {   // for select box
            var v =$(this).val();  
            dataTable.columns(0).search(v).draw();
        });    

        $('#department_id').on( 'change', function (e) {   // for select box
            var v =$(this).val();  
            dataTable.columns(1).search(v).draw();
        });    

        $('#to_date').on( 'change', function () {   // for select box
          var v =$(this).val(),
            f =$(this).parents('#dailyreportfilter').find('#from_date').val();  
          if(f != '' && v != ''){
            dataTable.columns(2).search(f).draw();
            dataTable.columns(3).search(v).draw();
          }
          
        });

        datemaxpicker();
    });
</script>







