
<div class="row clearfix">
    <div class="col-lg-12">
        <div class="card">
            <div class="header">
                <h2><strong>Inventory</strong> List </h2>
				<ul class="header-dropdown">
				    <li class="remove">
				        <a role="button" class=""><i class="zmdi zmdi-circle ash"></i></a>
				    </li>
				</ul>
            </div>
            <div class="body">
                <div class="row clearfix">
                    <div class="col-sm-3">
                        <div class="form-group" style="margin-top: 6px;">                                    
                            <input placeholder="search" class="form-control input-sm filter-value" type="search" value="">
                        </div>
                    </div>
                    <div class="col-sm-9" >
                          <a class="btn  btn-theme float-right btn-round"  data-type="button" href="<?php echo site_url('inventory/inventory/new_') ?>" data-title="New Inventory" data-html="form" data-selector="add">
                        <i class="zmdi zmdi-plus"></i>&nbsp;New Inventory
                        </a>
                    </div>
                </div>
                
                <table id="table_inventory" class="table table-hover dataTable table_inventory" width="100%">
                    <thead>
                        <tr class="btn-theme">
                            <th>Warehouse</th>
                            <th>Product</th>
                            <th>Product brand</th>
                            <th>Model no</th>
                            <th>Description</th>
                            <th>Purchase Date</th>
                            <th>Invoice no</th>
                            <th>Status</th>
                            <th width="120"></th>
                        </tr>
                    </thead>
                    <tbody>
                        
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>


<script>
   $(document).ready(function() {

        let width = "30px";
        let fixCol = "true";
        let dataTable;

        if($(window).width() > 767){
            width = "120px";
            fixCol = "false";
        }

        setTimeout(function(){  
            //datatables
            dataTable = $('.table_inventory').DataTable({
                "serverSide": true, //Feature control DataTables' server-side processing mode.
                "ordering": true, //Feature control DataTables' filtering.
                "order": [], //Initial no order.

                // Load data for the table's content from an Ajax source
                "ajax": {
                    "url": '<?php echo base_url('inventory/inventory/getListData')?>',
                    "type": "POST"
                },

                //Set column definition initialisation properties.
                "columnDefs": [
                    {
                        "targets": [ -1 ], //last column
                        "orderable": false, //set not orderable
                        "width": width
                    },
                    {
                        "targets": [ -2 ], //last column
                        "orderable": false, //set not orderable
                    },
                ],
                scrollX:        fixCol,
                fixedColumns:   {
                    leftColumns: 0,
                    rightColumns: 1,  //last column fixed
                    heightMatch: 'auto'
                }
            });       
            $(".dataTables_filter").css("display","none");  // hiding global search box     
            $(".dataTables_info").css("display","none");  // hiding global table info
        }, 1000);
        $('.filter-value').on( 'keypress', function (e) {   // for select box
            if(e.which == 13){
            var i =$(this).attr('data-column');  
            var v =$(this).val();  
            if(v.length >= 3){
                dataTable.columns(i).search(v).draw();
            } else {
                v = '';
                dataTable.columns(i).search(v).draw();
            }          
        }
        });
    });
</script>