/*----------sslect2-----------*/

$('.select2').select2();
/*----------sslect2-----------*/




let attachmentUploadBtn = '<button class="btn btn-block btn-theme uploadFile" data-type="attachment">\
        <i class="zmdi zmdi-upload"></i> Upload Attachment\
    </button>',
    imageUploadBtn = '<button class="btn btn-block btn-theme uploadFile" data-type="image">\
        <i class="zmdi zmdi-upload"></i> Upload Image\
    </button>'


/*global $ */
$(document).ready(function() {
  "use strict";
  $('.menu > ul > li:has( > ul)').addClass('menu-dropdown-icon');
  //Checks if li has sub (ul) and adds class for toggle icon - just an UI

  $('.menu > ul > li > ul:not(:has(ul))').addClass('normal-sub');

  $(".menu > ul > li").hover(function(e) {
    if ($(window).width() > 943) {
      $(this).children("ul").stop(true, false).fadeToggle(150);
      e.preventDefault();
    }
  });
  //If width is more than 943px dropdowns are displayed on hover    
  $(".menu > ul > li").click(function() {
    if ($(window).width() <= 943) {
      $(this).children("ul").fadeToggle(150);
    }
  });
  //If width is less or equal to 943px dropdowns are displayed on click (thanks Aman Jain from stackoverflow)

  $(".h-bars").click(function(e) {
    $(".menu > ul").toggleClass('show-on-mobile');
    e.preventDefault();
  });
  //when clicked on mobile-menu, normal menu is shown as a list, classic rwd menu story (thanks mwl from stackoverflow)

  initiateFileUpload();
});    

// go back
$(document).on('click', '.backLink', function(event){
    event.preventDefault();
    history.back(1);
});

$(document).on('click', '.saveBtn', function(event){
	event.preventDefault();

	let $this = $(this),
		$form = $this.parents('form');
		$topmessage = $this.parents('.topmessage'),
		$data = $this.parents('form').serializeArray();

	let valid = checkRequired($form);	
	console.log(valid);
	if(valid){
		$data.push({ name: $this.attr('name'), value: $this.attr('value') }, { name: CSRF.csrfTokenName(), value: Cookies.get('csrf_cookie') });

		$form.find('div.alert').remove();	

		$.each($form.find('.form-group'), function(){
			$(this).removeClass('has-danger');
		});

		$.ajax({
	        url: $this.parents('form').attr('action'),
	        type: "POST",
	        data: $data,
	        dataType: "json",
	        success: function(data, textStatus, jqXHR) {
				if(data.type === 'validation_error'){
					$.each(data.message, function(index, value){
						$.notify(value, "error");
						$.each($form.find('.'+index), function(){
							if($(this).val() === ''){
								$(this).addClass('form-control-danger').parents('.form-group').addClass('has-danger');		
							} 
						});					
					});
				} else if(data.type === 'login_success'){
					$.notify(data.message, data.class);

					if(data.url){
						setTimeout(function(){ window.location = data.url; }, 1000);	
					}				
				} else if(data.type === 'not_success') {

					$.notify(data.message, data.class);

				} else if(data.type === 'save_success') {
					
					$.notify(data.message, data.class);

					if(data.url){
						setTimeout(function(){ window.location = data.url; }, 800);	
					} else {
						$form.parents('.modal').modal('hide');
					}				
				}

				else if(data.type === 'success_top'){
					$.notify(data.message, data.class);

					if(data.url){
						setTimeout(function(){ window.location = data.url; }, 1500);	
					}else{
						setTimeout(function(){window.location.reload();}, 1000);
					}				
				}
				else if(data.type === 'validation_error_top'){
					$("html, body").animate({ scrollTop: 0 }, "fast");
					$.notify(data.message, data.class);

					if(data.url){
						setTimeout(function(){ window.location = data.url; }, 1500);	
					}				
				} else {
					$('#modal').modal('hide');
				}
	        },
	        error: function (xhr, ajaxOptions, thrownError){
		       	console.log(thrownError);
		    }
	    });	
	}
});

/** POP UP HTML CONTENT / FORM
 * CUSTOM ATTRIBUTE required data-href : url to be loaded
 * CUSTOM ATTRIBUTE required data-title : title will show as pop up title
 * CUSTOM ATTRIBUTE optional data-html : either pop up body will be a new form or other html
 * CUSTOM ATTRIBUTE optional data-selector : html element id
 **/
 function reload() {
		location.reload();
	};

 $('#exampleModal').on('show.bs.modal', function (event) {
  	var button = $(event.relatedTarget) // Button that triggered the modal
  	var recipient = button.data('whatever') // Extract info from data-* attributes
  	// If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
  	// Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
  	var modal = $(this)
  	var url	= button.attr('data-href')
	var title = button.attr('data-title')
	modal.find('.modal-body').remove()
  	modal.find('.modal-title').text(title)
  	$.get( url, function( data ) {
  		modal.find('.modal-content').append(data);
  	})
  	
});

$(document).on('click', '.delete-confirm', function(){
	let $this = $(this),
		url = $this.attr('data-href'),
		id = $this.attr('data-id');

	swal({
        title: "Are you sure?",
        text: "You will not be able to recover this imaginary file!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Yes, delete it!",
        closeOnConfirm: false
    }, function () {
    	$.ajax({
            url: url,
            type: "POST",
            data: {id : id},
            dataType: "json",
            success: function(data, textStatus, jqXHR) {
            	$this.parents('tr').remove();
            	swal("Deleted!", "Your imaginary file has been deleted.", "success");
            },
            error: function (xhr, ajaxOptions, thrownError){
            	swal("Warning!", thrownError, "warning");
		    }
        });        
    });
});


/// CHANGE STATUS
$(document).on('click', '.status', function() {
	var $this = $(this),
		url = $this.attr('data-href'),
		id = $this.attr('data-id'),
		admin = $this.attr('data-admin'),
		usertype = $this.attr('data-usertype'),
		$data;

	if ($("#status" + id).val() == '1') {
        var status = 0;
    } else {
        var status = 1;
    }

	$this.next('span.lbl').css('text-decoration', 'line-through');
	//$data = CSRF.csrfTokenName()+'='+Cookies.get('csrf_cookie')+'&id='+id+'&status='+status;
	$data = 'id='+id+'&status='+status;

    if(usertype != 5){
	    if(admin == 1 || $("#status" + id).val() == 1 && $("#status" + id).val() != 0){
	    	swal({
	        title: "Are you sure to change status?",
	        text: "This would not be undone.!",
	        type: "warning",
	        showCancelButton: true,
	        confirmButtonColor: "#26737f",
	        confirmButtonText: "Yes! Change Status",
	        closeOnConfirm: false
	 		   },function() {
						$.ajax({
				            url: url,
				            type: "POST",
				            data: $data,
				            dataType: "json",
				            success: function(data, textStatus, jqXHR) {
				            	if(status === 1){
				            		$this.prop('checked', true);
				            	} else {
				            		$this.prop('checked', false);
				            	}		
				            	$this.val(status);		            	
				            	swal({type: "success",});
				            	swal("Status Changed!", "", "success");	
				            },
				            error: function (xhr, ajaxOptions, thrownError){
				            	swal("Warning!", thrownError, "warning");
						    }
				        });
				});
	    }
	}
});


	/* multiple button */
	var addFormGroup = function (event) {
		event.preventDefault();

		var $formGroup = $(this).closest('.form-group');
		var $multipleFormGroup = $formGroup.closest('.multiple-form-group');
		var $formGroupClone = $formGroup.clone();

		$(this)
			.removeClass('btn-theme')
		  	.toggleClass('btn-default btn-add btn-danger btn-remove')
		  	.html('<i class="zmdi zmdi-close"></i>');

		$formGroupClone.find('input').val('');
		$formGroupClone.insertAfter($formGroup);

		var $lastFormGroupLast = $multipleFormGroup.find('.form-group:last');

		if ($multipleFormGroup.data('max') <= countFormGroup($multipleFormGroup)) {
		  	$lastFormGroupLast.find('.btn-add').attr('disabled', true);
		}
  	};

  	var removeFormGroup = function (event) {
      	event.preventDefault();

		var $formGroup = $(this).closest('.form-group');
		var $multipleFormGroup = $formGroup.closest('.multiple-form-group');

		var $lastFormGroupLast = $multipleFormGroup.find('.form-group:last');
		if ($multipleFormGroup.data('max') >= countFormGroup($multipleFormGroup)) {
		  	$lastFormGroupLast.find('.btn-add').attr('disabled', false);
		}

		$formGroup.remove();
  	};

  	var countFormGroup = function ($form) {
      	return $form.find('.form-group').length;
  	};

	$(document).on('click', '.btn-add', addFormGroup);
	$(document).on('click', '.btn-remove', removeFormGroup);

	/* Add Multiple Element */
	var addMultiRow = function (event) {
		event.preventDefault();

		let $this = $(this),
			$formGroup = $this.parents('.multiple'),
			$lastFormGroup = $this.parents('.multiple:last'),
			$element = $('#'+$formGroup.data('ele_name')).find('.multiple').clone(),
			count = 0,
			last_order_invoice_div;

		$this.parents('.parent_multiple').find('.multiple').each(function () {
			count++;
            last_order_invoice_div = $(this);
        });

		if($this.parents('.parent_multiple').is( "div" )){
			last_order_invoice_div.after('<div class="row multiple">' + $element.html() + '</div>');
		} else {
			last_order_invoice_div.after('<tr class="multiple">' + $element.html() + '</tr>');		
		}
		
		$this.parents('.parent_multiple').find('.multiple').each(function () {
            $(this).find('.bootstrap-select').replaceWith(function() { return $('select', this).addClass('select2'); })
            $(this).find('.select2').select2();
            datetimepicker();
            datemaxpicker();
            dateminpicker();
            timepicker();
            initiateFileUpload();
        });

        if($elementstatus != 'single'){
			let items = $this.parents('.parent_multiple').find('.multiple'),
				last = items[items.length-1];
			last.scrollIntoView({ block: 'end',  behavior: 'smooth' });
		}
    };

    var removeMultiRow = function (event) {
		event.preventDefault();

		var $this = $(this);

		var $formGroup = $this.closest('.multiple');
		var $multipleFormGroup = $formGroup.closest('.box');

		var $lastFormGroupLast = $multipleFormGroup.find('.multiple:last');

		$formGroup.remove();
    };

    $(document).on('click', '.add-row', addMultiRow);
    $(document).on('click', '.remove-row', removeMultiRow);

    // for number only input
    $(document).on('keypress', '.numberOnly', function (e) {
	    return (/^[0-9]*\.?[0-9]*$/).test($(this).val()+e.key);
	});



/*--------------Lead Approved Start----------------*/
$(document).on('click', '.approveLead', function () {
	let $this = $(this),
		url = $this.attr('data-href'),
		id = $this.attr('data-id');

    swal({
        title: "Are you sure?",
        text: "You want to Approve this Lead?",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#18ce0f",
        confirmButtonText: "Yes, Approve",
        closeOnConfirm: false
    }, function () {
    	$.ajax({
            url: url,
            type: "POST",
            data: {id : id},
            dataType: "json",
            success: function(data, textStatus, jqXHR) {
            	$(".approveLead").attr('hidden', true);

            	swal("Approved!", "Lead approved Successfully.", "success");

            },
            error: function (xhr, ajaxOptions, thrownError){
            	swal("Warning!", thrownError, "warning");
		    }
        });        
    });
});
/*--------------Lead Approved End----------------*/



/*-----------Lead to Client Convert Start-----------*/
$(document).on('click', '.make-client', function () {
	let $this = $(this),
		url = $this.attr('data-href'),
		id = $this.attr('data-id');

	var status = 1;

	$this.next('span.lbl').css('text-decoration', 'line-through');
	$data = CSRF.csrfTokenName()+'='+Cookies.get('csrf_cookie')+'&id='+id+'&status='+status;
	console.log($data);

    swal({
        title: "Are you sure?",
        text: "You want to Convert Client this Lead?",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#18ce0f",
        confirmButtonText: "Yes, Approve",
        closeOnConfirm: false
    }, function () {
    	$.ajax({
            url: url,
            type: "POST",
            data: $data,
            dataType: "json",
            success: function(data, textStatus, jqXHR) {
            	$this.parents('tr').remove();
            	swal("Convert!", "Lead Converted Successfully.", "success");
            },
            error: function (xhr, ajaxOptions, thrownError){
            	swal("Warning!", thrownError, "warning");
		    }
        });        
    });
});
/*-----------Lead to Client Convert End-----------*/

// change todo status on click

$(document).on('click', '.todostatus', function () {
	let $this = $(this),
		url = $this.attr('data-href'),
		id = $this.attr('data-id'),
		admin = $this.attr('data-admin'),
		usertype = $this.attr('data-usertype'),
        status = '0',
	   
		$data = CSRF.csrfTokenName()+'='+Cookies.get('csrf_cookie')+'&status='+status+'&id='+id;
		swal({
	        title: "Are you sure?",
	        text: "You want to Complete Todo?",
	        type: "warning",
	        showCancelButton: true,
	        confirmButtonColor: "#18ce0f",
	        confirmButtonText: "Yes, Complete",
	        closeOnConfirm: false
	    }, function () {
		    $.ajax({
		        url: url,
		        type: "POST",
		        data: $data,
		        dataType: "json",
		        success: function(data, textStatus, jqXHR) {
					if(data.type === 'save_success'){
						swal("Convert!", "Successfully completed.", "success");
						if(data.url){
							setTimeout(function(){ window.location = data.url; }, 1000);	
						}else{
							setTimeout(function(){window.location.reload();}, 1000);

						}				
					}
		        },

 		});

   	});    
});

var datetimepicker = function(){
	$('.datetimepicker').bootstrapMaterialDatePicker({
        format: 'YYYY-MM-DD',
        clearButton: true,
        weekStart: 1,
        time: false
    });
}

var datemaxpicker = function(){
	$('.datemaxpicker').bootstrapMaterialDatePicker({
        format: 'YYYY-MM-DD',
        maxDate : new Date(),
        clearButton: true,
        weekStart: 1,
        time: false
    });
}

var dateminpicker = function(){
	$('.dateminpicker').bootstrapMaterialDatePicker({
        format: 'YYYY-MM-DD',
        minDate : new Date(),
        clearButton: true,
        weekStart: 1,
        time: false
    });
}

var timepicker = function(){
	$('.timepicker').bootstrapMaterialDatePicker({
		format: 'hh:mm A',
        clearButton: true,
        weekStart: 1,
        date: false,
        time: true,
        hourFormat: 12
    });
}

// change theme

$(document).on('click', '.change-theme', function () {
	let $this = $(this),
		url = $this.attr('data-href'),
		theme = $this.attr('data-theme'),
		$data = CSRF.csrfTokenName()+'='+Cookies.get('csrf_cookie')+'&theme='+theme;

    $.ajax({
        url: url,
        type: "POST",
        data: $data,
        dataType: "json",
    });        
});

// file upload
// $(document).on('click', '.uploadFile', function(e){
// 	e.preventDefault();

// 	let $type = $(this).data('type'),
// 		$modal = $('#fileUploadModal');

// 	$.get( URL.getSiteAction('fileUpload/index/'+$type), function( data ) {
// 		$modal.find('form').remove();
// 		$modal.find('.modal-header').after(data);
// 	});

// 	$modal.modal('toggle');
// });

// $(document).on('click', '.cropped_image', function(event){
// 	event.preventDefault();

// 	$image_crop.croppie('result', {
// 		type: 'canvas',
// 		size: 'viewport'
// 	}).then(function (response) {

// 		let $data = CSRF.csrfTokenName()+'='+Cookies.get('csrf_cookie')+'&image='+response;

// 		$.ajax({
// 			url: URL.getSiteAction('fileUpload/saveImage'),
// 			type: "POST",
// 			dataType: "json",
// 			data: $data,
// 			success: function (data) {
// 				if(data.type === 'success'){
// 					html = '<div class="imgEditFrame" style="background-image: url(' + URL.getSiteAction('uploads/'+data.fileName) + ');" data-name="" data-table="" data-column="" data-type="image">\
//                         <button class="btn btn-primary btn-sm removeImage"><i class="zmdi zmdi-delete"></i> remove</button>\
//                     </div>';

// 					$('body').find('#crop_preview').find('.uploadFile').remove();
// 					$('body').find('#crop_preview').append(html);
// 					$('body').find('#crop_preview').find('.imageInput').val(data.fileName);
// 					$('#fileUploadModal').modal('toggle');
// 				}
// 			}
// 		});
// 	});

// });

// $(document).on('click', '.removeImage', function(e){
// 	e.preventDefault();

// 	let $this = $(this),
// 		$type = $(this).data('type'),
// 		$form = $(this).parents('form'),
// 		$imgWrap = $this.parents('div.imgEditFrame'),
// 		$fileName = $imgWrap.data('name'),
// 		$table =  $imgWrap.data('table'),
// 		$column =  $imgWrap.data('column'),
// 		$data = CSRF.csrfTokenName()+'='+Cookies.get('csrf_cookie')+'&fileName='+$fileName+'&table='+$table+'&column='+$column,
// 		$html = '';

// 	if($type === 'image'){
// 		$html = imageUploadBtn;
// 	} else {
// 		$html = attachmentUploadBtn;
// 	}	

// 	$.ajax({
// 		url: URL.getSiteAction('fileUpload/removefile'),
// 		type: "POST",
// 		dataType: "json",
// 		data: $data,
// 		success: function (data) {
// 			if(data.type === 'success'){
// 				$imgWrap.remove();
// 				$form.find('.imageInput').val('');
// 				$form.find('.attachmentId').val('');
// 				$form.find('#crop_preview').append(imageUploadBtn);
// 				//$.notify(data.message, data.type);
// 			} else {
// 				//$.notify('Something wrong!', 'error');
// 			}
// 		}
// 	});	
// });

// function uploadAttachment() {
// 	$('#upload_form').on('submit', function(e){
// 		e.preventDefault();
// 		if($('#image_file').val() == '')
// 		{
// 			alert("Please Select the File");
// 		}
// 		else
// 		{
// 			$.ajax({
// 				url: URL.getSiteAction('fileUpload/saveAttachment'), 
// 				//base_url() = http://localhost/tutorial/codeigniter
// 				method:"POST",
// 				data:new FormData(this),
// 				contentType: false,
// 				cache: false,
// 				processData:false,
// 				dataType: "json",
// 				success:function(data)
// 				{	
// 					if(data.type === 'success'){
// 						if(data.fileExt === 'pdf'){
// 							html = '<div class="imgEditFrame" style="background-image: url(' + URL.getSiteAction('assets/images/blank-pdf.png') + ');" data-name="" data-table="" data-column="" data-type="attachment">\
// 		                        <button class="btn btn-primary btn-sm removeImage"><i class="zmdi zmdi-delete"></i> remove</button>\
// 		                    </div>';
// 						} else {
// 							html = '<div class="imgEditFrame" style="background-image: url(' + URL.getSiteAction('uploads/'+data.fileName) + ');" data-name="" data-table="" data-column="" data-type="attachment">\
// 		                        <button class="btn btn-primary btn-sm removeImage"><i class="zmdi zmdi-delete"></i> remove</button>\
// 		                    </div>';
// 						}
					

// 						$('body').find('#crop_preview').find('.uploadFile').remove();
// 						$('body').find('#crop_preview').append(html);
// 						$('body').find('#crop_preview').find('.imageInput').val(data.fileName);
// 						$('#fileUploadModal').modal('toggle');
// 					} 

// 					$.notify(data.message, data.type);
					
// 				}
// 			});
// 		}
// 	});
// }

/*FILE UPLOAD*/
    /// FILE REMOVE
	$(document).on('click', '.attachmentbody .remove', function(){

        var el = $(this).parents('.attachmentbody').html('<div class="progress"><div class="progress-bar progress-bar-success progress-bar-striped active" style="width: 100%"></div></div>');
        $.ajax({
            url: URL.getSiteAction('upload/remove/'+el.attr("data-type")),
            type: "POST",
            dataType: "html",
            data: {attachment:$(el.attr("data-target")).val()},
            complete: function () {
                el.parent('.row').find('.attachmentFile').val("");
                el.html('<img class="upload" src="'+URL.getSiteAction('assets/images/no_image.png')+'" />');

                reInitiateFileUpload(el);
            }
        });
    });

	function initiateFileUpload() {
        $.each($(document).find('.attachmentbody'), function(i, el) {
            el = $(el);

            var target = el.attr('data-target');
            var currentFileExt = $(target).val().split('.')[1];
            
            if( currentFileExt == 'txt' || currentFileExt == 'doc' || currentFileExt == 'docx' || currentFileExt == 'xls' || currentFileExt == 'xlsx' || currentFileExt == 'pdf' || currentFileExt == 'zip' || currentFileExt == 'rar' ) {
            	if( currentFileExt == 'txt' ) {
	                currentHtml = '<i class="fa fa-file-text-o bigger-300 text-center"></i>';
	            } else if( currentFileExt == 'doc' || currentFileExt == 'docx' ) {
	                currentHtml = '<i class="fa fa-file-word-o bigger-300 text-center"></i>';
	            } else if( currentFileExt == 'xls' || currentFileExt == 'xlsx' ) {
	                currentHtml = '<i class="fa fa-file-excel-o bigger-300 text-center"></i>';
	            } else if( currentFileExt == 'pdf' ) {
	                currentHtml = '<i class="fa fa-file-pdf-o bigger-300 text-center"></i>';
	            } else if( currentFileExt == 'zip' || currentFileExt == 'rar' ) {
	                currentHtml = '<i class="fa fa-file-archive-o bigger-300 text-center"></i>';
	            }

            	el.html('');
                var list = $('<ul></ul>').appendTo(el).addClass('success');

                $('<li></li>').appendTo(list).html(currentHtml);                                         
                $('<li class="remove"></li>').appendTo(list).html('<i title="Remove" class=" red-color zmdi zmdi-close hand"></i>');            	

            }

            if(el.find('.upload').length > 0) {
                new AjaxUpload(el.find('.upload'), {
                    action: URL.getSiteAction('upload/index/'+el.attr("data-type")),
                    name: 'attachment',
                    responseType: 'json',
                    onSubmit: function(file, ext){

                        el.html('<div class="progress"><div class="progress-bar progress-bar-success progress-bar-striped active" style="width: 100%"></div></div>');
                    },
                    onComplete: function(file, response) {                    
                        //Add uploaded file to list
                        if(response.status === "success") {
                        	el.parent('.row').find('.attachmentFile').val(response.fileName);
                            el.html('');
                            var list = $('<ul></ul>').appendTo(el).addClass('success');

                            var fileHtml = '';
                            if( response.fileExt == '.gif' || response.fileExt == '.jpg' || response.fileExt == '.jpeg' || response.fileExt == '.png' ) {
                                fileHtml = '<img src="'+URL.getSiteAction(response.fileLocation)+'" alt="" />';
                            } else if( response.fileExt == '.txt' ) {
                                fileHtml = '<i class="fa fa-file-text-o bigger-300 text-center"></i>';
                            } else if( response.fileExt == '.doc' || response.fileExt == '.docx' ) {
                                fileHtml = '<i class="fa fa-file-word-o bigger-300 text-center"></i>';
                            } else if( response.fileExt == '.xls' || response.fileExt == '.xlsx' ) {
                                fileHtml = '<i class="fa fa-file-excel-o bigger-300 text-center"></i>';
                            } else if( response.fileExt == '.pdf' ) {
                                fileHtml = '<i class="fa fa-file-pdf-o bigger-300 text-center"></i>';
                            } else if( response.fileExt == '.zip' || response.fileExt == '.rar' ) {
                                fileHtml = '<i class="fa fa-file-archive-o bigger-300 text-center"></i>';
                            }

                            $('<li></li>').appendTo(list).html(fileHtml);                                         
                            $('<li class="remove"></li>').appendTo(list).html('<i title="Remove" class=" red-color zmdi zmdi-close hand"></i>');
                        } else {
                            alert(response.message);
                            el.html('<img class="upload" src="'+URL.getSiteAction('assets/images/no_image.png')+'" />');
                            reInitiateFileUpload(el);
                        }
                    }
                });
            }
        });
	}


	function reInitiateFileUpload(el) {
        new AjaxUpload(el.find('.upload'), {
            action: URL.getSiteAction('upload/index/'+el.attr("data-type")),
            name: 'attachment',
            responseType: 'json',
            onSubmit: function(file, ext){
                
                el.html('<div class="progress"><div class="progress-bar progress-bar-success active" style="width: 100%"></div></div>');
            },
            onComplete: function(file, response){
                //Add uploaded file to list
                if(response.status === "success"){
                    el.parent('.row').find('.attachmentFile').val(response.fileName);
                    el.html('');
                    var list = $('<ul></ul>').appendTo(el).addClass('success');
                    
                    var fileHtml = '';
                    if( response.fileExt == '.gif' || response.fileExt == '.jpg' || response.fileExt == '.jpeg' || response.fileExt == '.png' ) {
                        fileHtml = '<img src="'+URL.getSiteAction(response.fileLocation)+'" alt="" />';
                    } else if( response.fileExt == '.txt' ) {
                        fileHtml = '<i class="fa fa-file-text-o bigger-300 text-center"></i>';
                    } else if( response.fileExt == '.doc' || response.fileExt == '.docx' ) {
                        fileHtml = '<i class="fa fa-file-word-o bigger-300 text-center"></i>';
                    } else if( response.fileExt == '.xls' || response.fileExt == '.xlsx' ) {
                        fileHtml = '<i class="fa fa-file-excel-o bigger-300 text-center"></i>';
                    } else if( response.fileExt == '.pdf' ) {
                        fileHtml = '<i class="fa fa-file-pdf-o bigger-300 text-center"></i>';
                    } else if( response.fileExt == '.zip' || response.fileExt == '.rar' ) {
                        fileHtml = '<i class="fa fa-file-archive-o bigger-300 text-center"></i>';
                    }

                    $('<li></li>').appendTo(list).html(fileHtml);                        
                    $('<li class="remove"></li>').appendTo(list).html('<i title="Remove" class="red-color zmdi zmdi-close hand"></i>');
                } else {
                    alert(response.message);
                    el.html('<img class="upload" src="'+URL.getSiteAction('assets/images/no_image.png')+'" />');
                    reInitiateFileUpload(el);
                }
            }
        });
	}
	/*FILE UPLOAD*/



	$(document).on('click', '#addCriteria', function(e){
	    e.preventDefault();            
	    let $this = $(this),
	        $appendPlace = $this.parents('table').find('tbody'),
	        $tableRow = $('<tr></tr>'),
	        $tableData = $('<td></td>').appendTo($tableRow),
	        $formGroup = $('<div></div>').attr({class: 'input-group'}).appendTo($tableData);

	        createElement('input', 'criteria', '', true).appendTo($formGroup);
	        $('<span class="input-group-btn"><button type="button" class="btn btn-danger no-margin btn-radius btn-remove"><i class="zmdi zmdi-delete"></i></button></span>').appendTo($formGroup);

	        $tableRow.appendTo($appendPlace);
	});

	function createElement(type, name, json = '', multiple = false){
		var input,
			inputName;

		if(multiple == true){
			inputName = name+'[]';
		} else {
			inputName = name;
		}

		if(type === 'select'){
			input = $("<select></select>").attr({name: inputName, class: "select2 "+name, style: 'width:100%'});
			$.each(json,function(index,data){
				input.append($("<option></option>").attr("value", data.id).text(data.name));
			});    
		} else {
			input = $('<input/>').attr({ type: 'text', class: 'form-control '+name, name: inputName, value: json, style: 'width:100%', placeholder: name})
		}

		return input;
	}

	$(document).on('click', '.btn-remove', function(e){
	    e.preventDefault();
	    let $this = $(this);
	    $this.parents('tr').remove();
	});

	$(document).on('click', '.divestInventory', function(){
		let $this = $(this),
			$id = $this.parents('tr').find('.id').val();

		swal({
	        title: "Are you sure to divest?",
	        text: "This would not be undone.",
	        type: "warning",
	        showCancelButton: true,
	        confirmButtonColor: "#F00",
	        confirmButtonText: "Yes, divest it!",
	        closeOnConfirm: false
	    }, function () {
	    	$.ajax({
	            url: URL.getSiteAction('inventory/inventory/divestInventory'),
	            type: "POST",
	            data: {id : $id},
	            dataType: "json",
	            success: function(data, textStatus, jqXHR) {
	            	$this.parents('tr').remove();
	            	swal("Deleted!", "Your imaginary file has been deleted.", "success");
	            },
	            error: function (xhr, ajaxOptions, thrownError){
	            	swal("Warning!", thrownError, "warning");
			    }
	        });        
	    });
	});



	$(document).on('click', '.refuseInventory', function(){
		let $this = $(this),
			$id = $this.parents('tr').find('.id').val();

		swal({
	        title: "Are you sure to refuse?",
	        text: "This would not be undone.",
	        type: "warning",
	        showCancelButton: true,
	        confirmButtonColor: "#F00",
	        confirmButtonText: "Yes, refuse it!",
	        closeOnConfirm: false
	    }, function () {
	    	$.ajax({
	            url: URL.getSiteAction('inventory/inventory/refuseInventory'),
	            type: "POST",
	            data: {id : $id},
	            dataType: "json",
	            success: function(data, textStatus, jqXHR) {
	            	$this.parents('tr').remove();
	            	swal("Deleted!", "Your imaginary file has been deleted.", "success");
	            },
	            error: function (xhr, ajaxOptions, thrownError){
	            	swal("Warning!", thrownError, "warning");
			    }
	        });        
	    });
	});

	function checkRequired(parm){
		let count = 0;
		parm.find('.required').each(function(index){
			if($(this).val() === ''){
				count += 1;
				$.notify($(this).attr('placeholder'), "error");
				$(this).addClass('form-control-danger').parents('.form-group').addClass('has-danger');		
			}			
		});

		if(count > 0){
			return false;
		} else {
			return true;
		}
	}
	